#!
# (c) Gnther Alka, 2019
# 18.apr: supports Solaris

###############
sub my_action {
###############

 # shrink pool/ remove vdev
 #override with private functions?
 ##################################
 eval { &mylib_menue_pools_shrink };                   # create this function in a private mylib.pl to replace this action

 my ($var1, $ant, $free, $type, $d, $r, $v, $ok,$sol);

 #load lib
   &load_lib('get-disk.pl');   # get required values

# header
    print "<script language='javascript'>document.getElementById('hl').innerHTML='Shrink pool/ remove vdev on $in{'member'}'</script>\n";
    print "<b>Remove a vdev</b><br><br>";

# 1. edited
#&print_hash(%in);
if (($in{'answered'}) && ($in{'submit_ok'} ne "")) { &my_remove; }     # form -> create

# datapools
if ($zfs{'allpools'} eq "") {
  print "There is no datapool available.<br>Please create a Pool!";
  return;
}

# 2. get form
#########################
# form begin


&ask('begin');

## select pool
if ($in{'autoselect_pool'} eq "") {
  $t=$zfs{'datapools'}; $t=~s/\t.*//;    # first datapool
  $in{'autoselect_pool'}=$t;
}

&ask('autoselect_pool','Datapool',$zfs{'datapools'},$in{'autoselect_pool'});

# feature enabled
## checkboxes vdevs
   $v="";
   $t="all_vdevs_$in{'autoselect_pool'}";
   $t=$disk{$t};   # vdevs

   if ($sys{'auto_os_type'} ne "sol_s") { # illumos currenty without raid-z
     if ($t =~/raidz\d/) {
        print "<br><font style='color:red'>You cannot remove a vdev from pool $in{'autoselect_pool'} that contains a raidz[1-3]</font>";
        &my_pools; &log_end; exit;
     }
   }

   @t=();
   @t=split(/\t/,$t);
   foreach $t (@t) {
     if ($sys{'auto_os_type'} ne "sol_s") {
        if ($t=~/raidz\d/i) { next; }            # currenty no raidz [1-3]
     }
     $v.="$t,";
   }
   $v=~s/,+$//;

   $r=~s/.*\@//;
   print "Feature status: $r";

   if ($v eq "") {
      print "<br><font style='color:red'>There are no removeable vdevs available for this pool $in{'autoselect_pool'}</font>";
      &my_pools;&log_end; exit;
   }
   &ask('checkbox_vdev','Remove vdev (Solaris: all, Illumos only mirror and basic)',$v);

&ask('end');

# info
print <<EoF;
<pre>

<b>Solaris</b>
  - No restrictions beside Pool v.44

<b>Illumos/Open-ZFS</b>
  - The device_removal feature must be enabled for a pool.
  - A pool must not contain a raidz[1-3] but only basic, mirror, slog or l2arc vdevs .
    Slog, l2arc and parts of a mirror can be removed in the Disks > Remove menu.
  - You cannot currently add a raidz[1-1] vdev to a pool where you had removed a vdev.
  - You cannot currently remove a raidz[1-3] vdev.

  - a removed vdev will continously require some RAM, see zpool status.
  - A pool with a removed vdev is not importable on former systems without this feature.
    A "zfs remap filesystem" can limit this.

<b>All</b>
  - <font style='color:red'>if a just removed vdev remains selectable, please reload this page.</font></pre>
EoF

&my_pools;




} #/ my_action
################


#########
sub my_pools {
#########
#status with disk cap and  model
    print "<br>";
    my $ant=&exe("zpool status");
    my @l=split(/\n/,$ant);
    my ($s,$t,$k);
    foreach my $l (@l) {
        $t=$l;
        $t=~s/^\s+//;

        if ($l=~/NAME/) { $l.="     CAP            Product";}

        if ($t=~/^c\d|^wwn|^scsi|^ata|^sd/) {      # is disk Solaris or Linux
             $t=~s/\s.*//;     # id only
             $t=~s/s0$|p0$//;  # no slices
             $k="$t"."_partcap";
             $s=15-length($disk{$k});

             $l.="     $disk{$k}"." "x $s;
             $k="$t"."_product";
             $k=~s/p\d//;                        #disk not part
             $l.=$disk{$k};
        }

    }
    $ant=join("\n",@l);
    $ant=~s/FAULTED/<font style='color:red'>FAULTED<\/font>/gs;
    $ant=~s/UNAVAIL/<font style='color:red'>UNAVAIL<\/font>/gs;
    $ant=~s/REMOVED/<font style='color:red'>removed<\/font>/igs;
    $ant=~s/\bAVAIL/<font style='color:blue'>AVAIL<\/font>/gs;
    $ant=~s/INUSE/<font style='color:blue'>INUSE<\/font>/gs;
    $ant=~s/DEGRADED/<font style='color:blue'>DEGRADED<\/font>/gs;


    print "<br><br><table style='width:100%'>\n";
    print "\t<tr>\n";
      print "<td class=\"td1_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<b>zpool status</b></td>";
    print "\t<tr>\n";

    print "\t<tr>\n";
      print "<td class=\"td2_bg\" nowrap style=\"vertical-align:top; padding: 1 5 1 3; width:100%\">\n";
      print "<pre>$ant</pre></td>";
    print "\t<tr>\n";

    print "</table>\n";
}

##############################################################################
sub my_remove {
################
   #&print_hash(%in);
   my ($r,$a);

   my $pool=$in{'autoselect_pool'};

   # zraid-n, create only in standalone mode
   if (($pool=~/^zraid\-\d/) && ($cfg{'select_servermode'} ne "standalone")) {
       &mess("A zraid pool cannot be modified in clustermode for security reasons.<br>Switch to standalone in About &gt; Settings to modify a zraid-pool.");
   }

   my $vdev=$in{'checkbox_vdev'};
   $vdev=~s/\..*//;

   # allow only a remove when all vdevs have same ashift
   # current bloody (oct 19) crashes with possible pool corrupt when different

   if (-f "/usr/sbin/zdb") {
     $r=`sudo /usr/sbin/zdb -C \"$pool\" | grep ashift`;
     @t=split(/\n/,$r);
     foreach my $t (@t) {
       $t=~s/\D//g;
       if (($t > 0) && ($a eq ""))   { $a=$t; }
       if (($t > 0) && ($t ne "$a")) { &mess("To allow a vdev remove, all vdevs must have the same ashift.<br>Your pool has vdevs with different ashift. A remove is not possible."); }
     }
   }

   print "<br>remove vdev (zpool remove \"$pool\" $vdev) please wait...<br>to cancel a running vdev removal, call <br><br><b>zpool remove -s $pool</b><br> ";

   #do it
   $r=&exe("zpool remove \"$pool\" $vdev 2>&1");

   #acc
   if (-f "/tmp/nappit/format_last.dsk") { `sudo rm /tmp/nappit/*.dsk`;  }
   if (-f "/tmp/nappit/parted_last.dsk") { `sudo rm /tmp/nappit/*.dsk`;  }
   if (-f "/tmp/nappit/zfs_list.zfs")    { `sudo rm /tmp/nappit/*.zfs`;  }

   if ($r ne "") {
     print "<br><font style='color:#cc3333;font-weight:800'>$r</font>"; &log_end; exit;
   }

   sleep(3);
   if (-f '/tmp/zfsstat.log') { &exe("rm /tmp/zfsstat.log"); }
   $in{'l2'}="";  $in{'l3'}="";
   &reload;
}





###############################################
#end of my script, do not delete the line below
1;
