###############
sub my_action {
###############

  #override with private functions?
  ##################################
    eval { &mylib_menue_snaps };                   # create this function in a private mylib.pl to replace this action

    my ($s, $ant);


&log_end;
print <<EoF;
<pre><b>Clone a ZFS Filesystem from a snapshot</b>

A clone is a writable volume or file system whose initial contents are the same as the snapshot from which it was created.
Creating a clone is nearly instantaneous and initially consumes no additional disk space. In addition, you can snapshot a clone.

Clones can only be created from a snapshot. When a snapshot is cloned, an implicit dependency is created between the clone and snapshot.
Even though the clone is created somewhere else in the dataset hierarchy, the original snapshot cannot be destroyed as long as the clone exists.

The origin property exposes this dependency, and the zfs destroy command lists any such dependencies, if they exist.
Clones do not inherit the properties of the dataset from which it was created.

Because a clone initially shares all its disk space with the original snapshot, its used property value is initially zero.
As changes are made to the clone, it uses more disk space. The used property of the original snapshot does not include the disk space consumed by the clone.

The parent filesystem of the parent snap must be writable or you cannot mount the clone.
Clones must be destroyed before the parent snapshot can be destroyed.


</pre>

EoF


# need always filesystems
print "<script language='javascript'>\$('#hl').html('Create a clone from a snap on $in{'member'}')</script>\n";
$ant=&exe("zfs list -H -o name -t filesystem");
$ant=~s/\n/,/gs;
$ant=~s/rpool,*//;


# you must select a filesystem and optionally a filter
if ($in{'select_fs'} eq "") {
     print "<b>Step1: Select snaps per filesystem</b><br><br>";
     &ask('begin');
     &ask('select_fs','Select a (parent) filesystem',$ant);
     &ask('value_filter','and filter snaps based on a string (opt)');
     &ask('end');
     exit;
}

#check
$in{'value_filter'}=~s/ +//g;
if ($in{'select_fs2'} eq "") {
     if (($in{'value_filter'} eq "") && ($in{'select_fs'} eq "-")) {
          &mess('Select a filesystem or characters to filter');
     }
}


print "<script language='javascript'>\$('#hl').html('processing, please wait..')</script>\n";
if ($in{'value_filter'} =~/\w/) {
    $s=&exe("zfs list -r -H -o name,creation -t snapshot | grep $in{'select_fs'} | grep $in{'value_filter'}");
} else {
    $s=&exe("zfs list -r -H -o name,creation -t snapshot | grep $in{'select_fs'}");
}

#separate snap from date
@t=();
@t=split(/\n/,$s);
foreach my $t (@t) {
  $t=~s/\s+/ from: /;    #
}
$s=join("\n",@t);
$s=~s/\n/,/gs;


# header
 print "<script language='javascript'>\$('#hl').html('Create a clone from a snap (valid Pro or Dev edition required)')</script>\n";

# clone
print "<b>Step2: Create a clone</b><br><br>";

if (!($s=~/\w/)) {
    print "No snaps found";
    sleep(2);
    &reload;
}


$in{'value_name'}=~s/ +//g;
if (($in{'value_name'} eq "") && ($in{'select_fs2'} ne "")) {
    if ($in{'select_snap'}=~/\/scsi_\d+/) {
           $in{'value_name'}="iscsi_".time();
    } else {
           if ($in{'value_name'} eq "") {                           # xx/test@..
               $in{'value_name'}=$in{'select_snap'};
               $in{'value_name'}=~s/\@.*//;
               $in{'value_name'}=~s/.*\///;                         # test
           }
    }
}


# allow only filesystems on same pool as snaps
$t=$in{'select_fs'};
$t=~s/\/.*//;            # leaves pool
@t=();
@t=split(/,/,$ant);
@t=sort(@t);
$ant="";
foreach my $f (@t) {
     if ($f eq $t)    { $ant ="$t,"; next; }   # pool
     if ($f=~/^$t\//) { $ant.="$f,"; }         # fs belo
}
$ant=~s/,$//;

if ($in{'value_name'} eq "") {
     &ask('begin');
     &ask('select_snap','Create a clone from snap',$s);
     &ask('select_fs2','Create a clone below filesystem',$ant);
     &ask('value_name','Name of new clone, keep empty for same fs name<br>For filesystem based iscsi_volumes name is always auto <br>generated like iscsi_146.. as volumename reflects a LU.');
     &ask('hidden','select_fs',$in{'select_fs'});
     &ask('confirm','create a clone from this snap','Do you really want to create the clone?');

     &my_clones();
     exit;
}


#&mess("zfs clone $in{'select_snap'} $in{'select_fs2'}/$in{'value_name'}");

#parse
if (!($in{'select_snap'} =~/\w/))  { &mess('Snap is missing'); }
if (!($in{'select_fs2'} =~/\w/))   { &mess('Filesystem is missing'); }

# remove date
$in{'select_snap'}=~s/\s.*//;


# ok clone
print "<br><br>";

print  "zfs clone $in{'select_snap'} $in{'select_fs2'}/$in{'value_name'}<br>";
print &exe("zfs clone $in{'select_snap'} $in{'select_fs2'}/$in{'value_name'}");

sleep(2);
$in{'l3'}="";
reload;




} #/ my_action
##############


###############
sub my_clones {
################
   my $ant=$_[0];
   my $r;

print "<br><br><br><b>Current Filesystem Clones</b><br><br>";
$ant=&exe("zfs list -H -o name -t filesystem | grep -v rpool/");
@fs=split(/\n/,$ant);

$l="Filesystem\tClone based on Snap\n";
$f="1";

foreach my $fs (@fs) {
     $r=&exe("zfs get -H -o value origin $fs");

     chomp ($r);
     if ($r=~/\@/) {

         # add creation
         $r=&exe("zfs get -H creation $r");
         $r=~s/ +/\t/gs;

         $l.="$fs\t$r\n";
         $f="0";
     }
}
if ($f) { $l.="none"; }
print &list2table($l);

print "<br><br><b>Current Volume Clones</b><br><br>";
$ant=&exe("zfs list -H -o name -t volume | grep -v rpool/");
@fs=split(/\n/,$ant);

$l="Volume\tClone based on Snap\n";
$f="1";

foreach my $fs (@fs) {
     $r=&exe("zfs get -H -o value origin $fs");

     chomp ($r);
     if ($r=~/\@/) {

         # add creation
         $r=&exe("zfs get -H creation $r");
         $r=~s/ +/\t/gs;

         $l.="$fs\t$r\n";
         $f="0";
     }
}
if ($f) { $l.="none"; }
print &list2table($l);

}


###############################################
#end of my script, do not delete the line below
1;
