#! disk lib
###############################
# disk functions for napp-it    Copyright (c) napp-it 2010-2024
################################
# 23.jan 2024 win

use strict;
#use vars qw( %disks );


#####################################################################

#########
sub disklib {
#############################
}

################
sub get_mydsk_stat   {
#################       # pool member, removed, replaceable etc, used in get-disk and get-smart
  my ($v,$k,@w,$w,$id,@p,$p,$d,@d,$t,$id,$r);

  @p=split(/\t/,$disk{'all_part'});                  # all available partitions

#debug
#&print_array(@p);

  $disk{'all_unused'}="";
  foreach $id (@p) {

               #unused
               $k="$id\_pool";
               if ($disk{$k} eq "") {                  # unused
                    # only if no slices for bootmirror ex c1t1d0s0
                    # c3t5d0_vdev        ->        'mirror-0'
                    $t=$id."vdev";

                    if (!($disk{'all_unused'}=~/$id/)) { $disk{'all_unused'}.="$id\t";  }        # add to unused

               } else {
                    if ($disk{'all_unused'}=~/$id/)    { $disk{'all_unused'}=~s/$id//;  }   #
               }

               # add avail to replaceable
               $k="$id\_state";
               if ($disk{$k} eq "AVAIL") {
                    if (!($disk{'all_replaceable'}=~/$t/)) { $disk{'all_replaceable'}.="$t\t";  }
               }
  }
  $disk{'all_unused'}=~s/\t+$//;

  # remove disks that are raw lu
#  $r=&exe("sbdadm list-lu");        # 600144f08278020f0000579653160001  21474770944          /dev/rdsk/c2t1d0p0
  my @l=();
  @l=split(/\n/,$r);

  @d=();
  @d=split(/\t/,$disk{'all_unused'});

  $disk{'all_raw_lu'}=();
  foreach my $l (@l) {                           # each lu
     if (!($l=~/dev\/rdsk/))  { next; }

     @w=();
     @w=split(/  +/,$l);                         # guid size id
     #&print_array(@w);

     $w[2]=~s/p\d+$//;
     $w[2]=~s/s\d+$//;
     $w[2]=~s/.*\/rdsk\///;

     foreach my $d (@d) {                        # each unused disk
          if ($w[2] eq $d) {                     # a raw lu
             $disk{'all_unused'}=~s/$d//;        # remove from unused
             $disk{'all_unused'}=~s/^\t+//;
             $disk{'all_unused'}=~s/\t+$//;
             $disk{'all_unused'}=~s/\t+/\t/g;

             if (!($disk{'all_raw_id'}=~/$d/)) {
                 $disk{'all_raw_id'}.="$d\t";
             }
             if (!($disk{'all_raw_lu'}=~/$w[0]/)) {
                 $disk{'all_raw_lu'}.="$w[0]\t";
             }

             $t="$d\_raw_lu";
             $disk{$t}=$w[0];
             $t="$d\_raw_size";
             $disk{$t}=$w[1];
             $t="$w[0]\_raw_source";
             $disk{$t}=$w[2];

          }  else {

          }
     }
  }
  $disk{'all_raw_id'}=~s/\t+$//;
  $disk{'all_raw_lu'}=~s/\t+$//;
  #&print_hash(%disk);
}


#########################
sub disklib_array_edit {                 # define hd arrays
#########################
 &mess('obsolete');
         my $tb="1";                # table border 0/1
         my $tw="1030px";         # table width
         my $tw1="";               # td width 1..n
         my $tw2="";
         my $tw3="";
         my $tw4="";
         my $tw5="";
         my $conf="/var/web-gui/_log/arrayconf.txt";
         my ($re,$i,$c,@w,@l,$l);

         #

        # first call, load values
         if (($in{'select_ctrl_1'} eq "") && ($in{'select_ctrl_2'} eq ""))  {
                 if (-f $conf) {
                         $re=&exe("cat $conf",'','disklib 37');

                     @l=split(/\n/,$re);
                        $in{'autoselect_arrays'}=@l-1;

                     foreach $l (@l) {
                                 @w=();
                            @w=split(/\|/,$l);
                            if ($w[1] eq "")          {  next; }

                                if ($w[0] eq "text_id") {
                                        $in{'text_id'}=$w[1];            #manual id
                                           $in{'text_id'}=&t2f($in{'text_id'});
                                } else {
                                      $c="text_$w[0]";                   # info
                                $in{$c}=$w[1];

                                $c="select_height_$w[0]";   # height
                                $in{$c}=$w[2];

                                $c="select_hv_$w[0]";       # hor/ver
                                $in{$c}=$w[3];

                                $c="select_disks_$w[0]";    # disks
                                $in{$c}=$w[4];

                                $c="select_ctrl_$w[0]";     # controller1
                                $in{$c}=$w[5];

                               $c="select_start_$w[0]";    # start with id
                                $in{$c}=$w[6];

                                $c="select_ctrl2_$w[0]";    # controller2
                                $in{$c}=$w[7];

                                $c="select_ctrl3_$w[0]";    # controller3
                                $in{$c}=$w[8];
                                }
                     }

                 }
         }


          # save values
         if ($in{'submit_ok'} eq "save")  {
               $t="";
               for ($i=1;$i<=$in{'autoselect_arrays'}; $i++) {
                   $t.="$i|";                # arraynr

                   $c="text_$i";                # info
                   $in{$c}=~s/\|//g;
                   $t.="$in{$c}|";

                   $c="select_height_$i"; # height
                   $t.="$in{$c}|";

                   $c="select_hv_$i";        # hor/ver
                   $t.="$in{$c}|";

                   $c="select_disks_$i";        # disks
                   $t.="$in{$c}|";

                   $c="select_ctrl_$i";        # controller1
                   $t.="$in{$c}|";

                   $c="select_start_$i"; # start with id
                   $t.="$in{$c}|";

                   $c="select_ctrl2_$i"; # ctrl2
                   $t.="$in{$c}|";

                   $c="select_ctrl3_$i"; # ctrl3
                   $t.="$in{$c}|\n";

               }

               $in{'text_id'}=~s/\|//gs;
               $in{'text_id'}=~s/ //gs;
               $in{'text_id'}=&f2t($in{'text_id'});        #manual set
               $t.="text_id|$in{'text_id'}|\n";

               $re=&exe("perl -e 'open (R,\">$conf\"); print R \"$t\"; close (R);'");
               $in{'l3'}=""; &reload;

         }


         print<<EoT;
<b>Array setup</b><br><br>
Your Disks are connected to one ore more disk controller building vertical or horizontal array-sets. <br>
Each array < 5 Disks must have the same controller id and should be set according to your drive bay location.  <br>
If you have more than 4 Disks in a row, you must set the controller 2 and 3 for Disks > 5  <br>
<br>
Horizontal arrays count from left to right, vertical drives and arrays from bottom up

EoT

        if ($in{'autoselect_arrays'} eq "") { $in{'autoselect_arrays'}="2"; }

          &ask('begin');
          &ask('autoselect_arrays','Number of Rows/Disk-arrays?','1,2,3,4,5,6,7,8,9,10,11,12',$in{'autoselect_arrays'});

         print"<table border=\"$tb\" style=\"width: $tw; padding: 1px; border:1px solid\">";

         #header
         my $tw1="40px";               # td width 1..n
         my $tw2="";
         my $tw3="60px";
         my $tw4="50px";
         my $tw5="130px";
         my $tw6="100px";
         my $tw7="100px";
         my $tw8="100px";
         my $tw9="100px";
          print<<EoF;
         <tr>
         <td valign='middle' style='width:$tw1;padding:2px' nowrap> <b>Row</b></td>
         <td valign='middle' style='width:$tw2;padding:2px' nowrap> <b>Info [A-Z,a-z,0-9&lt;br&gt;,-_()]</b></td>
         <td valign='middle' style='width:$tw3;padding:2px' nowrap> <b>Height %</b></td>
         <td valign='middle' style='width:$tw4;padding:2px' nowrap> <b>Hor/Ver</b></td>
         <td valign='middle' style='width:$tw5;padding:2px' nowrap> <b>Disks/ Layout</b></td>
         <td valign='middle' style='width:$tw6;padding:2px' nowrap> <b>Ctrl1 Hd0-7</b></td>
         <td valign='middle' style='width:$tw7;padding:2px' nowrap> <b>Ctrl1 from ID</b></td>
         <td valign='middle' style='width:$tw8;padding:2px' nowrap> <b>Ctrl2 Hd8-15</b></td>
         <td valign='middle' style='width:$tw9;padding:2px' nowrap> <b>Ctrl3 Hd16-23</b></td>
         </tr>
EoF


         for (my $i=$in{'autoselect_arrays'};$i>0; $i--) {
            &disklib_array_edit_tr($i);
         }

         print "</table>";
          print "<br><br><b>manual controller-id-setting</b><br><br>slot-id = id/guid (one value per line) examples: <br>c4t5d0=c4t500000E0115FFB50d0s4<br>c3d1=c2d0<br><br>";
           &ask('text_id','id=(gu)id',$in{'text_id'},'w400r9');

          &ask('confirm','save','save these settings?');

}

##########################
sub disklib_array_edit_tr {        #hide: generate tablerow for edit
###########################
&mess('obsolete');
        my $row=$_[0];
         my $tw1="40px";               # td width 1..n
         my $tw2="";
         my $tw3="60px";
         my $tw4="50px";
         my $tw5="130px";
         my $tw6="100px";
         my $tw7="100px";
         my $tw8="100px";
         my $tw9="100px";

          my @w=split(/\t/,$disk{'controller2'});          #number of controller
         my $cn=@w;
         my ($ctrl2,$ctrl3,$ctrl4,$dn);
         my $vi="text_$row";

         my $hv="select_hv_$row";
         $hv=&select($hv,'hor,ver',$in{$hv});

         my $ctrl="select_ctrl_$row";
         $ctrl=&select($ctrl,$disk{'controller2'},$in{$ctrl}); #

         my $disks="select_disks_$row";
         $dn=$in{$disks}; $dn=~s/\=.*//;
         my $val="1a=I x - - - I,1b=I - - - x I,1c=I x I,2a=I x x - - I,2b=I - - x x I,3a=I x x x - I,3b=I x x x I,3c=I x x - x I,3d=I x - x x I,4= I x x x x I,8= I 8x I,12=I 12x I,16=I 16x I,24=I 24x I";
         $disks=&select($disks,$val,$in{$disks},'','auto'); #

         my $start="select_start_$row";
         if (($cn > 1) && ($dn > 4)) {
                 $start=&select($start,'0',$in{$start}); #
         } else {
                 $start=&select($start,'0,1,2,3,4,5,6,7',$in{$start}); #
         }

  #&mess($dn);
         my $height="select_height_$row";
         $height=&select($height,'100,50',$in{$height}); #

         $ctrl2="select_ctrl2_$row";
         if (($cn > 1) && ($dn > 4)) {
           $ctrl2=&select($ctrl2,$disk{'controller2'},$in{$ctrl2}); #
         }  else {
           $ctrl2=&select($ctrl2,'-',$in{$ctrl2});
         }

         $ctrl3="select_ctrl3_$row";
         if (($cn > 2)   && ($dn > 4)) {
           $ctrl3=&select($ctrl3,$disk{'controller2'},$in{$ctrl3}); #
         } else {
           $ctrl3=&select($ctrl3,'-',$in{$ctrl3});
         }

        print<<EoF;
         <tr>
         <td valign='middle' style='width:$tw1;padding:2px' nowrap> <b>Row-$row</b>:</td>
         <td valign='middle' style='width:$tw2;padding:2px' nowrap> <input type=\"text\" name=\"text_$row\" value=\"$in{$vi}\" style="width: 99%; font-size:9px"></td>
         <td valign='middle' style='width:$tw3;padding:2px' nowrap> $height</td>
         <td valign='middle' style='width:$tw4;padding:2px' nowrap> $hv</td>
         <td valign='middle' style='width:$tw5;padding:2px' nowrap> Disks $disks</td>
         <td valign='middle' style='width:$tw6;padding:2px' nowrap> Ctrl1: $ctrl</td>
         <td valign='middle' style='width:$tw7;padding:2px' nowrap> Start t $start</td>
         <td valign='middle' style='width:$tw8;padding:2px' nowrap> Ctrl2: $ctrl2</td>
         <td valign='middle' style='width:$tw9;padding:2px' nowrap> Ctrl3: $ctrl3</td>
         </tr>
EoF

}

########################
sub disklib_array_show {                 # hide: show hd arrays
#########################
&mess('obsolete');
             my $conf="/var/web-gui/_log/arrayconf.txt";
             if (!(-f $conf)) {  print "-not defined-"; exit; }

             my $re=&exe("cat $conf",'','disklib 37');
             my @tmp=split(/\n/,$re);
               my (@r,@w,$d,$i,$h,$l,@l,$s,$stat,@id,$out,$id,$col,$tdstyle,$tdstyle2,$wi);

             foreach my $t (@tmp) {
                   if ($t=~/^text_id/) {
                        $t=~s/^text_id//;
                        $t=~s/\||\s//gs;
                        $in{'text_id'}=$t;
                        next;
                   }
                        if (!($t=~/^\d+\|/)) { next; }
                 push (@r,$t);
             }
             #@r contains valid data-rows
              @r=reverse(@r);


                #manual id=id settings
                if ($in{'text_id'} =~/=/s) {
                        @tmp=();
                        @tmp=split(/<n>/,$in{'text_id'});
                        @t=();
                        foreach $t (@tmp) {
                                if (!($t=~/=/)) { next; }                        # ex c0d2 -> c1d0 (or guid)
                                @t=split(/=/,$t);
                                $current{$t[0]}=$t[1];
                        }
              }


             #0=nr, 1=info, 2 =50/100, 3=hor/ver, 4=disks, 5=ctrl1, 6=startid, 7=ctrl2, 8=ctrl3
             foreach my $r (@r) {
                @w=(); @w=split(/\|/,$r);
                $d=$w[4];   $d=~s/\D.*//;        #number of disks
                $h="40px";
                if ($w[2] eq "50") { $h="20px"; }

                 $tdstyle="style='width: 150px; height: $h; vertical-align: top; border: 1px solid'";
                 $tdstyle2="style='width: 150px; height: $h; vertical-align: top; border: none'";


                $l=$w[4];                #disk + layout
                $l=~s/I$//;
                 $l=~s/.*I *//;
                @l=split(/ /,$l);

                $s=$w[6];          # startid
                if (!($s=~/\d/))   { $s="0"; }
#test
#&print_array(@r);
#&mess($s);

                #vertical
                if ($w[3] eq "ver") {
                       print "<table border='0' style='border: 3px outset; width: 150px'>\n";
                         print "<caption style='font-size: 10px'>$w[1]</caption>\n";
                      $s=$d+$s-1;
                      for ($i=$d-1;$i>=0; $i--) {
                                print "<tr>\n";
                            $t=$w[5]."$s";

                                if (($i eq "7") || ($i eq "15") || ($i eq "23")) { $s ="7";  }

                                if ($i eq "23") {      # 8 disks per controller
                                 if (($w[5] eq $w[7]) && ($w[7] eq $w[8]))  { $s ="23"; }
                                              if (($w[5] ne $w[7]) && ($w[7] eq $w[8]))  { $s ="15"; }
                                }
                                if ($i eq "15") {
                                              if ($w[5] eq $w[7])  { $s ="15"; }
                                }


                                if ($i  <= 24) { $t=$w[8]."$s";  }  # ctrl3
                                if ($i  <= 16) { $t=$w[7]."$s";  }  # ctrl2
                                if ($i  <= 8)  { $t=$w[5]."$s";  }  # ctrl1


                            $out=&disklib_array_show_values($t);
                            print "<td $tdstyle>$out</td>\n";
                            print "</tr>\n";
                            $s--;
                      }

                } else {     #hor

                         $wi=$d*150; $wi.="px";
                         if (($w[4] =~/^1a/) || ($w[4] =~/^1b/))                      { $wi="600px"; }
                         if ($w[4] =~/^1c/)                                                   { $wi="150px"; }
                         if (($w[4]=~/^2a/)  || ($w[4]=~/^2b/) || ($w[4]=~/^4/))   { $wi="600px"; }
                         if ($w[4] =~/^3b/)                                                  { $wi="450px"; }
                         if (($w[4] =~/^3a/) || ($w[4] =~/^3c/) ||($w[4] =~/^3d/)) { $wi="600px"; }


                            print "\n<table border='0' style='width: $wi; border: 3px outset'>\n";
                           print "<caption style='font-size: 10px'>$w[1]</caption>\n";
                         print "<tr>\n";

                         if ($d <= 4) {
                                 for ($i=0;$i<4; $i++) {
                                       if ($l[$i] eq "x") {
                                          $t=$w[5]."$s";
                                          $out=&disklib_array_show_values($t);
                                          print "<td $tdstyle'>$out</td>\n";
                                          $s++;
                                       } else {
                                                print "<td $tdstyle2>&nbsp;</td>\n";
                                       }
                                  }
                         }  else {

                            for ($i=0;$i<$d; $i++) {
                                    $t=$w[5]."$s";
                                        if (($i eq "8") && ($w[5] ne $w[7]))  { $s ="0";  }       # ctrl1 hd0-15
                                        if (($i eq "18") && ($w[7] ne $w[8])) { $s ="0";  }       # ctrl2 (ctrl1) hd 16-23
                                        if ($i  > 7)  { $t=$w[7]."$s";  }                         # ctrl2
                                        if ($i  > 15) { $t=$w[8]."$s";  }                         # ctrl3
                                         $out=&disklib_array_show_values($t);
                                        print "<td $tdstyle>$out</td>\n";
                                         $s++;
                            }
                         }
                         print "</tr>\n";


                } #/vh



                print "</table>\n";
             }
}

##############################
sub disklib_array_show_values {  # hide: par id
#############################
&mess('obsolete');
  my $id=$_[0];
  my $bg;
  my ($out,$t,@id);
     @id=();
     @id=split(/\t/,$disk{'all'});

     foreach my $p (@id) {                        # check of other than d0
        if ($p=~/^$id/) {
           $id=$p; last;                     # $id = c0t1d0
        }
     }

     $out="";
     if ($current{$id} ne "") {                #manual setting id=(gu)id
        $id=$current{$id};
        $bg="#f9f9d3";
     }


     $t=$id."_state";
     $out.="$disk{$t}";

     $t=$id."_pool";
     $out.="<br>$disk{$t}";                    # c1t2d0 ONLINE tank

#     if ($out=~/ONLINE/)                                { $out="<font style='color:green; font-size:11px;background-color:$bg'>$out</font>"; }
#     if ($out=~/FAULTED|OFFLINE|UNAVAILABLE|REMOVED/)   { $out="<font style='color:red; font-size:11px;background-color:$bg'>$out</font>" ; }

     $t=$id;
     $t=substr($t,0,10)." ".substr($t,11);
     $out="<b>$t $out</b>";

     $t=$id."_product";
     $t=substr($disk{$t},0,10);
     $out.="<br><font style='font-size:11px; color: #333333'> $t ";

     $t=$id."_cap";
     $out.=" $disk{$t}</font>";

     if ($out=~/ONLINE|AVAIL/)                          {
          $out="<font style='color:green; font-size:11px;background-color:$bg'>$out</font>";
          $t=$id."_vdev";
          $out=~s/ONLINE/$disk{$t}/;
          $out=~s/AVAIL/AVAIL $disk{$t}/;
     }
     if ($out=~/FAULTED|OFFLINE|UNAVAILABLE|REMOVED/)   { $out="<font style='color:red; font-size:11px;background-color:$bg'>$out</font>" ; }
     if ($out=~/AVAIL/)                                 { $out="<font style='color:blue; font-size:11px;background-color:$bg'>$out</font>" ; }
     if ($out=~/INUSE/)                                 { $out="<font style='color:#996633; font-size:11px;background-color:$bg'>$out</font>" ; }

     return $out;
}
##############
sub wwn_bold {   # set last 4 digiuts to bold
##############
  # wwn
  my $wwn=$_[0];
  if (length($wwn) > 15) {
      # bold of last char only
      my $t=substr($wwn,0,15);
      my $s=substr($wwn,15);

      $wwn="<tt>$t<b> $s";
      if ($wwn=~/d0/) {                        #  bold last 4 char without d0
          $wwn=~s/d0/<\/b> d0/;
      } else {
          $wwn.="</b>";
      }
      $wwn.="</tt>";
  }   else {
      # ok
  }
  return($wwn);

}


###
sub my_disklib_enc_window {
###
my $id=$_[0];  # id

my $t=<<EoF;
  Enclosure detection for $id on supported backplanes<br><b style='color:red'>Alert LED</b>
  will be enabled for 10s. Please wait...
EoF
&messages_box($t);
&messages_fadein;

}


#
################          ##########################################
sub disklib_list  {       # returns tablist of hds with parameter: 'source', 'header, vendor, product, revision, sn, cap, port, ..'
################          # each hd in new line \n
 my ($list,$d,@d,$txt,$p);
 my $source=$_[0];
 my $par=$_[1];

 # all_disk_inuse
 if ($source eq "all_disk_inuse") {    # disks from all_inuse
      @d=split(/\t/,$disk{'all_inuse'},);
      foreach $d (@d) {
            $d=~s/p\d$//;
            if ($disk{'all_disk_inuse'}=~/$d/) { next; }
            $disk{'all_disk_inuse'}.="$d\t";
      }
      $disk{'all_disk_inuse'}=~s/\t+$//;
  }

 # all_disk_unused
 if ($source eq "all_disk_unused") {    # disks from all_unused
      $disk{'all_disk_unused'}="";

      @d=split(/\t/,$disk{'all_unused'},);
      foreach $d (@d) {
            $d=~s/p\d$//;
            if ($disk{'all_disk_unused'}=~/$d/) { next; }
            $disk{'all_disk_unused'}.="$d\t";
      }
      $disk{'all_disk_unused'}=~s/\t+$//;
  }

 #addable disks
 if ($source eq "all_addable") {
      $disk{'all_addable'}="$disk{'all_basic'}\t$disk{'all_mirror'}";

      #remove disks from syspool
      @d=split(/\t/,$disk{'addable'},);

      foreach $d (@d) {
          if ($d eq "") { next; }
          $t=$d."_pool";
          if ($disk{$t} eq $zfs{'syspool'}) {
              $disk{'all_addable'}=~s/$d\t*//;            # not from syspool
          }
      }
      $disk{'all_addable'}=~s/^\t|\t$//;
 }

 #removeable disks
 if ($source eq "all_removeable") {
      # do not show twice
      $t="$disk{'all_cache'}\t$disk{'all_logs'}\t$disk{'all_mirror'}\t$disk{'all_spares'}\t$disk{'all_failed'}\t$disk{'all_replacing'}";
      $t=~s/\t+/\t/g;
      $t=~s/^\t|\t$//;
      @t=();
      @t=split(/\t/,$t);
      foreach my $t (@t) {
        if ($disk{'all_removeable'}=~/$t/) { next; }
        $disk{'all_removeable'}.="$t\t";
      }
      $disk{'all_removeable'}=~s/\t+/\t/g;
      $disk{'all_removeable'}=~s/^\t|\t$//;
 }

 #replacable disks
  if ($source eq "all_replaceable") {
      # do not show twice
      $t="$disk{'all_inuse'}\t$disk{'all_unavail'}";
      $t=~s/\t+/\t/g;
      $t=~s/^\t|\t$//;
      @t=();
      @t=split(/\t/,$t);
      foreach my $t (@t) {
        if ($disk{'all_replaceable'}=~/$t/) { next; }
        $disk{'all_replaceable'}.="$t\t";
      }
      $disk{'all_replaceable'}=~s/^\t|\t$//;
  }

  #replacewith unused and spares
    $disk{'all_replacewith'}="$disk{'all_unused'}\t$disk{'all_spares'}";
    $disk{'all_replacewith'}=~s/^\t+|\t+$//;

    # without spares "INUSE"
    @d=();
    @d=split(/\t/,$disk{'all_replacewith'});
    $disk{'all_replacewith'}="";
    foreach $d (@d) {
        $t=$d."_state";
        if ($disk{$t} eq "INUSE") { next; }
        $disk{'all_replacewith'} .="$d\t";
    }
    $disk{'all_replacewith'}=~s/^\t+|\t+$//;

 # offline disks
 if ($source=~/online|offline/) {
     $disk{'online'}="";
     $disk{'offline'}="";
     @d=split(/\t/,$disk{'all_dsk'},);
     foreach $d (@d) {
        $t=$d."_state";
        if ($disk{$t} eq "ONLINE")  { $disk{'online'} .="$d\t"; }
        if ($disk{$t} eq "OFFLINE") { $disk{'offline'} .="$d\t"; }
    }
    $disk{'online'}=~s/^\t+|\t+$//;
    $disk{'offline'}=~s/^\t+|\t+$//;
 }

 # online disks


 # prop = identify, then set link / show smart details on smart_sn
 # via dd
  my $url="<a title=\"=how=\" href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;action=\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list==list=\&amp;disk==disk=\&amp;prop==prop=\">=text=</a>";

 #smart_check
 my $url_s="<a title=\"=how=\" style='font-weight:bold' href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;disk==disk=\&amp;prop==prop=\" onclick=\"return(confirm('smart-check short 2 min/ long > 1h =disk= ?'))\">=text=</a>";
 my $url_a="<a title=\"=how=\" style='font-weight:bold' href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;disk==disk=\&amp;prop==prop=\" onclick=\"return(confirm('Abort check =disk= ?'))\">=text=</a>";


 #unconfigure
 my $url_u="<a style='font-weight:bold' href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;prop=unconfigure\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;disk==disk=\" onclick=\"return(confirm('unconfigure/offline =disk= ?'))\">configured</a>";

 #configure
 my $url_c="<a style='font-weight:bold' href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;prop=configure\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;disk==disk=\" onclick=\"return(confirm('configure/ online =disk= ?'))\">unconfigured</a>";

#offline
 my $url_off="<a style='font-weight:bold' href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;prop=offline\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;disk==disk=\" onclick=\"return(confirm('offline =disk= ?'))\">online</a>";

 #online
 my $url_on="<a style='font-weight:bold' href=\"/cgi-bin/$sys{'napp'}/admin.pl?id=$in{'id'}\&amp;prop=online\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;disk==disk=\" onclick=\"return(confirm('online =disk= ?'))\">offline</a>";

 $par=~s/\s//gs;
 $par=~s/,/\t/g;

  if ($_[1]=~/header/) {
     $par=~s/header\t*//;
     $par=~s/^\t|\t$//;
     $par=~s/\t+/\t/g;
     $t='&nbsp;' x 23;
     $list="<b>id</b>$t\t$par\n";
  }

  my @par=split(/\t/,$par);

  my @hds=split(/\t/,$disk{$source});
  @hds=sort(@hds);

#debug
#&print_array(@hds);

  foreach my $i (@hds) {         #c1\tc2\tc3

      # use disk instead of partition 1 when source=all_* and id_part =1 only
      if ($source=~/^all\_/) {
         $t=$i; $t=~s/p\d$//; $t="$t\_part";
         if (!($disk{$t}=~/,/)) {                   # ex part 1,2
            $i=~s/p\d$//;
         }
      }

      $list .="$i\t";
      foreach $par (@par) {

                if (($i=~/p\d$/) && ($par eq "part")) {
                   $t=$i;
                   $t=~s/.*p//;
                   $list.="$t\t";
                   next;
                }

                if ("vendor,error,product,sn,psec,lsec,stat,diskcap,ptable"=~/$par/) {
                   $t=$i;
                   if ($i=~/p\d$/) {
                      $t=~s/p\d$|s\d$//;
                   }
                   $t="$t"."_$par";
                   $list.="$disk{$t}\t";                   # add value of disk not partition/slice
                   next;
                }

                if (($i=~/p\d$/) && ("vendor,error,product,sn,psec,lsec,stat,diskcap,ptable"=~/$par/)) {
                   $t=$i;
                   $t=~s/p\d$|s\d$//;
                   $t="$t"."_$par";
                   $list.="$disk{$t}\t";                   # add value of disk not partition/slice
                   next;
                }

                if ($par eq "dsk") {
                        $list.="$i\t";
                        next;
                }

                if ($par eq "smart_sn") {
                        $t="$i"."_$par";
                        $list.=$url;
                        $list=~s/=prop=/$i/g;
                        $list=~s/=text=/$disk{$t}/g;
                        $list=~s/=how=/show smart details/g;
                        $list=~s/=list=/show smart details/g;
                        $list=~s/=disk=/$i/g;
                        $list.="\t";
                        next;
                }

                if ($par eq "smart_check") {
                  $t="$i"."_smart_sn";
                  if ($disk{$t} ne "" ) {
                        $t="$i"."_$par";
                        $list.=$url_s;
                        $list=~s/=prop=/short check/g;
                        $list=~s/=text=/short/g;
                        $list=~s/=how=/nondestructive short check/g;
                        $list=~s/=list=/short/g;
                        $list=~s/=disk=/$i/g;
                        $list.=" ";

                        $t="$i"."_$par";
                        $list.=$url_s;
                        $list=~s/=prop=/long check/g;
                        $list=~s/=text=/long/g;
                        $list=~s/=how=/nondestructive long check/g;
                        $list=~s/=list=/long/g;
                        $list=~s/=disk=/$i/g;
                        $list.=" ";

                        $t="$i"."_$par";
                        $list.=$url_a;
                        $list=~s/=prop=/abort/g;
                        $list=~s/=text=/abort/g;
                        $list=~s/=how=/abort check/g;
                        $list=~s/=list=/abort/g;
                        $list=~s/=disk=/$i/g;
                        $list.=" ";

                        $t="$i"."_$par";
                        $list.=$url;
                        $list=~s/=prop=/log/g;
                        $list=~s/=text=/log/g;
                        $list=~s/=how=/log/g;
                        $list=~s/=list=/log/g;
                        $list=~s/=disk=/$i/g;
                        $list.="\t";
                     } else {
                        $list.="-\t";
                     }
                        next;
                }

                #offline
                if ($par eq "state!") {
                       $t="$i"."_state";

                       #current configured
                       if ($disk{$t} eq "ONLINE") {
                          $list.=$url_off;
                       } else{
                          $list.=$url_on;
                       }
                       $list=~s/=disk=/$i/g;
                       $list.="\t";
                       next;
                }

                #busy!
                if ($par eq "busy!") {
                       $t="$i"."_busy";

                       #current configured
                       if ($disk{$t} eq "configured") {
                          $list.=$url_u;
                       } else{
                          $list.=$url_c;
                       }
                       $list=~s/=disk=/$i/g;
                       $list.="\t";
                       next;
                }

                #ctrl:target
                if ($par eq "ctrl:target") {
                        $t=$i;
                        $t=~s/d.*//;
                        $t=~s/t/ : t/;
                        $list.="<b>$t</b>\t";
                        next;
                }

                #dd
                $t="$i"."_busy";
                if ($par eq "identify")  {    # dd

                        $p=$i;
                        $p=~s/p\d//;          # disk not part
                        $t="$p"."_stat";

                        if ($disk{$t} eq "ok") {
                           $t="";
                           if ($in{'list'} eq "identify_dd") {
                             if ($in{'disk'} eq $i) {
                                $t="<img src='/_doc/red.png'>";       # led
                             }
                           }

                           #$t="$i"."_$par";
                           $list.=$url;
                           $list=~s/=prop=/$p/g;
                           $list=~s/=text=/via dd $t/;
                           $list=~s/=how=/identify via dd/;
                           $list=~s/=list=/identify_dd/;
                           $list=~s/=disk=/$p/;
                        } else {
                           $list.="-";
                        }
                        $list.="\t";
                        next;
                } else {
                        $t="$i"."_$par";
                        if (($par eq "") || ($disk{$t} eq "")) { $list.="-"; }
                }

                #sas2 slot detection
                if ($par eq "slot") {
                        $t="$i"."_$par";

                        $txt=$disk{$t};
                        if ($txt=~/s\d\b/) { $txt=~s/s/s0/; }
                        $txt=~s/:/ : /g;

                        # to allow sort on slot in in actions
                        $list.="$txt:=$url\t";
                        $list=~s/=prop=/$disk{$t}/g;

                        $txt=$disk{$t};
                        if ($txt=~/s\d\b/) { $txt=~s/s/s0/; }
                        $txt=~s/:/ : /g;

                        $t="";
                        if ($in{'list'} eq "identify_slot") {
                             if ($in{'disk'} eq $i) {
                                &my_disklib_enc_window($in{'prop'});  # message
                                $t="<img src='/_doc/red.png'>";       # led
                             }
                        }

                        $list=~s/=text=/$txt $t/;

                        $list=~s/=how=/via red LED on supported backplanes/;
                        $list=~s/=list=/identify_slot/;
                        $list=~s/=disk=/$i/;
                }  else {
                        $list.="$disk{$t}\t";
                }
      }
      $list=~s/\t+$//;
      $list.="\n";
  }
  # c0d0  \t western digitel \t 100GB
  # c0d1  \t western digitel \t 100GB

# &mess($list);
 $par="disklib_list_$_[0]_$_[1]";
 $current{$par}=$list;
 return($list);
}




####################
sub disklib_ctrl     {   #return all controller/ disk infos if connected
####################  ex sata0/0::dsk/c0t0d0                    disk         connected    configured   ok
   my ($r,$t,$s,$i,@c,@w,@i);

&mess('disklib_ctrl moved to getdisk-status');
   # get disk of controller
   # $r=&exe("cfgadm -avl","n");                # sata0/0::dsk/c0t0d0                    disk         connected    configured   ok

}



# end of file
##############
1;