#!
# get-lib
#

# part 1 get data -> %user  on user menus
##########################

&my_getaccounts;             # key is always a number (sid,uid,gid, not names (can give problems with localisations)
                             # ex users="0\t102\t"; same with sid

&my_filter;                  # filter user and groups for table


#####################        # filter user,groups,smbuser amd smbgrpups to x_filter
sub my_filter {
#####################
     my (@t,@filter,$k,@users,@groups,@smbgroups);

 #&print_hash(%user);

     # f1,f2                 textfilter
     #f1s,f2s,f3s,f4s        groupfilter local_nonsys, local_all (ad_nonsys, ad_all)

     # base list all or nonsys
     #push (@filter,'=User=');               # header


     #####################################
     #############  users_filtered #######
     #####################################

     if ($in{'f1s'}=~/all/) {
       @users=split(/\t/,$user{'users'});
     } else {
       @users=split(/\t/,$user{'users_nonsys'});
     }

     @filter=();
     @users=sort(@users);
     foreach my $t (@users) {
          $k=$t."_name";
          if (($in{'f1'} ne "") && (!($user{$k}=~/$in{'f1'}/))) { next; }
          push (@filter,$t);
     }

     # add  user
     if (!($current{'on'}=~/mswin/i)) {
        push(@filter,"=adduser=");
     }


     #local users filtered
     $user{'users_filtered'}=join("\t",@filter);

     #####################################
     #######  smbaccounts_filtered #######
     #####################################

     @filter=();

     # 1. users are smbaccounts
     #push(@filter,"=smbusers=");
     push(@filter,"=users=");

     if ($in{'f2s'}=~/all/) {
       @t=split(/\t/,$user{'users'});
     } else {
       @t=split(/\t/,$user{'users_nonsys'});
     }
     @t=sort(@t);

     foreach my $t (@t) {
          $k=$t."_name";
          if (($in{'f2'} ne "") && (!($user{$k}=~/$in{'f2'}/))) { next; }
          push (@filter,$t);
     }

     # 2. smbgroups are smbaccounts
     push(@filter,"=groups=");


     if ($in{'f2s'}=~/all/) {
       @t=split(/\t/,$user{'smbgroups'});
     } else {
       @t=split(/\t/,$user{'smbgroups_nonsys'});
     }
     @t=sort(@t);

     foreach my $t (@t) {
          $k=$t."_name";
          if (($in{'f2'} ne "") && (!($user{$k}=~/$in{'f2'}/))) { next; }
          push (@filter,$t);
     }

     # add  user
     if ($current{'on'}=~/mswin/i) {
        push(@filter,"=adduser=");            # on linix, unix adduser in 1st table
     }  else {
        push(@filter,"==");             # add line for bin+
     }


     #local users filtered
     $user{'smbaccounts_filtered'}=join("\t",@filter);

     #################
     # groups filtered
     #################

     if ($in{'f3s'}=~/all/) {
       @groups=split(/\t/,$user{'groups'});
     } else {
       @groups=split(/\t/,$user{'groups_nonsys'});
     }

     @filter=();
     @groups=sort(@groups);
     foreach my $t (@groups) {
          $k=$t."_name";
          if (($in{'f1'} ne "") && (!($user{$k}=~/$in{'f1'}/))) { next; }
          push (@filter,$t);
     }

     # add  group
     if (!($current{'on'}=~/mswin/i)) {
        push(@filter,"=addgroup=");
     }


     #local users filtered
     $user{'groups_filtered'}=join("\t",@filter);


     #################
     # smbgroups filtered
     #################


     if ($in{'f4s'}=~/all/) {
       @smbgroups=split(/\t/,$user{'smbgroups'});
     } else {
       @smbgroups=split(/\t/,$user{'smbgroups_nonsys'});
     }

     @filter=();
     @users=sort(@smbgroups);
     foreach my $t (@smbgroups) {
          $k=$t."_name";
          if (($in{'f1'} ne "") && (!($user{$k}=~/$in{'f1'}/))) { next; }
          push (@filter,$t);
     }

     # add  group
     push(@filter,"=addgroup=");


     #local users filtered
     $user{'smbgroups_filtered'}=join("\t",@filter);


     #&print_hash(%user);
}

######################       # user and groups
sub my_getaccounts {
#######################
   if ($users{'get_accounts'}) { return; } # only once
   $users{'get_accounts'}=1;

   if ($current{'on'}=~/mswin/i)   { &my_getaccounts_win; } else {  &my_getaccounts_x; }        # win or x uid/gid
   if ($current{'on'}=~/solaris/i) { &my_getaccounts_sol; }                                     # get smbgroups/sid
}


#########################
sub get_groupmembers_win {                   # get group members in windows from group sid
#########################
   # Get-LocalGroupMember -Group S-1-5-21-.. | Select-Object -ExpandProperty Name,SamAccountName,ObjectSID

}

#########################
sub my_getaccounts_sol {
#########################          # Illumos and Solaris
my ($r,@p,$k,$p,@l,$g,@name,@sid,@member,@desc,$d,$n,$sid);
# SMB user=Unix user
# SID for user and groups

# SMB groups with members
# Solaris 11: smbadm show-group -m
# Illumoos  : smbadm show -m

if ($current{'on'}=~/Oracle Solaris/i)   {
      $r=&exe('smbadm show-groups -m');
} else {
      $r=&exe('smbadm show -m');
}

# [0] -> 'administrators (Members can fully administer the computer/domain)'
# [1] -> '        ?SID: S-1-5-32-544'
# [2] -> '        ?No members'
# [3] -> 'backup operators (Members can bypass file security to back up files)'
# [4] -> '        ?SID: S-1-5-32-551'
# [5] -> '        ?No members'
# [6] -> 'power users (Members can share directories)'
# [7] -> '        ?SID: S-1-5-32-547'
# [8] -> '        ?Members:'
# [9] -> '        ?        ?a@solaris114cbe.fritz.box'

@l=split(/\n/,$r);   #
#&print_array(@l);

my $i=-1;
# get arrays name, desc, sid and add member (tablist) to %user
foreach my $l (@l) {
  if (!($l=~/\w/))                 { next; }

  # first line
  if ($l=~/^\w/) {               # new group
      $i++;
      $n=$l; $n=~s/ \(.*//;      # name
      $name[$i]="$n";

      $d=$l; $d=~s/^.* \(//;     # desc
      $d=~s/\)//;
      $desc[$i]="$d";

      $user{'n:smbgroups'}.="\t$n";       # names
      $user{'n:smbgroups'}=~s/^\t//;

      next;                         # goto sid
  }

  # sid
  if ($l=~/^\tSID:/) {              # sid
     $sid=$l;
     $sid=~s/.*SID: *//;
     $sid[$i]=$sid;
#&mess($sid);

     $user{'smbgroups'}.="\t$sid";    # sid is key
     $user{'smbgroups'}=~s/^\t//;

     # nonsys groups
     $t=quotemeta($sid);
     if ((length($sid) > 20) || ("S-1-5-32-544,S-1-5-32-547,S-1-5-32-545"=~/$t/)) {              #administratoren, Hauptbenutzer,Benutzer
              $user{'smbgroups_nonsys'}.="\t$sid";
              $user{'smbgroups_nonsys'}=~s/^\t//;             # non sys groups

              $user{'smbgroups_nonsys:n'}.="\t$n";
              $user{'smbgroups_nonsys:n'}=~s/^\t//;            # non sys named groups

              $user{'smbaccounts_nonsys'}.="\t$sid";
              $user{'smbaccounts_nonsys'}=~s/^\t//;           # non sys named groups
     }

     next;                          # goto members
  }

  #members to users(sid_members)
  if ($l=~/^\tNo /)   {              # no members
      @member[$i] ="-";
      next;                          # next group

  }

  if ($l=~/^\tMembers /)   {  # has members
      next;                     # goto members
  }

  # is a member
  if ($l=~/^\t\t\w/)        {   # is a member
       $t=$l;
       $t=~s/\@.*//;            # name only

       $k="$sid\_members";
       $user{$k}.="\t$t";
       $user{$k}=~s/^\t+//;

       next;                    # next user or group
  }
}

# get name and desc based on sid
$i=0;
foreach my $s (@sid) {
    $k=$s."_name";
    $user{$k}=$name[$i];

    $k="$s\_desc";
    $user{$k}=$desc[$i];

    $i++;
}

#&print_hash(%user);

# idmap dump (Solaris, Ill)
$r=&exe("idmap dump | grep uid");

#idmap dump | grep uid
#usid:S-1-5-21-722635049-2797886035-3977363046-501       ==      uid:2147483649
#usid:S-1-5-21-3952067331-766569302-2624163198-501       ==      uid:2147483650

@sid=split(/\n/,$r);
foreach my $s (@sid) {
  if (!($s=~/==/))          { next; }
  $s=~s/usid:|uid:|\s+//g;
  @t=split(/==/,$s);

  $k="u:$t[1]"."_sid";
  $user{$k}=$t[0];

}





}

######################       # user and groups linux/unix
sub my_getaccounts_x {
#######################
    #
    my ($r,@p,$k,$p,@l,$g);

    # defaults
        $user{'groups_nonsys'}="g:root";        # root in nonsys group is default

    # rootgroup on bsd is wheel
    if ($current{'on'} =~/bsd/i) {
        $user{'users_default'}="_dhcp\t_pflogd\t_ypldap\tauditdistd\tavahi\tbin\tbind\tcyrus\tdaemon\tgames\thast\tkmem\tmailnull\tman\tmessagebus\tnews\tnobody\tntpd\toperator\tpop\tproxy\troot\tsmmsp\tsshd\ttests\ttoor\ttty\tunbound\tuucp\twww";
        $user{'groups_default'}="_dhcp\t_pflogd\t_ypldap\taudit\tauthpf\tavahi\tbin\tbind\tcyrus\tdaemon\tdialer\tftp\tgames\tguest\thast\tidletime\tkmem\tmail\tmailnull\tman\tmessagebus\tnetwork\tnews\tnobody\tnogroup\tntpd\toperator\tproxy\trealtime\tsmmsp\tsshd\tstaff\tsys\ttests\ttty\tu2f\tunbound\tuucp\tvideo\twheel\twww";
        $user{'groups_nonsys'}="g:wheel";      # basic groups with wheel instead root as nonsys
    }
    if ($current{'on'} =~/linux/i) {
        $user{'users_default'}="_apt\t_chrony\t_rpc\tbackup\tbin\tceph\tdaemon\tgames\tgluster\tirc\tlist\tlp\tmail\tman\tmessagebus\tnews\tnobody\tpostfix\tproxy\troot\tsshd\tstatd\tsync\tsys\tsystemd-network\ttcpdump\ttss\tuucp\twww-data";
        $user{'groups_default'}="_chrony\t_ssh\tadm\taudio\tbackup\tbin\tcdrom\tceph\tcrontab\tdaemon\tdialout\tdip\tdisk\tfax\tfloppy\tgames\tgluster\tinput\tirc\tkmem\tkvm\tlist\tlp\tmail\tman\tmessagebus\tnews\tnogroup\toperator\tplugdev\tpostdrop\tpostfix\tproxy\trdma\trender\troot\tsambashare\tsasl\tsgx\tshadow\tsrc\tssl-cert\tstaff\tsudo\tsys\tsystemd-journal\tsystemd-network\ttape\ttcpdump\ttss\ttty\tusers\tutmp\tuucp\tvideo\tvoice\twww-data";
    }

    if ($current{'on'} =~/solaris/i) {
       $user{'users_default'}="adm\tbin\tchrony\tdaemon\tdladm\tdma\tgdm\tguest\tlisten\tlp\tminio\tnetadm\tnetcfg\tnoaccess\tnobody4\tnobody\tnuucp\tpkg5srv\troot\tsshd\tsvctag\tsys\tunknown\tupnp\tuucp\twebservd\txvm\tzfssnap";
       $user{'groups_default'}="adm\tbin\tchrony\tdaemon\tgames\tgdm\tlp\tmail\tminio\tnetadm\tnoaccess\tnobody\tnogroup\tnuucp\tother\tpkg5srv\troot\tslocate\tsshd\tstaff\tsys\tsysadmin\ttty\tunknown\tupnp\tuucp\twebservd\txvm";
    }

    # common nonsys groups, root last
    if ($user{'groups_default'}=~/\busers\b/)      { $user{'groups_nonsys'}="g:users\t$user{'groups_nonsys'}"; }         # add users
    if ($user{'groups_default'}=~/\bsambashare\b/) { $user{'groups_nonsys'}="g:sambashare\t$user{'groups_nonsys'}"; }    # add sambashare
    if ($user{'groups_default'}=~/\bstaff\b/)      { $user{'groups_nonsys'}="g:staff\t$user{'groups_nonsys'}"; }         # add staff
    if ($user{'groups_default'}=~/\bbackup\b/)      { $user{'groups_nonsys'}="g:backup\t$user{'groups_nonsys'}"; }        # add backupo
    if ($user{'groups_default'}=~/\bother\b/)      { $user{'groups_nonsys'}="g:other\t$user{'groups_nonsys'}"; }         # add other
    if ($user{'groups_default'}=~/\bguest\b/)      { $user{'groups_nonsys'}="g:guest\t$user{'groups_nonsys'}"; }         # add guest

    # /defaults


    $r=&exe('cat /etc/passwd');
    @l=split(/\n/,$r);   # name,x,uid,gid,desc,homedir,shell
    @l=sort(@l);

    foreach my $l (@l) {
       @p=split(/:/,$l);
       if ($p[2] eq "") { next; }

       $user{'users'}.="\tu:$p[0]";            # key is name as same uid/gid can be used for several user/groups
       $user{'users'}=~s/^\t//;

       #$user{'users:n'}.="\t$p[0]";          # named users
       #$user{'users:n'}=~s/^\t//;

       $k="u:".$p[0]."_name";
       $user{$k}="$p[0]";

       $k="u:".$p[0]."_uid";
       $user{$k}=$p[2];

       $k="u:".$p[0]."_gid";
       $user{$k}="$p[3]";

       $g=$user{$k};                       # last gid

       $k="u:".$p[0]."_desc";
       $user{$k}="$p[4]";

       $k="u:".$p[0]."_home";
       $user{$k}="$p[5]";

       # not a default user
       if (!($user{'users_default'}=~/\b$p[0]\b/)) {

           $user{'users_nonsys'}.="\tu:$p[0]";
           $user{'users_nonsys'}=~s/^\t//;

       }  else {

           $user{'users_sys'}.="\tu:$p[0]";
           $user{'users_sys'}=~s/^\t//;       # propably sys user

       }

       $k="u:".$p[0]."_shell";
       $user{$k}="$p[6]";

       if ($user{$k}=~/nologin$|false$/) {
           $t="u:".$p[0]."_enabled";
           $user{$t}="disabled";
       } else {
           $t="u:".$p[0]."_enabled";
           $user{$t}="enabled";
       }

       #list of all uid
       $user{'users_alluid'}.="$p[2]\t";
    }
    $user{'users_alluid'}=~s/\t+$//;

    ###################################
    # groups

    $r=&exe('cat /etc/group');
    @l=split(/\n/,$r);   # name,x,guid
    @l=sort(@l);


    foreach my $l (@l) {
       @p=split(/:/,$l);
       if ($p[0] eq "") { next; }

       $user{'groups'}.="\tg:$p[0]";       # key is name
       $user{'groups'}=~s/^\t//;

       $k="g:$p[0]\_guid";
       if (!($user{'groups_default'}=~/\b$p[0]\b/)) {       # not a default group
           $user{'groups_nonsys'}.="\tg:$p[0]";
           $user{'groups_nonsys'}=~s/^\t//;
       }  else {
           $user{'groups_sys'}.="\tg:$p[0]";
           $user{'groups_sys'}=~s/^\t//;
       }

       $k="g:".$p[0]."_name";
       $user{$k}="$p[0]";

       $k="g:".$p[0]."_guid";
       $user{$k}="$p[2]";
    }

    # &print_hash(%user);
    # &mess($r);

} #/sub

######################       # user and groups
sub my_getaccounts_win {
#######################
    #
    my ($r,@p,$k,$p,@l);

    #&print_hash(%current);

       $r=&exe("Get-LocalUser | Select-Object -Property Name, SID, \@{Name=\"Enabled\";Expression={if (\$_.Enabled) {\"enabled\"} else {\"disabled\"}}}, Description | ConvertTo-Csv -NoTypeInformation | ConvertFrom-Csv -Delimiter \";\" | Out-String -Width 200");

       #
       #Name,"SID","Enabled","Description"
       #----------------------------------
       #Administrator,"S-1-5-21-2926750767-1104162250-30284767-500","Vordefiniertes Konto f?r die Verwaltung des Computers bz...
       #DefaultAccount,"S-1-5-21-2926750767-1104162250-30284767-503","Ein vom System verwaltetes Benutzerkonto.","Disabled"
       #Gast,"S-1-5-21-2926750767-1104162250-30284767-501","Vordefiniertes Konto f?r Gastzugriff auf den Computer bzw. die Do...

       @l=split(/\n/,$r);   # name,sid,enabled,desc
       foreach my $l (@l) {
          if ($l=~/^Name,/)    { next; }
          if ($l=~/^----/)     { next; }

          $l=~s/\"//g;
          #print "$l<br>\n";

          @p=split(/,/,$l);

          #print "$p[0]<br>";

          if ($p[0] eq "") { next; }

          $user{'users'}.="\t$p[1]";   # key is sid
          $user{'users'}=~s/^\t//;

          if (length($l) > 20)  {                  # administratoren, Hauptbenutzer,Benutzer
              $user{'users_nonsys'}.="\t$p[1]";    # key is sid
              $user{'users_nonsys'}=~s/^\t//;
          }

          $user{'users:n'}.="\t$p[0]";  # named users
          $user{'users:n'}=~s/^\t//;

          $k=$p[1]."_name";
          $user{$k}=&my_t2html($p[0]);

          $k=$p[1]."_enabled";
          $user{$k}="$p[2]";

          $k=$p[1]."_desc";
          $user{$k}="$p[3]";
       }

       ########
       # groups
       ########

       $r=&exe("Get-LocalGroup | Select-Object -Property Name, SID, Description | ConvertTo-Csv -NoTypeInformation | ConvertFrom-Csv -Delimiter \";\" | Out-String -Width 180");

       #utf8::encode($r);      # does not help

       #&mess($r);

       #Name,"SID","Description"
       #------------------------
       #__vmware__,"S-1-5-21-2926750767-1104162250-30284767-1005","VMware User Group"
       #Administratoren,"S-1-5-32-544","Administratoren haben uneingeschr?nkten Vollzugriff auf den Computer bzw. die Dom?ne."
       #Benutzer,"S-1-5-32-545","Benutzer k?nnen keine zuf?lligen oder beabsichtigten ?nderungen am System durchf?hren und d?....

       @l=split(/\n/,$r);   # name,sid,enabled,desc
       foreach my $l (@l) {
          if ($l=~/^Name,/)    { next; }
          if ($l=~/^----/)     { next; }

          $l=~s/\"//g;
          #print "$l<br>\n";

          @p=split(/,/,$l);

          #print "$p[0]<br>";

          if ($p[1] eq "") { next; }

          $user{'smbgroups'}.="\t$p[1]";
          $user{'smbgroups'}=~s/^\t//;

          $user{'smbgroups:n'}.="\t$p[0]";           # named groups
          $user{'smbgroups:n'}=~s/^\t//;

          $k=$p[1]."_name";
          $user{$k}=&my_t2html($p[0]);

          # nonsys groups
          if (( length($p[1]) > 15) || ("S-1-5-32-544,S-1-5-32-547,S-1-5-32-545"=~/p[1]/)) {              #administratoren, Hauptbenutzer,Benutzer
              $user{'smbgroups_nonsys'}.="\t$p[1]";
              $user{'smbgroups_nonsys'}=~s/^\t//;             # non sys groups

              $user{'smbgroups_nonsys:n'}.="\t$p[0]";
              $user{'smbgroups_nonsys:n'}=~s/^\t//;           # non sys named groups
          }

          $k=$p[1]."_desc";
          $user{$k}="$p[2]";
       }

       #
       #&print_hash(%user);
       #&mess($r);

}  #/sub


sub my_t2html {        # display _name with html entitities in get-user/groups with charsets
###############
    my $r=$_[0];

       $r=~s/ f..r / f\&uuml\;r /gs;                      # problems with national charsets
       $r=~s/Dom..ne/Dom&auml;ne/gs;

       # groupnames
       $r=~s/G..ste/G&auml;ste/gs;                        # problems with national charsets
       $r=~s/Ger..te/Ger&auml;te/gs;
       $r=~s/..berwachungs/\&uuml;berwachungs/gs;
       $r=~s/..tzungsoperatoren/\&uuml;tzungsoperatoren/gs;

    return ($r);
}


1;