# get_basic-sys.pl
# zpool list gets NAME   SIZE  ALLOC   FREE  CKPOINT  EXPANDSZ   FRAG    CAP  DEDUP    HEALTH  ALT

# basic info for global hashes  like name, cap%, health -> zfs(allpools)
# loaded always

# windows

use strict;


# 1. zpool hash (info)
#######################


 # get pool details
 &get_zpool_list;

 # &print_hash(%zfs);

 # ldate
 &getdate;
 &get_ldate;

 # &get_joberror;  # in ample

 ######################
 sub get_zpool_list {
 #####################
     if ($current{'on'}=~/Oracle Solaris/i) {
         &get_zpool_solaris;
     } else {
        &get_zpool_openzfs;
     }
 }

 #######################
 sub get_zpool_solaris {
 #######################

        my ($r,@p,@l);
        # get zpool list

        $r=&exe('zpool list');

        #NAME    SIZE  ALLOC   FREE  CAP  DEDUP  HEALTH  ALTROOT
        #rpool  29.5G  11.4G  18.1G  38%  1.00x  ONLINE  -
        #tank   9.94G  1.24M  9.94G   0%  1.00x  ONLINE  -

        $zfs{'allpools'}="";
        $zfs{'allpool_health'}="yes";
        $zfs{'allpool_cap'}="yes";            # <80%

        @t=split(/\n/,$r);
        foreach my $t (@t) {
        if ($t=~/^NAME +SIZE/)  { next; }
           @p=split(/ +/,$t);

           #&print_array(@p);

           # [0] -> 'NAME'   # tank
           # [1] -> 'SIZE'   # 29G
           # [2] -> 'ALLOC'  # 11G
           # [3] -> 'FREE'   # 18G
           # [4] -> 'CAP'    # 28%
           # [5] -> 'DEDUP'  # 1.00x
           # [6] -> 'HEALTH' # ONLINE
           # [7] -> 'ALTROOT'


           $zfs{'allpools'}.="\t$p[0]";  $zfs{'allpools'}=~s/^\t//;
           if ($p[0] ne "rpool") {
               $zfs{'datapools'}.="\t$p[0]";  $zfs{'datapools'}=~s/^\t//;
           }


           if ($p[6] ne "ONLINE")   { $zfs{'allpool_health'} ="no"; }
           if ($p[4] >79)           { $zfs{'allpool_cap'} ="no"; }      # cap usage > 79%

           $t=$p[0]."_size";
           $zfs{$t}=$p[1];

           $t=$p[0]."_alloc";
           $zfs{$t}=$p[2];

           $t=$p[0]."_free";
           $zfs{$t}=$p[3];

           $t=$p[0]."_cap";
           $zfs{$t}=$p[4];
           $zfs{$t}=~s/\D//g;  # 19% -> 19

           $t=$p[0]."_dedup_ratio";
           $zfs{$t}=$p[5];

           $t=$p[0]."_health";
           $zfs{$t}=$p[6];

           $t=$p[0]."_altroot";
           $zfs{$t}=$p[7];
        }


        # member disks
        $r=&exe('zpool status');
        #$r=~s/.*rpool/rpool/s;

        # NAME        STATE        READ  WRITE CKSUM
        #rpool       ONLINE        0     0     0
        #  mirror-0  ONLINE        0     0     0
        #    c1t0d0  ONLINE        0     0     0
        #    c1t2d0  ONLINE        0     0     0
        #caches
        #    c1t0d0  ONLINE        0     0     0

        @t=split(/\n/,$r);
        #&print_array(@t);

        # get poolinfo only
        my @new;
        foreach my $t (@t) {
            @p=split(/\s+/,$t);
            if ($p[6] ne "")      {  next; }             # resilver message
            if (!($t=~/\t/))      {  next; }
            if ($t=~/\tNAME /)    {  next; }

            $t=~s/^\t//;        # leading tab
            $t=~s/^  mirror/\tmirror/;
            $t=~s/^  raid/\traid/;
            $t=~s/^  +c/\tc/;     # disk

            $t=~s/ +/\t/g;
            push(@new,$t);
        }

         # [0] -> 'continue        ?to        ?function        ?in        ?a        ?degraded        ?state.'
         # [1] -> 'Run        ?'zpool        ?status        ?-v'        ?to        ?see        ?device        ?specific        ?details.'

        #@new
        # [0] -> 'rpool        ?ONLINE        ?0        ?0        ?0'
        # [1] -> '        c1t2d0        ?ONLINE        ?0        ?0        ?0'
        # [2] -> 'caches'
        # [3] -> '        c1t0d0        ?ONLINE        ?0        ?0        ?0'
        # [4] -> 'tank     ONLINE        ?0        ?0        ?0'
        # [5] -> '     >c1t1d0        ?ONLINE        ?0        ?0        ?0'

        my ($pool,$top,$vdev);
        $disk{'all_removable'}="";
        $disk{'all_addable'}="";
        $disk{'all_poolmember'}="";

        foreach my $n (@new) {
             @p=split(/\s+/,$n);
             if ($p[0]=~/\w/)          {          # pool or top level vdev
                $top=$p[0];
                if (!($top=~/spare|cache|log/)) { # it is a pool
                   $pool=$top;
                }
                next;
             }
             $vdev="basic";
             if ($p[1]=~/mirror|raid/) {        # pool or top level vdev
                 $vdev=$p[1];
                 next;
             }

             if ($p[1]=~/c\d/) {                 # a disk

                $disk{'all_poolmember'}.="\t$p[1]";
                $disk{'all_poolmember'}=~s/^\t//;

                if ($vdev=~/basic|mirror/)  {
                     $disk{'all_addable'}.="\t$p[1]";
                     $disk{'all_addable'}=~s/^\t//;
                }

                if ($vdev=~/mirror|spare|log|cache/)  {
                     $disk{'all_removable'}.="\t$p[1]";
                     $disk{'all_removable'}=~s/^\t//;
                }

                $t=$pool."_vdevs";
                $zfs{$t}.="\t$vdev";
                $zfs{$t}=~s/^\t//;

                $t=$pool."_memberdisks";
                $disk{$t}.="\t$p[1]";
                $disk{$t}=~s/^\t//;

                $t=$p[1]."_vdev";          # vdev of disk
                $disk{$t}=$vdev;

             }
        }

        # &print_array(@new);
        #&print_hash(%zfs);
        #&print_hash(%disk);

 }


###################### get datapools, allpools, vdevs, disks
sub get_zpool_openzfs  {
######################

    my ($pool,$vdev,$disk,$top,$sub,$type,@p,@ant,$k,$size,$free,$ant);

    $ant=&exe('zpool list -Hpv');

#&mess($ant);

    # get  NAME  SIZE  ALLOC  FREE  CKPOINT  EXPANDSZ   FRAG  CAP  DEDUP  HEALTH  ALTROOT
    #  #   0     1     2      3     4        5          6     7    8      9       10
    #zpool list -Hpv
    #
    #[0] -> 'tank   ->15703474176        ?260303872        ?15443170304        ?-        ?-        ?0        ?1        ?2.44        ?ONLINE        ?-'
    #[1] -> '       ->physicaldrive1        ?5358223360        ?256939520        ?4574898688        ?-        ?-        ?0        ?5        ?-        ?ONLINE'
    #[2] -> '         mirror-3        ?2013265920        ?0        ?2013265920        ?-        ?-        ?0        ?0        ?-        ?ONLINE'
    #[3] -> '         physicaldrive7        ?2136997888        ?-        ?-        ?-        ?-        ?-        ?-        ?-        ?ONLINE'
    #[4] -> '         physicaldrive8        ?2136997888        ?-        ?-        ?-        ?-        ?-        ?-        ?-        ?ONLINE'
    #[5] -> 'dedup                   -      -      -        -         -      -      -      -         -'
    #[6] -> '       ->physicaldrive9        ?2136997888        ?294912        ?2012971008        ?-        ?-        ?0        ?0        ?-        ?ONLINE'
    #[7] -> 'special                 -      -      -        -         -      -      -      -         -'
    #[8] -> '       ->mirror-1        ?2013265920        ?3009024        ?2010256896        ?-        ?-        ?1        ?0        ?-        ?ONLINE'
    #[9] -> '        physicaldrive5        ?2136997888        ?-        ?-        ?-        ?-        ?-        ?-        ?-        ?ONLINE'
    #[10] -> '       physicaldrive4        ?5358223360        ?-        ?-        ?-        ?-        ?-        ?-        ?-        ?ONLINE'
    #[11] -> '       physicaldrive2        ?5358223360        ?60416        ?4831777792        ?-        ?-        ?0        ?0        ?-        ?ONLINE'
    #[12] -> 'logs                    -      -      -        -         -      -      -      -         -'
    #[13] -> '     ->physicaldrive3        ?5358223360        ?0        ?4831838208        ?-        ?-        ?0        ?0        ?-        ?ONLINE'
    #[14] -> 'cache                   -      -      -        -         -      -      -      -         -'
    #[15] -> '     ->physicaldrive6        ?2136997888        ?4643328        ?2127635456        ?-        ?-        ?0        ?0        ?-        ?ONLINE'        -        ONLINE

    # &b_convert($data,"b","s")       1000 -> 1KB     adminlib

    my ($k);
    if ($ant=~/^error/) {
       &mess("zpool list -Hpv <hr>$ant");
    }

    $zfs{'allpools'}="";
    $zfs{'allpool_health'}="yes";
    $zfs{'allpool_cap'}="yes";                                                # cap < 80%

    #dedup_used (%), pool_dedup_size, pool_dedup_size2 (bd), pool_dedupratio
    #$t="$pool\_dedup_used";
    #   $zfs{$t}=($size-$free)/$size*100;
    #   $zfs{$t}=sprintf("%.2f", $zfs{$t});

    #pool_special_size, special_size2 (bd), special_free, pool_special_used


    ################################### parse list ################################
    my @ant=split(/\n/,$ant);
    foreach my $l (@ant) {

#&print_array(@ant);
          @p=split(/\t/,$l);

          # basic, mirror or raid devices have a cap value p[7], disks have not
          if ($p[7]=~/\d/) {
            $type="dev";
            $vdev="basic";
          } else {
            $type="disk";
          }

          if (($p[8]=~/^\d/) && ($p[0]=~/\w/)) {            # top=pool, has dedup entry
             $top="pool";
             $type="poolname";
             $vdev="none";
          }

          #top: pool or dev like dedup, special, cache, log, spare

          if ($p[0]=~/logs|cache|spare|special|dedup/)    {           # pool or dev
             $p[0]=~s/[^a-z]//g;                # removw "-"
             $top="$p[0]";
             $type="dev";
          }


          if ($p[1]=~/raid|mirror/)      {   # or line is mirror, raid  (draid/raidz)
              $vdev=$p[1];
          }

          #print "# $top, $vdev, $type  -> $l<br>";

          # pool, none, poolname -> tank 15703474176 260303872 15443170304 - - 0 1 2.44 ONLINE -
          # pool, basic, dev -> physicaldrive1 5358223360 256939520 4574898688 - - 0 5 - ONLINE
          # pool, mirror-3, dev -> mirror-3 2013265920 0 2013265920 - - 0 0 - ONLINE
          # pool, mirror-3, disk -> physicaldrive7 2136997888 - - - - - - - ONLINE
          # pool, mirror-3, disk -> physicaldrive8 2136997888 - - - - - - - ONLINE
          # dedup, mirror-3, dev -> dedup - - - - - - - - -
          # dedup, basic, dev -> physicaldrive9 2136997888 294912 2012971008 - - 0 0 - ONLINE
          # special, basic, dev -> special - - - - - - - - -
          # special, mirror-1, dev -> mirror-1 2013265920 3009024 2010256896 - - 1 0 - ONLINE
          # special, mirror-1, disk -> physicaldrive5 2136997888 - - - - - - - ONLINE
          # special, mirror-1, disk -> physicaldrive4 5358223360 - - - - - - - ONLINE
          # special, basic, dev -> physicaldrive2 5358223360 60416 4831777792 - - 0 0 - ONLINE
          # logs, basic, dev -> logs - - - - - - - - -
          # logs, basic, dev -> physicaldrive3 5358223360 0 4831838208 - - 0 0 - ONLINE
          # cache, basic, dev -> cache - - - - - - - - -
          # cache, basic, dev -> physicaldrive6 2136997888 4643328 2127635456 - - 0 0 - ONLINE

          # we have a (new) pool
          if (($p[8]=~/^\d/) && ($p[0]=~/\w/)) {            # top=pool, has dedup entry
             # line is pool: name,size,alloc,free,chkpoint,expandsz,frag,cap,dedup,health,altroot
             #          0    1    2     3    4        5        6    7   8     9      10

             $pool=$p[0];

             if (!($zfs{'allpools'}=~/\b$pool\b/)) {
                $zfs{'allpools'}.="\t$pool";
                $zfs{'allpools'}=~s/^\t+//;
             }

             if (!($pool=~/rpool/)) {
                if (!($zfs{'datapools'}=~/\b$pool\b/)) {
                   $zfs{'datapools'}.="\t$pool";
                   $zfs{'datapools'}=~s/^\t+//;
                }
             }

             $k="$pool\_size";
             $zfs{$k}=&b_convert($p[1],'b','s');

             $k="$pool\_alloc";
             $zfs{$k}=&b_convert($p[2],'b','s');

             $k="$pool\_free";
             $zfs{$k}=&b_convert($p[3],'b','s');

             $k="$pool\_ckpoint";
             $zfs{$k}=$p[4];

             $k="$pool\_health";
             $zfs{$k}=$p[5];

             $k="$pool\_frag";
             $zfs{$k}=$p[6];

             $k="$pool\_cap";
             $zfs{$k}=$p[7];
             if ($zfs{$k}>79) {  $zfs{'allpool_cap'}="no"; }      # used cap <80%

             $k="$pool\_dedup_ratio";
             $zfs{$k}=$p[8];

             $k="$pool\_health";
             $zfs{$k}=$p[9];
             if ($zfs{$k} ne "ONLINE") { $zfs{'allpool_health'}="no";  }

             $k="$pool\_altroot";
             $zfs{$k}=$p[10];

             next;

          }  # end of pool line

          # next line, can be disk or vdev type
          #print "# $top, $vdev, $type  -> $l<br>";

          # is  vdev: -,type,size,alloc,free,-,-,frag,cap,-,health
          #           0 1    2    3     4    5 6 7    8   9 10

          if ($top eq "pool")    {          # a pool has vdevs -> basic,mirror,raid  with health

#print "# $top, $vdev, $type  -> $l<br>";               # we have a vdev definition
              if  ($vdev=~/mirror|raid/)    {                 # # pool, mirror-3, dev -> mirror-3 2013265920 0 2013265920 - - 0 0 - ONLINE

                  $k="$pool\_vdevs";
                  if (!($zfs{$k}=~/$vdev/)) {
                    $zfs{$k}.="\t$vdev";
                     $zfs{$k}=~s/^\t+//;
                  }

                  $k="$vdev\_size";
                  $zfs{$k}=&b_convert($p[2],'b','s');

                  $k="$vdev\_alloc";
                  $zfs{$k}=&b_convert($p[3],'b','s');

                  $k="$vdev\_free";
                  $zfs{$k}=&b_convert($p[4],'b','s');

                  $k="$vdev\_frag";
                  $zfs{$k}=$p[7];

                  $k="$vdev\_cap";
                  $zfs{$k}=$p[8];

                  $k="$vdev\_health";
                  $zfs{$k}=$p[10];

                  $k="$p[1]\_vdev";        # vdev type of disk
                  $zfs{$k}="$vdev";

                  $k="$p[1]\_pool";        # pool of disk
                  $disk{$k}="$pool";

                  # removable
                  if ($vdev=~/mirror|cache|log|spare/) {
                      $k="all_removable";
                      $disk{$k}.="\t$p[1]"; $disk{$k}=~s/^\t+//;
                  }

                  # all_addable
                  if ($vdev=~/mirror|basic/) {
                      $k="all_addable";
                      $disk{$k}.="\t$p[1]"; $disk{$k}=~s/^\t+//;
                  }

                  if (!($p[1]=~/mirror|raid/)) {   # is a disk

                     $k="all_poolmember";
                     $disk{$k}.="\t$p[1]";
                     $disk{$k}=~s/^\t+//;

                     $k="$p[1]_health";
                     $zfs{$k}=$p[10];

                     $k="$pool\_memberdisks";
                     $disk{$k}.="\t$p[1]";
                     $disk{$k}=~s/^\t+//;
                  }

                  next;                    # next line


              }   else {                   # or we have a disk/ any basic vdev in pool
                                           # pool, basic, dev -> physicaldrive1 5358223360 256939520 4574898688 - - 0 5 - ONLINE

                  #$vdev="basic";
                  $k="$pool\_vdevs";

                  if (!($zfs{$k}=~/basic/)) {
                    $zfs{$k}.="\tbasic";
                    $zfs{$k}=~s/^\t+//;
                  }

                  $k="$p[1]\_vdev";          # vdev type of disk
                  $zfs{$k}="basic";

                  #pool of disk
                  $k="$p[1]\_pool";          # pool of disk
                  $disk{$k}="$pool";

                  # removeable
                  if ($vdev=~/mirror|cache|log|spare/) {
                      $k="all_removable";
                      $disk{$k}.="\t$p[1]"; $disk{$k}=~s/^\t+//;
                  }

                  # all_addable
                  if ($vdev=~/mirror|basic/) {
                      $k="all_addable";
                      $disk{$k}.="\t$p[1]"; $disk{$k}=~s/^\t+//;
                  }

                  # health  of basic vdev
                  $k="$p[1]\_health";
                  $zfs{$k}=$p[10];            # basic vdev health

                  $k="all_poolmember";
                  $disk{$k}.="\t$p[1]";
                  $disk{$k}=~s/^\t+//;

                  $k="$pool\_memberdisks";
                  $disk{$k}.="\t$p[1]";
                  $disk{$k}=~s/^\t+//;

                  next;
              }

          }   # end of pool

 #&print_array(@p);
          if ($top=~/logs|cache|spare|special|dedup/)   {             # another  vdev, no health or size
              #
              $k="$pool\_vdevs";
              if (!($zfs{$k}=~/$vdev/)) {
                  $zfs{$k}.="\t$vdev";
                  $zfs{$k}=~s/^\t+//;
              }

              if ($top eq "special") {

                     $k="$pool\_special_vdev";          # has special vdev
                     $zfs{$k}="1";

                     if ($p[0]=~/special/) { next; }     # goto next line with mirror or basic and size

                     if ($vdev=~/basic|mirror/)  {
#&print_array(@p);
                        $t="$pool\_special_size";
                        $zfs{$t}=$zfs{$t}+$p[2];
                        $size=$zfs{$t};

                        $t="$pool\_special_size2";
                        $zfs{$t}=&b_convert($size,"b","d");

                        $t="$pool\_special_free";
                        $zfs{$t}=$zfs{$t}+$p[4];
                        $free=$zfs{$t};

                        $t="$pool\_special_used";
                        $zfs{$t}=($size-$free)/$size*100;
                        $zfs{$t}=sprintf("%.2f", $zfs{$t});
                        $zfs{$t}.='%';

                     }
               }  #/special

               if ($top eq "dedup") {
                     $k="$pool\_dedup_vdev";            # has dedup vdev
                     $zfs{$k}="1";

                     if ($p[0]=~/dedup/) { next; }     # goto next line with mirror or basic and size

                     if ($vdev=~/basic|mirror/)  {

                        $t="$pool\_dedup_size";
                        $zfs{$t}=$zfs{$t}+$p[2];
                        $size=$zfs{$t};

                        $t="$pool\_dedup_size2";
                        $zfs{$t}=&b_convert($size,"b","d");

                        $t="$pool\_dedup_free";
                        $zfs{$t}=$zfs{$t}+$p[4];
                        $free=$zfs{$t};

                        $t="$pool\_dedup_used";
                        $zfs{$t}=($size-$free)/$size*100;
                        $zfs{$t}=sprintf("%.2f", $zfs{$t});
                        $zfs{$t}.='%';

                     }
               }  #/deduo

               if ($top=~/logs|cache|spare/)   {
                       if ($p[0]=~/$top/) { next; }     # goto next line with mirror or basic and size
               }   #/vdevs

#print "# $top, $vdev, $type  -> $l<br>";
               if (($type eq "disk") || ($vdev eq "basic")) {
                  $k="$p[1]\_vdev";          # vdev type of disk
                  $zfs{$k}="$top";

                  #pool of disk
                  $k="$p[1]\_pool";          # vdev type of disk
                  $disk{$k}="$pool";

                  # removeable
                  if ($top=~/mirror|cache|log|spare/) {
                      $k="all_removable";
                      $disk{$k}.="\t$p[1]"; $disk{$k}=~s/^\t+//;
                  }

                  # addable, disk and basic
                  #
                      $k="all_addable";
                      $disk{$k}.="\t$p[1]"; $disk{$k}=~s/^\t+//;
                  #

                  $k="all_poolmember";
                  $disk{$k}.="\t$p[1]";
                  $disk{$k}=~s/^\t+//;

                  $k="$p[1]_health";
                  $zfs{$k}=$p[10];
               }

               next;                     # next line basic vdev disk or another vdev
          }

          #&print_array(@p);

    }


    #debug
    #print "Content-type: text/html\n\n";
    #&print_hash(%disk);

}


sub get_ldate {
###############

return;

#print "Content-type: text/html\n\n";

    my ($ant,@old,@new,$ok,$k,$date,$d,$diff,$ref,$r,@l,@w,$h,$s,$short,$id);


    $sys{'edition'}="Free";       # free license
   # $sys{'version2'}="Free";     # napp-it
   # if ($sys{'version'}>=20) {   $sys{'version2'}="Pro";  }       # alt

    if (-f "$wpath/appliance.log") {
       $ant=`cat $wpath/_log/appliance.log`;

       @old=split(/\n/,$ant);
       foreach my $li (@old) {

              $ok="";
              $k="0";
              $s="1";             # wrong key

              if (!($li=~/::/)) { push (@new,$li); next; }

              @w=split(/\|/,$li);

              $h=$w[1];
              $h=~s/.*h:/h:/;
              $h=~s/ \- .*//;
              $h=~s/\_.*//;  # opt name
              $id=&get_hid;   # $id=hid (first mac address),  sysdef id in %sys,

              # mid
              # host without [lem]90
              $short=$h;
              $short=~s/.90$//;
#print "Content-type: text/html\n\n"; &mess("$t<br>$short");

              if (!($id=~/$short/)) {

                   # on aio check only partly
                   $s="1";
                   if (length($id) <= 15) {
                      $s=$id;
                      $s=~s/h:m//;
                      if ($h=~/$s/) { $s="0"; } else { $s="1"; }

                   }

                   #check against sysdef
                   #$t=&sysdef($w[1]);

    #print "Content-type: text/html\n\n";
    #&error("$t<br>$h<br>$sys{'sysdef'}");
    #&print_hash(%sys);

                   if ($h eq $sys{'sysdef'}) {  # old
                      $id=$sys{'sysdef'};
                      $s="0";
                   }
              }

              # check always against all mac
         #     $r=`sudo /usr/sbin/dladm show-phys -m -o ADDRESS | grep :`;  # mac from DEVICE->LINK
              chomp($r);

              $r=~s/://gs;
              $h=~s/h:m//;
              $h=~s/.90$//;
              if ($r=~/$h/is) {
                   $s="0";
              }

              #  last check
              if (($h=~/\w+/) && ($id=~/\w+/) && ($id=~/$h/)) { $s="0"; }  # ex $h=d37d31032850 and $t=h:md37d31032850e90
 #print "Content-type: text/html\n\n"; &mess("$h<br>$t<br>$s");

              if ($id=~/unknown/) { $s="0"; }  # unknown failure of nic detection
              if ($sys{'version'}=~/de/) { $s="0"; }       # dev release
              if ($s) {
                         #
                         open (PF, ">>$tpath/k.log");
                               print PF "$li (wrong machine id $sys{'date_us'}\n";
                               print PF "$ant\n";
                         close (PF);

                         open (PF, ">>$wpath/_log/appliance.oldkey");
                               print PF "$li (wrong machine id $sys{'date_us'} \'$id\',\'$h\')\n";                                     # \n at the end
                         close (PF);
                         $ok.="0";
              }


              #valid
              $t=&getv2($w[1]);
     #&mess($ok);
              if (!($t=~/\d\d\d\d/)) {
                   open (PF, ">>$wpath/_log/appliance.oldkey");
                         print PF "$li (date expired or invalid key)\n";                                     # \n at the end
                   close (PF);
                   $ok.="0";
              }


              if (!($ok=~/0/)) {

                       $sys{'edition'}="Pro";

                       if ($w[1]=~/^complete/) {
                            if (!($cfg{'ver'}=~/c/)) { $cfg{'ver'}.="c"; }
                            if (!($cfg{'ver'}=~/a/)) { $cfg{'ver'}.="a"; }
                            if (!($cfg{'ver'}=~/r/)) { $cfg{'ver'}.="r"; }
                            if (!($cfg{'ver'}=~/m/)) { $cfg{'ver'}.="m"; }
                        }
                        if ($w[1]=~/\_eval/) {
                            if (!($cfg{'ver'}=~/e/)) { $cfg{'ver'}.="e"; }
                        }
                        if ($w[1]=~/\_home|\_noncom/) {
                            if (!($cfg{'ver'}=~/h/)) { $cfg{'ver'}.="h"; }
                        }
                        if (($w[1]=~/acl/) && (!($cfg{'ver'}=~/a/))) {$cfg{'ver'}.="a";  }
                        if (($w[1]=~/mon/) && (!($cfg{'ver'}=~/m/))) {$cfg{'ver'}.="m";  }
                        if (($w[1]=~/rep/) && (!($cfg{'ver'}=~/r/))) {$cfg{'ver'}.="r";  }
                        if (!($cfg{'ver'}=~/p/)) {$cfg{'ver'}.="p";  }
              }

              if (!($ok=~/0/)) {
                     push (@new,$li);
              }
        }

        if (@new < @old) {
             $t=join("\n",@new);
             open (PF, ">$wpath/_log/appliance.log");
                  print PF "$t";                                     # \n at the end
             close (PF);
             &read_ahfile("$wpath/_log/appliance.log","cfg","h+");                    #read appliance-info -> %cfg
        }
    }


    #edition
    if (!($cfg{'ver'} =~/c|m/)) {
       # &exe("touch /var/web-gui/_log/napp-it_ws_off");
       # &about_stat_disable;

    }

    if (!($cfg{'ver'} =~/\w/))  {
      #  &exe("touch /var/web-gui/_log/napp-it_acc_off");
       # &about_acc_disable;
    }

}



# eof
1;