#!
# keyserver lib
# (c) Guenther Alka, 2019-2020
# 17.mar.2020

$p{'key_par'}='fsid=&hostid=&action=&keypart=&hostname=&data=';         # use this data for post

##############
sub key_get_idxx {  # (full fs name ex pool/date/sub), return poolguid;creation;enc_id;fullname
##############
   # id from pool guid, creation and name
   &mess("obsolete, id = pool/fs");
}

################# get key from local or web
sub key_get_lw {
#################
  my $fs=$_[0];

  $fs=~s/ /_/gs;
  $fs=~s/\//~/gs;

  my $split=$_[1];
  $split=~s/[^LW\d:]//g;
  my @w=split(/:/,$split);

  my ($f1,$f2,$r,$k1,$k2,$key);

  # debug
  # &print_hash(%cfg);

  if ($w[0] eq "L1") {       # L1:L1 or L1:W1
    $f1="/$cfg{'value_keydata_fs'}/local/keys-part1/$fs.kp1";

    $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
    # &mess("$w[0]<br>$f1");

    if ($r eq "2") {
      &mess("Keyfile part 1 on L1: not found<br>$f1");
    }  else {
      $k1=`sudo cat $f1`;
      # &mess($k1);
      if (!($k1=~/\w+/)) {  &mess("Keyfile part 1 on L1: no data<br>$f1");}
    }
    $key=$k1;
  }

  if ($w[1] eq "L1") {  # L1:L1
    $f2="/$cfg{'value_keydata_fs'}/local/keys-part2/$fs.kp2";

    $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
    # &mess("$w[0]<br>$f1");

    if ($r eq "2") {
      &mess("Keyfile part 2 on L1: not found<br>$f2");
    }  else {
      $k2=`sudo cat $f2 2>/dev/null`;
      # &mess($k2);
      if (!($k2=~/\w+/)) {  &mess("Keyfile part 2 on L1: no data<br>$f2");}
    }
    $key.=$k2;
    $key=~s/[^A-Za-z0-9]//g;
    return($key);
  }

  # L2,W1,W2

  if ($w[1] eq "L2") {  # L1:L2
       $f2="/$cfg{'value_keydata_fs2'}/local/keys-part2/$fs.kp2";

       $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
       # &mess("$w[0]<br>$f2");

       if ($r eq "2") {
         &mess("Keyfile part 2 on L1: not found<br>$f2");
       }  else {
         $k2=`sudo cat $f2 2>/dev/null`;
         # &mess($k2);
         if (!($k2=~/\w+/)) {  &mess("Keyfile part 2 on L2: no data<br>$f2");}
       }
       $key.=$k2;
       #&mess($key);
       return($key);
  }

  #if ($split=~/W/) { &mess("key_get_lw: W todo"); }
  #&mess(__LINE__);
  #&print_hash(%cfg);


  if ($w[0] eq "W1") {  # W1:W1 or W1:W2
       if (!($cfg{'value_key_server1'}=~/:\/\/\w/))    { &mess('W1 not defined in About &gt; Settings'); }

       $t=$p{'key_par'};
       $r=&my_read_web($cfg{'value_key_server1'},$fs,'1');   # server, fsid, part
       if ($r=~/error/) { &mess("Keyfile part1 on W1<br>$r"); }
       $r=~s/.*ok, //;
       $key=$r;
  }

  if ($w[1] eq "W1") {  # L1:W1 or W1:W1
       if (!($cfg{'value_key_server1'}=~/:\/\/\w/))    { &mess('W1 not defined in About &gt; Settings'); }

       $t=$p{'key_par'};
       $r=&my_read_web($cfg{'value_key_server1'},$fs,'2');   # server, fsid, part
       if ($r=~/error/) { &mess("Keyfile part2 on W1<br>$r"); }
       $r=~s/.*ok, //;
       $key.=$r;
       $key=~s/[^A-Za-z0-9]//g;
       return($key);
  }

  if ($w[1] eq "W2") {  # W1:W2
       if (!($cfg{'value_key_server2'}=~/:\/\/\w/))    { &mess('W1 not defined in About &gt; Settings'); }

       $t=$p{'key_par'};
       $r=&my_read_web($cfg{'value_key_server2'},$fs,'2');   # server, fsid, part
       if ($r=~/error/) { &mess("Keyfile part2 on W2<br>$r"); }
       $r=~s/.*ok, //;
       $key.=$r;
#&mess("-$key-");
       $key=~s/[^A-Za-z0-9]//g;
       return($key);
  }

  &error("unexpected error at sub key_get_lw");
  &print_hash(%p);


}

################
sub my_read_web {  # server, fsid, part
################
my $server=$_[0];
my $fsid=$_[1];
my $part=$_[2];

               my $par=$p{'key_par'};

               #hostid
               $par=~s/hostid=/hostid=$cfg{'value_key_hostid'}/;      ## ex: 'keyserver.pl?&fsid=&hostid=&action=&part=&hostname=&data='

               #fsid
               $par=~s/fsid=/fsid=$fsid/;

               #hostname
               $t=`hostname`; chomp($t);
               $par=~s/hostname=/hostname=$t/;

               # action
               $par=~s/action=/action=get/;

               #part
               $par=~s/part=/part=$part/;

               #read
               my $r=&call_key_web($server,"$par");            # keylib  webserver, data
               return ($r);

}

#################
sub key_get_smbak {  # from hash of first 8 char of key
################
   my $t=$_[0];

   if ($t=~/error,/)          { return("error smb keydata");  }
   $t=~s/^.* //;              # keyserver:ok, VSNaP
   $t=substr($t,0,8);
   if (!($t=~/[a-zA-Z0-9]+/)) { return("invalid smb keydata");  }

   $t=crypt($t,"ab");         # this is used to lock/unlock via smb
   $t=~s/[^a-zA-Z0-9]//g;     # text only

   return ($t);               # no special char like /
}

#################  /usb/keyfiles or ../usb/keyfiles, check folders and perm (napp-it)
sub verify_keyfolder {
#################
   # check folder local1, local2 and keyserver

   # "mobile pool (mirror)": usb (oder fs usb), defines in About > Settings  ex usb/keydata
   # local keys
   #              ZFS Dateisystem: usb/keydata1/local                  (root only)
   #              normaler Ordner: usb/keydata1/local/keys-part1
   #              normaler Ordner: usb/keydata1/local/keys-part2
   #              normaler Ordner: usb/keydata1/local/logs

   #              ZFS Dateisystem: usb/keydata2/local                  (root only, opt, can be same as keydata1
   #              normaler Ordner: usb/keydata2/local/keys-part1
   #              normaler Ordner: usb/keydata2/local/keys-part2


   # keyserver:
   #              ZFS Dateisystem: usb/keydata/keyserver/                  (root only, can be same as keydata1)
   #              normaler Ordner: usb/keydata/keyserver/clid/keys-part1
   #              normaler Ordner: usb/keydata/keyserver/clid/keys-part2
   #              normaler Ordner: usb/keydata/keyserver/clid/logs

   my ($r,$f);

   #  check fs1
   if (!($cfg{'value_keydata_fs'}=~/\/\w/)) { &mess("Please define a filesystem-1 for local key data ex usb/keydata in About > Settings"); }

   $r=`sudo test -d "/$cfg{'value_keydata_fs'}" && echo 1 || echo 2`;  chomp($r);
   if ($r eq "2") {
       &mess("Filesystem $cfg{'value_keydata_fs'} not found,<br>please define a filesystem for local and keyserver data ex usb/keydata in About > Settings");
   }

   # check local autolock folders

         $r=`sudo test -d "/var/web-gui/_log/autolock" && echo 1 || echo 2`;  chomp($r);      # settings like local2, web2 and ha
         if ($r eq "2") { `sudo mkdir /var/web-gui/_log/autolock`; }

   # check local fs1

         $r=`sudo test -d "/$cfg{'value_keydata_fs'}/local" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs'}/local`; }

         $r=`sudo test -d "/$cfg{'value_keydata_fs'}/local/logs" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs'}/local/logs`; }

         $r=`sudo test -d "/$cfg{'value_keydata_fs'}/local/keys-part1" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs'}/local/keys-part1`; }

         $r=`sudo test -d "/$cfg{'value_keydata_fs'}/local/keys-part2" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs'}/local/keys-part2`; }

         `sudo /bin/chown -R root /$cfg{'value_keydata_fs'}/local  2> /dev/null`;            # root only
         `sudo /bin/chmod -R 700 /$cfg{'value_keydata_fs'}/local  2> /dev/null`;

  # check fs2

  if ($cfg{'value_keydata_fs2'}=~/\/\w/) {
         $r=`sudo test -d "/$cfg{'value_keydata_fs2'}" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") {
            &mess("Filesystem-2 $cfg{'value_keydata_fs2'} not found,<br>please create a filesystem-2 for local keydata ex usb/keydata in About > Settings");
         }

         $r=`sudo test -d "/$cfg{'value_keydata_fs2'}/local" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs2'}/local`; }

         $r=`sudo test -d "/$cfg{'value_keydata_fs2'}/local/logs" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs2'}/local/logs`; }

         $r=`sudo test -d "/$cfg{'value_keydata_fs2'}/local/keys-part1" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs2'}/local/keys-part1`; }

         $r=`sudo test -d "/$cfg{'value_keydata_fs2'}/local/keys-part2" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keydata_fs2'}/local/keys-part2`; }

         `sudo /bin/chown -R root /$cfg{'value_keydata_fs2'}/local 2>/dev/null`;            # root only
         `sudo /bin/chmod -R 700 /$cfg{'value_keydata_fs2'}/local  2>/dev/null`;
  }

  #check keyserver folder
  if ($cfg{'value_keyserver_fs'}=~/\/\w/) {
         $r=`sudo test -d "/$cfg{'value_keyserver_fs'}" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") {
            &mess("Keyserver filesystem $cfg{'value_keyserver_fs'} not found,<br>please create a filesystem-2 for keyserver keydata ex usb/keydata in About > Settings");
         }

         $r=`sudo test -d "/$cfg{'value_keyserver_fs'}/keyserver" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keyserver_fs'}/keyserver`; }

         $r=`sudo test -d "/$cfg{'value_keyserver_fs'}/keyserver/clients" && echo 1 || echo 2`;  chomp($r);    # with keys below
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keyserver_fs'}/keyserver/clients`; }

         $r=`sudo test -d "/$cfg{'value_keyserver_fs'}/keyserver/timetables" && echo 1 || echo 2`;  chomp($r);    # with keys below
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keyserver_fs'}/keyserver/timetables`; }

         $r=`sudo test -d "/$cfg{'value_keyserver_fs'}/keyserver/logs" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo mkdir /$cfg{'value_keyserver_fs'}/keyserver/logs`; }

         $r=`sudo test -f "/$cfg{'value_keyserver_fs'}/keyserver/defaults.cfg" && echo 1 || echo 2`;  chomp($r);
         if ($r eq "2") { `sudo touch /$cfg{'value_keyserver_fs'}/keyserver/defaults.cfg`; }

         `sudo /bin/chown -R root /$cfg{'value_keyserver_fs'}/keyserver  2> /dev/null`;            # root only
         `sudo /bin/chmod -R 700 /$cfg{'value_keyserver_fs'}/keyserver  2> /dev/null`;

   }

   return($f);
}




#######################
sub get_hasht_from_str {
#######################
 #ex  keydata_fs|tank/usb/keydata|\n
 #    keydata_fs2|tank/keydata2|
 my (@w,@l,$str);
 %t=();
 $str=$_[0];

 @l=split(/\n/,$str);
 foreach my $l (@l) {
     @w=();
     @w=split(/\|/,$l);
     if ($w[0]=~/\w/) {
        $t{$w[0]}=$w[1];
     }
 }
}



 #################
 sub get_key_status {     # keyserver status inServices > Keyserver
 #################

     # keyserver settings ->
     my ($r);
     if ($cfg{'ver'} =~/c/)                                                                     { $p{'keyserver_l'}="ok, complete license"; }  else { $p{'keyserver_l'}="complete license required";  }

     # keydata folder?

     $r=`sudo test -f "/$cfg{'value_keydata_fs'}/keyserver/defaults.cfg" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "1") {
            $p{'keyserver_a'}="yes";
     } else {
            $p{'keyserver_a'}="Keydata filesystem and configuration not available or locked";
     }

 }


 #################
 sub get_key_defaults {
 #################
   &verify_keyfolder;                # usb/keyfolder or tank/usb/keyfolder
   $r=`sudo test -f "/$cfg{'value_keyserver_fs'}/keyserver/defaults.cfg" && echo 1 || echo 2`;  chomp($r);
   if ($r eq "1") {
      &get_key_par("/$cfg{'value_keyserver_fs'}/keyserver/defaults.cfg","p");  # > %p
   }
   #&mess($f);
 }


 #################
 sub get_key_par {
 #################   keys to hash %p from file key|val|
   my (@l,$r,@w,$k);
   my $file=$_[0];
   my $hash=$_[1];      # p, t, current etc
   if ($hash eq "") { $hash="p"; }

   $r=&perm_read("$file");

   #&mess("$file<hr>$r");
   #print "file=$file\n";

   @l=split(/\n/,$r);
   foreach my $l (@l) {
         if ($l=~/^\#/)   { next; }     # comment
         if (!($l=~/\|/)) { next; }     # no data
         @w=split(/\|/,$l);
         if ($w[0] ne "") {
            $p{$w[0]}=$w[1];
            #$k=$w[0]; $k=~s/value\_|select\_//;
            $$hash{$k}=$w[1];         # set %current p{'value_key'} -> current{'key'}
         }
   }
   #&print_var($file);
   #&print_hash(%current);

 }


 #############  salt 8 char
 sub get_key_salt {
    my @chars = ("A".."Z", "a".."z", "0".."9");
    my $salt;
   $string .= $chars[rand @chars] for 1..8;
   return($string);
 }

 #################
 sub get_keysplit {
   my $key=$_[0];

   my $len=int(length($key)/2);
   if ($len<4) { &mess("keysplit error: min key length=8 char"); }
   my $k1=substr($key,0,$len);
   my $k2=substr($key,$len);

   #&mess("$key<br>$k1<br>$k2");
   return("$k1","$k2")
 }


 #############   # echo -n "That's the text"|openssl enc -e -aes-256-cbc -a -A -pass pass:123
 sub get_enc {
    my $data=$_[0];
    my $pass=$_[1];
    $pass=~s/ +//g;

    &mess("Solaris only");

    if (-f "/bin/openssl") {
      $str=`echo -n \"$data\" | /bin/openssl enc -e -aes-256-cbc -a -A -pass pass:$pass`;  chomp($str);
         return($str);
     } else {
        &mess("/bin/openssl not found");
    }
 }
 #############  # echo -n "U2FsdGVkX1/ITs/ThkwuzkZJYb8vaZ/yqbMySxqy01g=" | openssl enc -d -aes-256-cbc -a -A -pass pass:123
 sub get_dec {
    my $data=$_[0];
    my $pass=$_[1];
    $pass=~s/ +//g;

    &mess("Solaris only");

    if (-f "/bin/openssl") {
         $str=`echo -n \"$data\" | /bin/openssl enc -d -aes-256-cbc -a -A -pass pass:$pass`;  chomp($str);
         return($str);           # That's the text
     } else {
        &mess("/bin/openssl not found");
    }
 }


#############
sub get_random_ascii {
#############
  my ($t);
  my $n=$_[0];
  $n=~s/\D//g;
  if (!($n>0)) { $n="32"; }

  my @chars = ("A".."Z", "a".."z", "0".."9");
  my $string;
  $string .= $chars[rand @chars] for 1..$n;

  #&mess($string);
  return ($string);


  # opt
  $t=$n*2;
  my $str=`/bin/openssl rand $t -base64 2> /dev/null`;     # Solaris only
  $str=~s/[^a-zA-Z0-9]//g;
  $str=substr($str,0,$n);
  #&mess($str);
  return ($str);
}

#############  ok -> 1
 sub verify_pw_hash {
  my ($pw,$method,$salt,$hash,$check);
  $pw=$_[0];
  $hash=$_[1];

  $salt=$hash;

  # pwhash manually deleted or set to cleartext
  if (length($hash)<=10) {
    if ($hash eq $pw) { return(1); }
  }

  if (!($salt =~/^\$/)) {       # internal, Perl
      $check=crypt($pw,$salt);
      if ($hash eq $check) { return(1) } else { return (0); }
  } else {
      $salt=~s/^\$\d\$//; $salt=~s/\$.*//;  # openssl $1$XsVzfvTp$Ot6lPxKygER1sxfIAyy/A/
      if (-f "/bin/openssl") {
         $check=`/bin/openssl passwd -1 -salt $salt $pw`; chomp($hash);   chomp($check);
         if ($hash eq $check) { return(1) } else { return (0); }
      } else {
        &mess("/bin/openssl not found");
      }
  }
 }


 ############
 sub perm_read {      # read when perm=700, data also in @t
     ##
     my ($f,$file,$r,$d,$data,@data,$nomess,$perm,$opt,$t);
     $file=$_[0];
     $nomess=$_[1];
     $perm=$_[2];

     $r=`sudo test -f "$file" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "2") {
          if ($nomess ne "") {
            return();
          } else {
            &mess("cannot access file $file");
          }
     }
     #copy to temp
     $t=crypt($file,"ab");      # temp file
     $t=~s/[^a-zA-Z0-9]//g;     # text only

     $f="/tmp/$t.tmp";
     `sudo cp $file $f`;
     `sudo /usr/bin/chmod 444 $f 2>/dev/null`;


     @t=();
     open (F,"<$f");
        flock(F, LOCK_EX);
        @data=<F>;
     close (F);
     `sudo rm $f`;

     if ($perm=~/^\d\d\d$/) {
       `sudo /usr/bin/chmod $perm $file 2>/dev/null`;
     }
     $data=join("",@data);
     return($data);
 }

 ############         # write when file perm=700 (dir=755)
 sub perm_write {
     ##
     my ($f,$file,$r,$dir,$data,$user,$t);
     $file=$_[0];
     $data=$_[1];       # string
     $perm=$_[2];
     $user=$_[3];

     $r=rindex($file,'/');
     $dir=substr($file,0,$r);
     $r=`sudo test -d "$dir" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "2") { &mess("cannot access directory $dir"); }

     #create on temp
     $t=crypt($file,"ab");      # temp file
     $t=~s/[^a-zA-Z0-9]//g;     # text only

     $f="/tmp/$t.tmp";
     `sudo touch $f`;
     `sudo /usr/bin/chmod 666 $f 2>/dev/null`;

     #&mess($data);
     open (PF, ">$f");
       flock(PF, LOCK_EX);
       print PF "$data";
     close (PF);

     `sudo cp $f $file`;
     `sudo rm $f`;
     if ($perm=~/^\d\d\d$/) {
       `sudo /usr/bin/chmod $perm $file 2>/dev/null`;
     }
     if ($user=~/\w+/) {
       `sudo /usr/bin/chown $user $file 2>/dev/null`;
     }

     $r=`sudo test -f "$file" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "1") {
          return("");
     } else {
          return("error: could not write $file");
     }


 }

 #################
 sub save_key_local {
   my $file=$_[0];
   my $data=$_[1];     # keypart ex file.kp1 or file.kp2

   # write
   &perm_write("$file","$data","700");
   my  $r=`sudo test -f "$file" && echo 1 || echo 2`;  chomp($r);

  if ($r eq "1") {
    return ();
  } else {
    return (" Could not create keyfile part $file");
  }

 }

#################
 sub call_key_web {
   my $ws=$_[0];       # webserver ex https://abd.dd
   my $data=$_[1];     # data 'fsid=&hostid=&action=&part=&hostname=&data='
   my $r;

   $ws=~s/\s//g;
   `sudo echo \"call_key_web: check $ws\"`;

   $ws=~s/\/$//;
   $r=`wget -O - --tries=1 --timeout=3 --no-check-certificate --post-data \"$data\" $ws/cgi-bin/keyserver.pl 2>/dev/null`;
   chomp($r);

   # write
   if ($r eq "") {
     return("error, no answer");
   } else {
     return("$r");
   }
 }



 #############
 sub get_key_hash {
  my ($pw,$method,$salt,$hash);
  $pw=$_[0];
  $method=$_[1];
  $salt=&get_key_salt();

  if ($method eq "internal") {  # Perl
      $salt=substr($salt,0,2);  # salt 2 char, ex gNPCZ1K3Blknw
      $hash=crypt($pw,$salt);
      $current{'salt'}=$salt;
      return($hash);
  } else {
      if (-f "/bin/openssl") {
         $hash=`/bin/openssl passwd -1 -salt $salt $pw`; chomp($hash);  chomp($check);
         $current{'salt'}=$salt;  #
         return($hash);           # $1$XsVzfvTp$Ot6lPxKygER1sxfIAyy/A/
      } else {
        &mess("/bin/openssl not found");
      }
  }
 }

############ par: select value, current value
sub get_select {
##############
  my $select=$_[0];
  my $current=$_[1];
  if ($current eq "") { return("<select>$select</select>"); }
  if ($select=~/$current/i) {
    return("<select selected>$select</select>");
  }  else {
    return("<select>$select</select>");
  }
 }

 #
 1;