#!/usr/bin/perl
# (c) napp-it 2024 cs
# 2024, mar 21

# debug: run from cli    perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-repli-send.pl run_id
# auto.pl:    `powershell start-process  -WorkingDirectory $wpath -filepath C:\\xampp\\perl\\bin\\perl.exe -argumentlist \"$t\",\"run_$id\" -WindowStyle minimized`;       # minimized=debugmodr
#
# this script runs locally on client (Windows) to control sending source system

#job par
#############################
#job=replicate
#source_ip=192.168.2.203
#destination_ip=192.168.2.75
#source_zfs=daten1/test
#destination_zfs=bsd/data/1
#zfs_name=test
#transport=nc
#port=52969
#recursiv=no
#send_raw=no
#esxi_ip=
#send_i=-i
#send_options=
#rec_options=
#pv_limit=
#keep=
#hold=
#month=every
#day=sun
#hour=0
#min=0
#status=manual
#last=new
##########################

#use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

 use vars qw($wpath $dpath $tpath $ref $buf $par $id $action $f $t @t $p @p %current $error $info %job $os);

 if (!(-d '/tmp/nappit')) {  mkdir ('/tmp/nappit');  }         # create logfolder

$wpath="/xampp/web-gui";
$dpath="/xampp/web-gui/data";
$tpath="/xampp/web-gui/tmp";

# common lib
require "$wpath/_lib/windows/scripts/task-lib.pl";        #
require "$wpath/data/wwwroot/cgi-bin/admin-wlib.pl";


$par=$ARGV[0];
$par=~s/\'//g;

# netcat buffer size on sol
$buf="131072";


#debug
# print "job-job-repli-send 17: par=\'$par\'\n";

$info="xxx repli-send 43: zfs send initiated: $par";
&my_log();

 if (!(defined($par))) {
     &log("job-repli-send:  missing parameter");
     exit;
 }

 ############

 chomp($par);
 #par: action_job timestamp  'remote_id'
 $par=~s/ .*//;


 # parameter: action_$job time
 if (!($par =~/^[a-z]+\_\d+$/)) {
     print "repli-send 59: wrong par $par\n";
     exit;
 }
 @t=();
 @t=split(/\_/,$par);                   # action job
 $action=$t[0];
 $action=~s/[^a-z]//g;

 $id=$t[1];
 #############################################


# run?
if ($action eq "")                      {  &log("$id<br>remote|job-job-repli-send 42: wrong action - must be not empty","m");        exit; }
if (!("remote"=~/$action/))             {  &log("$id<br>remote|job-job-repli-send 43: wrong action - must be remote: $action","m");  exit; }


# do not start this job e.pl run_123 twice
     $t=`ps axw | grep $par | grep -v grep`;
     @t=();
     @t=split(/\n/,$t);

     # only one send
     if (@t > 1) {
         $info="xxx repli-send 84: send already running, cancel send request";
         &my_log("$info");
         exit;
     }


 &my_getpar;
 &my_run;

 exit;


  ## run job (child process)
 sub my_run {
 ############

# parameter from file /tmp/nappit/job-repli-send.id (ex id=1354303765)
  # id=1354303765
  # send_dedup=
  # send_rec=
  # send_inc=-i or -I
  # snap_name1=tank/data@1354303765_repli_zfs_rz-backup4_nr_1
  # snap_name2=tank/data@1354303765_repli_zfs_rz-backup4_nr_2
  # src_interface=sudo /usr/bin/nc -w 30 192.168.88.24 54282

  ##  new 0.9
  # send_ip=
  # port=
  # transport=
  # buffer=
  # send_i

  #23.4.18
  # send_option
  # pv_limit

  # override from napp-it 0.9
  if ($job{'send_i'} eq "-I") {
        $job{'send_inc'}="-I";
  } else {
        $job{'send_inc'}="-i"; # default
  }

  #initial send, snapname1="" , no -i/-I
  if ($job{'snap_name1'} eq "") {  $job{'send_inc'}=""; }

  my $path="";
  if ($os eq "linux") {
       $path="/sbin/";
  } else {
       $path="/usr/sbin/";

       # optionally delete incomplete last
       if ($job{'id'} > 0) {
#            `pkill -f '$job{'id'}_repli'`;  # zfs send
       }
       if ($job{'port'} > 50000) {
#            `pkill -f ' $job{'port'}'`;     # nc
       }

  }

  my $cmd=$path;

  # process viewer?
  my $pv="";
  if (-f "/usr/bin/pv") {
    $t="";
    if ($job{'pv_limit'}=~/[a-zA-Z]/)  { $t=" $job{'pv_limit'}";  }
    $pv="/usr/bin/pv$t -frb -i 10000 2> /tmp/$job{'port'}.log | ";
  }


  $cmd.="zfs send $job{'send_option'} $job{'send_dedup'} $job{'send_rec'} $job{'send_inc'} $job{'snap_name1'} $job{'snap_name2'} | $pv$job{'src_interface'} 2>&1";
  #$cmd.="zfs send $job{'send_option'} $job{'send_dedup'} $job{'send_rec'} $job{'send_inc'} $job{'snap_name1'} $job{'snap_name2'} | $pv$job{'src_interface'}";
  $cmd=~s/ +/ /g;

  #debug
  #print "job-repli 83: $cmd\n";

  &task_gettime;

  $info="xxx repli-send 165: $current{'timestamp'} repli-send.pl id $id cmd:<br>$cmd";
  &my_log;


  # log snaps  opt.
  $info="xxx repli -send 170: $current{'timestamp'} id $id snapinfo:<br>";
  if ($job{'snap_name1'} ne "") {
      $info="NAME USED AVAIL REFER MOUNTPOINT<br>snap1: ";
      $t=$path."zfs list -H $job{'snap_name1'}";
      $t=`$t`;
      chomp $t;
      $info.="$t";
  }
  if ($job{'snap_name2'} ne "") {
      $info.="<br> snap2: ";
      $t=$path."zfs list -H $job{'snap_name2'}";
      $t=`$t`;
      chomp $t;
      $info.="$t";
  }

  # pre job
  if (-f "/var/web-gui/_log/jobs/$id.pre") {
       $t=time();
       $info="xxx repli-send 189: (time $t) execute pre shell script $id.pre\:";
       &my_log;

       $info=`sudo sh /var/web-gui/_log/jobs/$id.pre`;
       $t=time();
       $info="xxx repli-send 194: (time $t) result: $info";
       &my_log;
  }

  $info="xxx repli-send 198: $current{'timestamp'} repli-send.pl id $id <br>$info<br>$cmd";
  &my_log;

  # start send
  my $t1=time();
  $error=`$cmd`;

  &task_gettime;
  my $t2=time();

  if (-f "/tmp/nappit/job-repli-send.$id") {
    unlink("/tmp/nappit/job-repli-send.$id");
  }

  $t=$t2-$t1;

  my $fs=$job{'snap_name2'}; $fs=~s/\@.*//;
  if ($error eq "") { $error="<b>zfs send ($fs): ok</b>"; } else { $error="zfs send result: $error"; &my_log; }

  $info="<hr>xxx repli-send 217: $current{'timestamp'} repli-send.pl id $id<br>remote send finished after $t s<br>$error<br><br>";

  # add pv
  if (-f "/tmp/$job{'port'}.log") {
      $info.=`cat /tmp/$job{'port'}.log`;
  }
  &my_log;

  # post job
  if (-f "/var/web-gui/_log/jobs/$id.post") {
       $t=time();
       $info="xxx repli-send 228: (time $t) execute post shell script $id.post\:";
       &my_log;

       $info=`sudo sh /var/web-gui/_log/jobs/$id.post`;
       $t=time();
       $info="xxx repli-send 233: (time $t) result: $info";
       &my_log;
  }

  return();
 }

############## read parameter to %job
sub my_getpar {
##############
my @data;
if (!(-f "/tmp/nappit/job-repli-send.$id")) { &log("$id<br>remote | error | file not found<br>/tmp/nappit/job-repli-send.$id "); exit; }
  open (F,"</tmp/nappit/job-repli-send.$id");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);
  my ($k,$v,$l,$w,@w,$par,$ncwait);

  $ncwait=900;
  $t=`cat /var/web-gui/_log/napp-it.cfg | grep nc_wait`;   chomp($t);
  $t=~s/\D//gs;
  if ($t>10) { $ncwait=$t; }


  foreach  $l (@data) {
      chomp($l);
      if (!($l=~/=/)) { next; }

      $par.="$l, ";
      @w=();
      @w=split(/=/,$l);
      $job{$w[0]}=$w[1];
  }
  $info="xxx repli send 259: par $id:<br>$par";
  &my_log;

  # set values send_ip, port
      @w=();
      @w=split(/ /,$job{'src_interface'});
      @w=reverse(@w);
      $job{'port'}   =$w[0];
      $job{'send_ip'}=$w[1];

  # set send interface
  if ($job{'src_interface'}=~/mbuffer/) {
            #  zfs send -i data/filesystem@1 data/filesystem@2 | mbuffer -s 128k -m 1G -O 10.0.0.1:9090
            $job{'src_interface'}="/usr/sbin/mbuffer -s 128k -m 1G -O $job{'send_ip'}\:$job{'port'}";
  } else {
     if ($os eq "linux") {
              $job{'src_interface'}="nc $job{'send_ip'} $job{'port'}";
     } else {

            # nc -b  -w 30 192.168.88.24 54282
            `/usr/bin/chmod 755 /var/web-gui/data/tools/nc/nc`;
            if ($buf > 0) {
               $job{'src_interface'}="/var/web-gui/data/tools/nc/nc -w $ncwait -b $buf $job{'send_ip'} $job{'port'}";
#               $job{'src_interface'}="/var/web-gui/data/tools/nc/nc -b $buf $job{'send_ip'} $job{'port'}";
            } else {
               $job{'src_interface'}="/var/web-gui/data/tools/nc/nc -w $ncwait $job{'send_ip'} $job{'port'}";
            }
     }
  }

}

####### log last run in jobfile /_log/jobs/id...job
sub my_log {
###########
  my $rem="$wpath/_log/remote.log";
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}

  my (@v,$v,$n,$l,$f1,$f2,@data);
  $info=~s/\n/<br>/gs;

  # write
  @data=();
      if (-f $rem) {
         open (F,"<$rem");
               flock(F, LOCK_EX);
               @data=<F>;
         close (F);
      }

      $info=~s/\n/<br>/gs;
      unshift(@data,"$info\n");

      if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);
      }

      $t=join("",@data);
      open (PF, ">$rem");
          flock(PF, LOCK_EX);
          print PF "$t";
      close (PF);

}





##
1;