#!"\xampp\perl\bin\perl.exe"

use strict;
use vars qw($debug $hostname $perl $nc $cgipath $dpath $wpath $tpath $i $t $p $o $action $txt $ev %t %p %in %cfg @p @t @cfg %disk %user %sys %zfs %action %current %opt %txt @post);         # menues and global var + global temp

#print "Content-type: text/html\n\n$dpath";
use CGI::Carp qw (fatalsToBrowser);                          # use only for debugging
use lib "/xampp/web-gui/data/cs_server/CGI";

use IO::Socket::INET;                                        # socket communication
#use IO::Select;                                             # socketserver only, this is client
                                                             # for server and multiple clients
use Digest::SHA::PurePerl qw(sha256_hex);                    # replaces md5m, $hash = sha256_hex($data); 96 char
use File::stat;
use File::Find;                                              # how old is a file
                                                             # find files and dirs
# action=rgroup                                              # use Tiny for upload of large text
use HTTP::Tiny;
use URI::Escape;                                             # url escape when needed

use Sys::Hostname; $hostname = hostname();                   # same line

#use Crypt::Rijndael_PP;                                      #? encrypt auth:
use utf8;
############################

$sys{'version'}="win 24.05.20 nightly beta";                          # date_version
use Fcntl qw(:flock);                                        # filelocking
$|=1;                                                        # keine Pufferung, no buffering
$sys{'port'}="80";                                           # remote control always via socket, not compatible to current nc control

#basic paths
$dpath="/xampp/web-gui/data";

#tmpfolder
$tpath="/xampp/web-gui/tmp";

#web-gui folder
$wpath="/xampp/web-gui";

require "$dpath/wwwroot/cgi-bin/admin-wlib.pl";              # common used functions

#settings
$perl="/xampp/perl/bin/perl.exe";
$nc="$dpath/tools/netcat.112/nc64.exe";


##########################################################################
# If this message is displayed within you browser, there is a problem with
# cgi-settings of your webserver, ex wrong filename (must admin.pl) or
# binary file-transfer instead of ascii or missing execute file permission
##########################################################################

# try:
# - check above problemlist
# - reboot you system and try again
# - reinstall napp-it and check messages for errors
# - check install-logfile /root/napp-it-setup.log
# - ask for help in forums (see www.napp-it.org/help)
#########################################################################


#########################################################################
# about napp-it ZFS-Server appliance (Windows edition)
#########################################################################

## (c) Guenther Alka, 2010 - 2024 ## All rights reserved
## Permission granted to use and modify this script freely and
## without charge so long as this copyright is maintained, modifications
## are documented, and this permission is given for any use of the scripts.
## This permission is unique to end-users only.
## if you want to distribute napp-it or charge for it (alone or bundled with
## other software or hardware) or offer preconfiguration, you need alicence
## for extensions, the author of the extension can request a fee or donation.
#########################################################################


# basic setup:
# 1. Install Base-OS (Win10, Win11, Server 2019+) with Open-ZFS
# - download bootable ISO from nexenta.org, openindiana.org or oracle.com
# - boot from ISO and install OS (recomended is: manual IP-setting)

# 2. Download Xampp with our NAS/SAN appliance Software
# start /xampp/napp-it/data/start_web-gui_as_admin.bat (as admin)

# 3.
# do you know the ad: there is no step three
# use web-gui with your preferred browser
# adress is: http://serverip or https://ip

########################################
# main script admin.pl
# admin.pl will create menues based on folders below this folder

# 1st level menue = foldernames ex. 01_storage, 01_webserver ...
# 2nd level menue = foldernames below 1st ex. 01_status, 02_pool ...
# 3rd level menue = foldernames below 2nd ex. 01_create, 02_import ...

# in each folder: action.pl -> script to handle this menue-item

# action.pl:
# 1. action.pl is included via require if item is selected
# 2. the script will then call eval { &action };
# 3. if error:  warn $@ if $@;

########################################


################################### main script, do not edit below ##########################################



#########
# get cli infos, socketserver must be running on port 63000
# print &socket('zpool status');           # example, allowed commands dir,zfs,zpool



print "Content-type: text/html\n\n";      # required here for get_**

####### read %in
# opt set %in when called via accelarator & cli
$o=$ARGV[0];
#&mess($o);

if ($o=~/^cli=1/)   {
    &Readsocket($o);
} else {
    &ReadParse;                                                           # cgi-lib Copyright (c) 1993-1999 Steven E. Brenner
}
$o="";


####### 1. Get basic configuration like paths, os, read libraries etc
       &get_config;


#read 2. %cfg, defaults and set lang  (opt), requ here for ip check
       &get_cfghash;


# read date
       &getdate;                                                        # tt.mm.jjjj


####### parse in, fix member double entry problem
&parse_in;
#&print_hash(%in);
                                                                        # parse input  data

# swap ENV REMOTE_ADDR ex on site to site vpn with port forwarding (gives wrong REMOTE_ADDR)
if ($cfg{'value_remote_addr'}=~/\w+=\w+/) {
     @t=split(/=/,$cfg{'value_remote_addr'});
     if ($ENV{'REMOTE_ADDR'} eq $t[0]) {
        $ENV{'REMOTE_ADDR'} = $t[1];
     }
}

############################ remote call #################  socket only??
# remote group login ?
if ($in{'action'} =~/^rgroup/) {

     # check allowed group ip
     if ($ENV{'REMOTE_ADDR'} ne "") {
        if ($cfg{'value_group_ip'} ne "") {
           $t=$cfg{'value_group_ip'};
           $t=~s/\./\\./g;                    # respect .
           $t=~s/ *, */|/g;                   # allow commalist
           if (!($ENV{'REMOTE_ADDR'}=~/$t/)) {
             print "error:group ip $ENV{'REMOTE_ADDR'} not allowed in appliance settings!";   exit;
           }
        }
     }
     #&mess("only socket connections are supported");   # basic stat ok

   &load_lib('grouplib.pl');                      # get large data or requests via post

   if ($in{'action'} =~/^rgroup_data_/) {         # remote datasave
        &grouplib_remote_data;
   }

   &grouplib_remote_call;                         # remote control in group-lib.pl

}


########################################################

# check allowed management ip
if ($ENV{'REMOTE_ADDR'} ne "") {
   if ($cfg{'value_manage_ip'} ne "") {
      $t=$cfg{'value_manage_ip'};

      $t=~s/\./\\./g;                   # respect .
      $t=~s/ *, */|/g;                  # allow commalist
      if (!($ENV{'REMOTE_ADDR'}=~/$t/)) { print "<div style='position: relative; top:200px; left:30%'><h2>ZFS appliance</h2><b>ip $ENV{'REMOTE_ADDR'} not allowed</b><br>for management in appliance settings"; exit; }
   }
}

# load interface windows
     $p="$dpath/menues/_lib/windows/interface.pl";

     if (-f "$dpath/_my/_lib/interface.pl")  {                 #option my
         $p="$dpath/_my/_lib/interface.pl";
     }
     require $p;
     $p="";

# option to display hashvalues from libs prior header
&display_loaded;

# print header, interface.pl requires next session id
&header;        # show header prior a preload error

################ preload libs and hashvalues

##get language files to hash, read to hash %txt
&get_language;

#&print_hash(%current);
#&print_hash(%in);

if ($in{'id'} ne "") {      # show menu always after login, even on socket errors
   # print menu
   ################# print menus now for better reactiveness
   $current{'menu_href'}="/cgi-bin/admin.pl?id=$in{'id'}&amp;member=$in{'member'}&amp;l1==l1=&amp;l2==l2=&amp;l3==l3=";

   # generate menu without ample
   &menu;
}

if ($in{'l1'} ne "") {     # preload only on submenues

   #&print_hash(%in);
   &get_preloads;          # based on menulevel or action, can poduce errors or timeout

}


#&print_hash(%in);
#console load zfs
if (($in{'cons'}) && ($in{'console'}=~/zfs |zpool /)) {
    &load_lib("zfslib.pl");
}

# update ample after preload
$t= &ample_state('','update');
print $t;
#&print_var($t);

# generate logbox (always)
  &log_begin;



######login?
######################################################
if ($in{'id'} eq "") {

     # logout command topmenu
     if ($in{'action'}=~/logout/) {                # logout_session
          $t=$in{'action'}; $t=~s/.*\_//;          # session
          #&mess($t);
          unlink("$tpath\\session.$t");            # no exe
          $t="";
     }

     if ($in{'name'} eq "") {
          &login;
          exit;
     }
     &login_ok;
                                                                                 # verify name
} else {

      $p=$in{'id'}; $p=~s/,.*//;                                                 # name from id = name,... ex $p=admin
      $t=$p;                                                                     # name ex admin

      if (!(($t eq "admin") || ($t eq "operator")))    {
           $t="wrong name, please login again!";
           &login;
      }

      ######
      # load menu to be in case of connect timeout
      # path to current menue level
      ############################
      if (($in{'l1'} eq "")|| ($in{'l1'} =~/00_about/)) {
         $sys{'path'}="$sys{'ospath'}";
      } else {
        $sys{'path'}="$sys{'ospath'}"."$in{'l1'}/$in{'l2'}/$in{'l3'}/";
       $sys{'path'}=~s/\/+/\//g;  #$sys{'path'}=~s/\/$//g;
      }


}

#########################################################
#perl path

$t=join(", ",@INC);
        $sys{'libs_searchpath'}="$t";


 #update without logout?
        if (($sys{'os'}=~/\.new$/) || ($sys{'os'}=~/^sunos/)) {
                print "<p style='margin-left: 5px; font-size: 10px'>$txt{'sys_update'}</p>";
                sleep(3);
                $t="";
                $in{'id'}="";
                &reload;
        }




#repeat selected menue items = show history
#############################
        $t="$in{'l1'}"; $t=~s/=.*//;
        $t.=" / $in{'l2'} "; $t=~s/=.*//;
        $t.=" / $in{'l3'}:"; $t=~s/=.*//;

        $t=~s/ +\/ + \// \/ /g;  $t=~s/\/ *:$/:/g;                      # ex  menu1 | menue2:     or   menu1:
        $t=~s/\d\d_//g;


#action in folder-menue
 $o=$in{'action'};
 if (($in{'action'}=~/NAME/) && ($in{'l1'}=~/folder/)) { $o=""; }       # or property-list



## basic commands: add edit remove menue items
###############################################
       # if ($in{'action'} =~/^add_/)    { &menue_add; }                # add_l1 add_l2 add_l3
       # if ($in{'action'} =~/^rename_/) { &menue_rename; }             # add_l1 add_l2 add_l3
        #if ($in{'action'} =~/^remove_/) { &menue_remove; }             # remove_l1   or _l2 _l3
        if ($in{'action'} =~/^edit_/)   { &edit_file; }                 # edit -> show only



#setup (internal item)
######################
         if ($in{'l1'} eq "00_about")  {
           &about;
           print "\n</div>\n<!--admin 347-->";
           &log_end;  # close log window
           print "</body>\n</html>";                             # div from menu
           exit;
         }


##########
##do actions
#########   after 2 * <br>
my $w=&getv($cfg{'app_acc'}); if ($w=~/val/is) { sleep(1);  }

print <<EoF;
<!-- action --><br>
EoF

 ##load action ##
 ################

         $action="$sys{'ospath'}$in{'l1'}/$in{'l2'}/$in{'l3'}";
         $action=~s/\/+$//g;


         $t=$in{'l1'}; $t=~s/\_.*//;          # get number
         if ($t>=100) {                       # my actions    z.b. 101_mymenu
             $action="$sys{'myospath'}$in{'l1'}/$in{'l2'}/$in{'l3'}";
         }
         $action=~s/\/+/\//g;
         $action=~s/\/$//g;

         $action=~s/[^a-zA-Z0-9\_\-\ \.\+\/\\=:]//g;
         $action.="\\action.pl";                              #name of actionfile=menue-item.pl

         #read action and verify if its text only
         @p=();

         if (-f $action) { &read_ahfile("$action","p","a"); }                           #read action -> @p
         $txt=join("",@p);

         #################################################
         # autoload basic libs for included function calls
         #################################################
           my (@w,$w,$i,@l);
           foreach $t (@p) {
                @l=();
                @l=split(/\&/,$t);

                for (my $i=1;$i<@l; $i++) {


                        if (!($l[$i]=~/^[a-z]+lib\_/))         { next; }        # no autoload on functions without _ (name must be for ex &zfslib_list();

                        $l[$i]=~s/\_.*//s;                     # ex zfslib
                        $l[$i]=~s/\s//g;



                        #gethash for lib required? yes if you have get-zfs for lib zfslib
                        $p=$l[$i];  $p=~s/lib//;
                        if (($p eq "sys") || ($p eq "current")) {
                              $p="get-$p".".pl";
                              if ($sys{'libs'}=~/$l[$i]/) {
                                  # require $p;
                                  if (!($sys{'auto_loadhash'}=~/$p/)) { $sys{'auto_loadhash'}.=", $p"; }
                              }
                        }

                     #autoload lib

                        $l[$i].=".pl";
                        if ($sys{'libs'}=~/$l[$i]/) {
                          #require $l[$i];
                          if (!($sys{'auto_loadlibs'}=~/$l[$i]/)) { $sys{'auto_loadlibs'}.=", $l[$i]"; }
                        }

                }
           }
           $sys{'auto_loadlibs'}=~s/^, |, $//g;




           ###################
           # autoload gethash
           ################### for hash sys, zfs, disk, current   ex get-disk.pl
           foreach $t (@p) {
                @l=();
                @l=split(/\$/,$t);

                for ($i=1;$i<@l; $i++) {

                         if (!($l[$i]=~/^sys\{|^disk\{|^zfs\{|^current\{/))         { next; }        # autoload on public hash values ex zfs{'key_'}


                         $l[$i]=~s/\{\'/_/;
                         $l[$i]=~s/\'.*//;                        # current_file1_file2_key or current_file1_key
                         @w=split(/\_/,$l[$i]);                   # or disk_file1_file2


                         # current{'file1_file2_key'}.. or current{'file1_key'}..   or disk{'key'}  or disk{'file1_key'}

                         # 1. get-hash.pl
                         #################          # basic, always loaded
                         if ($w[2] eq "")  {
                                  $w="get-$w[0]-$w[1]".".pl";
                                  $w=quotemeta($w);
                                  if ($sys{'libs'}=~/$w/) {
                                         $w="get-$w[0]-$w[1]".".pl";
                                         require $w;
                                        if (!($sys{'auto_loadhash'}=~/$w/)) { $sys{'auto_loadhash'}.=", $w"; }
                                  }
                         }

                         # 2. get-hash-file1.pl
                         ######################
                         if (($w[2] ne "") && ($w[2] eq ""))  {
                                  $w="get-$w[0]-$w[1]".".pl";
                                  $w=quotemeta($w);
                                  if ($sys{'libs'}=~/$w/) {
                                        $w="get-$w[0]-$w[1]".".pl";
                                        require $w;
                                        if (!($sys{'auto_loadhash'}=~/$w/)) { $sys{'auto_loadhash'}.=", $w"; }
                                  }
                         }


                         # 3. get-hash-file1-file2.pl
                         ######################
                         if (($w[2] ne "") && ($w[3] ne ""))  {
                                  $w="get-$w[0]-$w[1]-$w[2]".".pl";
                                  $w=quotemeta($w);
                                  if ($sys{'libs'}=~/$w/) {
                                        $w="get-$w[0]-$w[1]-$w[2]".".pl";
                                        require $w;
                                        if (!($sys{'auto_loadhash'}=~/$w/)) { $sys{'auto_loadhash'}.=", $w"; }
                                  }
                         }

                }
          }
          $sys{'auto_loadhash'}=~s/^, |, $//g;




 ## run action.pl
 ################


         if (($txt=~/sub +my_action +\{/) && ($txt=~/1\;\s*$/)) {                           #script ok
                  if (!(-f $action)) { &error("(195) write-error: $action not found"); }

                  require "$action";
                  eval (&my_action);

                  warn $@ if $@;
          }  else {

                $txt=~s/^.*not remove this header ################ -->\n+//s;            #remove header
                print $txt;
          }

 print "\n<br><br>\n</div>\n<!--admin 535-->\n";
 &log_end; # close command log window
 print "</body>\n</html>";                               # div from menu

 #&mess(__LINE__);
 exit;


####################################  end of main ##########################################################

#################
sub get_preloads {                    # hide:
################
# preload other libs based on action or menulevel############

# current:member must be always defined

# autoload disk-lib in disks and extensions sas2
if ((!($in{'l1'} =~/00|03|20/)) && ($in{'member'} ne "")) {             # 00_about,03_system, 20 extensions

       #always
       &load_lib("oslib.pl");

       # always beside 00 and 20, ..
       if (!($in{'l1'}=~/00|01|20|1\d\d/)) {          # about, help my, ext

             #&load_lib("get-sys-status.pl");           # allpools etc
             &load_lib("get-zpool.pl");
       }

       if (($in{'l1'}=~/disks|pools/i) || ($in{'l3'}=~/sas2/i)) {

             if ($in{'l2'} ne "") {

                  if ($in{'l2'}=~/controller/i)    {                     # load there when needed
                      &load_lib("get-disk-status.pl");                   # load disklib_ctrl, (slow) - only when needed
                  }
             }
             &load_lib("get-disk.pl");
       }

       if ($in{'l1'}=~/disk|pool/i) {
             &load_lib("disklib.pl");
             #&load_lib("get-sys-status.pl");
       }

       if ($in{'l1'}=~/filesystems|pools|snaps/i) {
             &load_lib("zfslib.pl");
             &load_lib("get-zfs.pl");
             &load_lib("sharelib.pl");

       }

       if ($in{'l1'}=~/job/i) {
             &load_lib("jobslib.pl");
             &load_lib("task-lib.pl");
             if ($in{'l3'}=~/create/i) {
               &load_lib("zfslib.pl");                 #  load after select  members (performance) or job create
             }
       }

       if ($in{'l1'}=~/user/i) {
              &load_lib("get-user.pl");
       }

  }

  if ($in{'l1'}=~/jobs|ext|group/i) {
             &load_lib("grouplib.pl");
  }

  # load my/zfsos/_lib/myautoload.pl  if available
  # can overwrite everything incl in and colors
  ##############################################
  $t="$wpath/my/_lib/myautoload.pl";
  if (-f $t) {
         $sys{'auto_loadlibs'}="myautoload.pl";
         require "$t";
  }

}  # /eof




################
sub get_cfghash {                    # hide: fill hash %cfg or %current
################
        my (@p,$m,$k,$ip);

        # in:member, current:member_hostname, current:member_ip must always be defined
        # with local as default, displayed hostname is not "real" hostname but hostname from group
        # local hostname is always localhost

        # first read auth pw hashes for &exe first
        # my $dir="$wpath/_log/group";

        my @files = glob("$wpath/_log/group/*.txt");
        @files=sort @files;

        $sys{'group'}="localhost~127.0.0.1\t";           # pre set as first member

        if ($in{'member'} eq "") {     # default
                  $in{'default_member'}="localhost~127.0.0.1";
        }

        foreach my $file (@files) {                      # group members
            my $file2=$file;

            if ($file=~/~127\.0\.0\.1\.txt/)  {
                if (!($file=~/\/localhost~127\.0\.0\.1\.txt/)) {
                   &mess("local groupmember (*~127.0.0.1) $file must be unique <br> and named./_log/group/localhost~127.0.0.1.txt");
                }
            }

            $t=&my_read($file2);

            #print "file: $file2<br>";


            $m=$file2;         # member ex path/localhost~127.0.0.1.txt
            $m=~s/\.txt$//;    # filename without .txt
            $m=~s/.*\///;      # member name: host~ip

            if (!($sys{'group'}=~/\b$m\b/)) {
              if ($m=~/\d/) {
                 $sys{'group'}.="$m\t";
              }
            }

            $ip=$m;
            $ip=~s/.*~//;       # auth related to ip only

            $current{$ip}=$m;   #ip -> member

            $t=~s/\s//gs;       # auth
            $cfg{$ip}=$t;       # cfg{127.0.0.1} => 123 from read

            #print __LINE__." ip= $ip -> $cfg{$ip} ( $t )<br>";

            # current: ip ->  member
        }


        #&print_hash(%cfg);

        $sys{'group'}=~s/\t+$//;                         # to select a member from a commalist
        $current{'members'}=$sys{'group'};               # just a copy that can e displayed in topmenu %current

        # some menus like job create seelct member via autoselect_member -> make this member
        if ($in{'autoselect_member'} ne "") {
             $in{'member'}=$in{'autoselect_member'};
        }

        ###
        # exe requires member in %in and ip in %current
        if ($in{'member'} eq "") {
             $in{'member'}="localhost~127.0.0.1";
             @t=split(/~/,$in{'member'});
             $current{'member_hostname'}=$t[0];
             $current{'member_ip'}=$t[1];
        }  else {
            @t=split(/~/,$in{'member'});
             $current{'member_hostname'}=$t[0];
             $current{'member_ip'}=$t[1];
        }
        ###
#&print_hash(%current);

        if ($in{'member'} ne "localhost~127.0.0.1") {
          $current{'on'}=&exe('on');    # Linux, Win32
        } else {
          $current{'on'}="MSWin32";
        }

#
#&mess($current{'on'});

        @t=split(/~/,$in{'member'});                               # set current
        $current{'member_hostname'}=$t[0];
        $current{'member_ip'}=$t[1];


        #read_ahfile(file,hash/arrayname,art,aufruf), art =h/b (hash,array,beides), aufruf aus zeile
        $t="$wpath/_log/web-gui.cfg";
        if (-f $t) { &read_ahfile("$t","cfg","h+"); }                    #read configuration -> %cfg

        $t="$wpath/_log/appliance.log";
        if (-f $t) { &read_ahfile("$t","cfg","h+"); }                   #read appliance-info/pro keys -> %cfg
        $t="";


 # force my language
       if (-d '$dpath/_my/_lib/lang/MY!') {
         $cfg{'select_lang'} ="MY!";
       }

 # global defaults
        if ($cfg{'value_adminpw'}=~/^\$/) {
             @p=();
             @p=split(/\$/,$cfg{'value_adminpw'});

        }
        if ($cfg{'value_operatorpw'}=~/^\$/) {
             @p=();
             @p=split(/\$/,$cfg{'value_operatorpw'});

        }
  # force en
  if (-f "$wpath/_log/force_en.log") {
            $current{'force_en'}="1";
  }

  # &print_hash(%cfg);
}


############### my basic configuration
sub get_config {     # hide:   get my configuration prior read data
##############
# get other paths and settings
###############################
#

$sys{'cgipath'}="$dpath/wwwroot/cgi-bin/";          #

##############
      $sys{'auto_os'}="Windows";
      $sys{'os'}="Windows";           # win only
      push(@INC,"$sys{'ospath'}/_lib/windows");

      # paths
      $sys{'ospath'}="$dpath/menues/";           # menues
      $sys{'myospath'}="$wpath/_my/menues/";    # user/os/folder
      $sys{'tmp'}="$wpath/tmp";                   # tmp folder

       # webref either /_doc or /_my/_doc
       $sys{'webref'}="/_doc";
       if (-d "$wpath/_my/wwwroot/_doc") {
           $sys{'webref'}="/_my/_doc";                                    # use private files instead
       }

       # localhost must be always a group member
       if (!(-f "$wpath/_log/group/localhost~127.0.0.1.txt")) {
            # create a random hash from time(); as default
            $t=time();
            $t=&get_sha_hash(time());

            &my_write("$wpath/_log/group/localhost~127.0.0.1.txt","$t");

            # write same to server.auth
            &my_write("$wpath/data/tools/socket/server.auth","$t");
       }

       #opt switch language via top-menu
       ##############
       if (($in{'lang'} ne "") && ($cfg{'select_lang'} ne "en")) {
             #
             #switch to en?
             if ($in{'lang'} eq "en") {
                 &exe("echo 1 > $wpath/cfg/force_en.log");
             } else {
                 if (-f "$wpath/_log/force_en.log")  {
                     &exe("del $wpath/cfg/force_en.log");
                 }
             }
       }

       if (-f "$wpath/cfg/debug_on") { $debug=1; }

## /setup ##

}



####################
sub display_loaded {                  # hide: display loaded hashes
####################

  #$sys{'test'} ="1"; #debug
  ##################  display loaded libs and hashes ###
  my $close_on = "\$('#mylog_close').animate({height: 'show', opacity: 'show'}, 'fast');";
  my $log_off   = "\$('.logwindow').animate({height: 'hide', opacity: 'hide'}, 'fast');";

  my $toggle_cli    ="<a href='#' title='show logs' class='mlink' onclick=\"$log_off $close_on \$('#mylog_cmd').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\"><b>Log</b></a>";
  my $toggle_in     ="<a href='#' title='show \%in' class='mlink' onclick=\"$log_off $close_on \$('#mylog_in').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\"><b>\%in</b></a>&nbsp;";
  my $toggle_sys    ="<a href='#' title='show \%sys' class='mlink' onclick=\"$log_off $close_on \$('#mylog_sys').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\">\%sys</a>&nbsp;";
  my $toggle_disk   ="<a href='#' title='show \%disk' class='mlink' onclick=\"$log_off $close_on \$('#mylog_disk').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\">\%disk</a>&nbsp;";
  my $toggle_zfs    ="<a href='#' title='show \%zfs' class='mlink' onclick=\"$log_off $close_on \$('#mylog_zfs').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\">\%zfs</a>&nbsp;";
  my $toggle_current="<a href='#' title='show \%current' class='mlink' onclick=\"$log_off $close_on \$('#mylog_current').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\">\%current</a>&nbsp;";
  my $toggle_txt    ="<a href='#' title='show \%txt' class='mlink' onclick=\"$log_off $close_on \$('#mylog_txt').animate({height: 'toggle', opacity: 'toggle'}, 'slow');\">\%txt</a>";

 if ($in{'id'}=~/^admin,/) {
    if  (-f "$wpath\\cfg\\debug_on")   {

       #show public hashes sys, zpool, zfs, disk, action current opt
       $sys{'m_links'}="$toggle_cli $toggle_in $toggle_sys $toggle_disk $toggle_zfs $toggle_current $toggle_txt ";
    }
 }       # always win
 #####################  end display libs and hashes ####################
}



############
sub load_lib {                 # load a lib
############

        my $lib=$_[0];
        if ($lib eq "") { return; }

        if (-f "$wpath/_my/_lib/$lib") {
            require "$wpath/_my/_lib/$lib";
        } else {
            require "$dpath/menues/_lib/windows/$lib";
        }
        return ("1");

}

####################         # run on login
sub about_set_basics {       # set permissions and create _log folder if missing,
#####################        # if folder zfsos.update  rename zfsos to zfsos.date and zfsos.new to zfsos
    my ($t,$c,$file,$uid,$user,$new,$old,$f,$r,$o,@b,$p);

    return;                   # obsolete

    #path to scripts (must be short due to length limitations of os axw)
    if (!(-d "/var/web-gui/data/scripts")) {
        `ln -s /var/web-gui/data/napp-it/zfsos/_lib/scripts /var/web-gui/data/scripts`;
    }
    if (!(-d "/var/web-gui/data/wwwroot/cgi-bin/napp-it")) {
        `ln -s /var/web-gui/data/wwwroot/cgi-bin /var/web-gui/data/wwwroot/cgi-bin/napp-it`;
    }

    #obsolete now
    #if (!(-d "/var/web-gui/data/napp-it/_log")) {
    #    `ln -s /var/web-gui/_log /var/web-gui/data/napp-it/_log`;
    #}
    #if (!(-d "/var/web-gui/data/napp-it/_my")) {
    #    `ln -s /var/web-gui/_my /var/web-gui/data/napp-it/_my`;
    #}

    if (!(-d "/var/web-gui/data/wwwroot/_my")) {
        `ln -s /var/web-gui/_my/wwwroot /var/web-gui/data/wwwroot/_my`;
    }

    #set email to tls (to be update save)?
    if (-f "/var/web-gui/_log/use_tls.log") {
        &exe("cp /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-tls-email.pl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-email.pl");
    }

    # set default value of show edit to /tmp   (could be set to off there)
       if ($cfg{'select_editable'} eq 'always') {
         if (!(-f "/tmp/nappit/napp-it_edit_on")) {
          #  `sudo touch /tmp/nappit/napp-it_edit_on`;
         }
       }

    #Expect modules depend on Perl release
     $r="";
     # check perl
     $p=`/usr/bin/perl -v`;
     $p=~s/.*\(v//s; $p=~s/\).*//s;  # ex 5.32.0
     @t=split(/\./,$p);
     $p="$t[0]\.$t[01]";             # ex 5.32


     if ($sys{'auto_os'} eq "Linux") {           # obsolet, kein Expect
           #&exe("cp -R /var/web-gui/data/tools/ubuntu/CGI/. /var/web-gui/data/napp-it/CGI/");                      # ubuntu 12, debian

           # check
           #eval { local $^W = 0; undef local $SIG{__DIE__}; require IO::Pty;  };
           #if ($@)    {
           #    # otherwise use this from OmniOS_Text_r151005 -1008
           #     &exe("cp -R /var/web-gui/data/tools/ubuntu/CGI.u14/. /var/web-gui/data/napp-it/CGI/");
           #}
     }


     if ($sys{'auto_os'}=~/omni/i) {
           $r="omnios/perl_$p";
     }

     #OI/Hipster
     if ($sys{'auto_os_type'}=~/ill_h/i) {               # Hipster
        if (-d "/var/web-gui/data/tools/oi/perl_$p")  {
          $r="oi/perl_$p";
        } else {
          $r="omnios/perl_$p";
        }
     }

     #Solaris
     if ($sys{'auto_os'}=~/Solaris/i) {
         #$r="omnios/perl_$p";                         # not ok with 5.22
         if (-d "/var/web-gui/data/tools/solaris/perl_$p")  {
            $r="solaris/perl_$p";
         } else {
            $r="omnios/perl_$p";
         }
     }

     # copy needed Tty.so
     #&exe("cp -R /var/web-gui/data/tools/$r/CGI/. /var/web-gui/data/napp-it/CGI/");

     ###/cgi

     # enable acc
     if (!(-f "/var/web-gui/_log/napp-it_acc_off")) {
        &about_acc_enable(0);
     }

     # enable stat
     if (!(-f "/var/web-gui/_log/napp-it_ws_off")) {
        &about_stat_enable;
     }

     # check for nc (use included if missing)             # /root/web-gui/data/tools/nc/nc
     if (!(-f "/usr/bin/nc")) {
        if ($sys{'auto_os'} ne "Linux") {
          &exe("cp /var/web-gui/data/tools/nc/nc /usr/bin/nc");
          &exe("chmod 755 /usr/bin/nc");
        }
     }

     ## check number of BE
     if ($sys{'auto_os'} ne "Linux") {
       $r=`/usr/sbin/beadm list | grep -v MOUNTPOINT 2> /dev/null`;
       @b=split(/\n/,$r);
       $t=@b;
       if ($t > 30) {
         print "<div style='position:absolute;top:180px;left:5px'><font style='color:red'>Warning: number of boot environments quite high: $t<br>Please delete unneded BEs in menu Snapshot - Bootenvironments</font></div>";
         sleep (5);
       }
     }

     #check host license
     $t="";
     if (-f "/var/web-gui/_log/appliance.log") {
       $r=`cat /var/web-gui/_log/appliance.log`;
       @b=split(/\n/,$r);
       foreach my $b (@b) {
          if ($b=~/::/) {
            if (!($b=~/h:m.+[mel]90/)) { $t.="1"; }
          }
       }
       if ($t=~/1/) {
         print "<br><font style='color:red'>&nbsp;Up from appliance v18.01 Pro licenses are based on a machine id<br>";
         print "&nbsp;Please swap your license to a machine id license, see menu Extensions > Get Machine ID <br><br>";
         if (!($cfg{'select_lang'}=~/my|app/i)) {
            print '&nbsp;You can swap a key online at <a href="http://napp-it.org/extensions/swap_en.html" target="_blank"><u>napp-it.org/extensions/swap_en.html</u></a>';
         }
         print "</font>";
         sleep (5);
       }
     }

     #check folder
   #  if (!(-d '/var/web-gui/_log/report/'))     {  mkdir ('/var/web-gui/_log/report/');  }
   #  if (!(-d '/var/web-gui/_log/report/time')) {  mkdir ('/var/web-gui/_log/report/time');  }

}

########################
sub about_stat_enable {
#######################
return;                   # obsolete

     my ($o,$r);
     # start realtime logging
     if ($sys{'auto_os'} eq "Linux") {
          $o="linux";
     } else {
          $o="illumos";
     }

    # print "<pre>";

     if (!($cfg{'ver'} =~/c|m/)) { print '<br><tt> monitoring disabled</tt>'; sleep(2); return; }
     if (!(-f "/var/web-gui/_log/monitor_off")) {


       #    `sudo echo \'#about_stat_enable\' > /tmp/stat.sh`;
       #    `sudo chmod 755 /tmp/stat.sh`;


           # already running?
        #   $r=&exe('ps axw | grep /agent_stat.pl | grep -v grep');


           if (!($r=~/stat.pl arcstat/s))  {
            `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl arcstat \&' >> /tmp/stat.sh`;
           }

           if (!($r=~/stat.pl iostat_60s/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl iostat_60s \&' >> /tmp/stat.sh`;
           }

           if (!($r=~/stat.pl iostat_long/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl iostat_long \&' >> /tmp/stat.sh`;
           }

           if (!($r=~/stat.pl fsstat/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl fsstat \&' >> /tmp/stat.sh`;;
           }

           if (!($r=~/stat.pl nicstat/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl nicstat \&' >> /tmp/stat.sh`;
           }

           if (!($r=~/stat.pl poolstat/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl poolstat \&' >> /tmp/stat.sh`;
           }

           if (!($r=~/stat.pl prstat/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl prstat \&' >> /tmp/stat.sh`;
           }

           if (!($r=~/stat.pl zilstat/s))  {
             `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl zilstat \&' >> /tmp/stat.sh`;
           }

           # kill all fswatch with agent
           $w=`ps axw | grep fswatch | grep -v grep`;      # all fswatch with agent
           @t=split(/\n/,$w);
           foreach my $t (@t) {
               #print "kill $t<br>";
               chomp $t;
               $t=~s/^ +//;   # leading spaces
               $t=~s/ .*//s;  # all after pid
              # `sudo kill -9 $t  > /dev/null 2>&1`;
           }

           # start fswatch agent
           if (!($r=~/fswatch/s))  {
           #  `echo \'perl /var/web-gui/data/napp-it/zfsos/_lib/$o/agents/agent_stat.pl fswatch \&' >> /tmp/stat.sh`;
           }

           sleep(1);
         #  `sudo rm /var/spool/cron/atjobs/* 2>/dev/null`;          # opt delete "hanging" at jobs
         #  `sudo /usr/bin/at -s -f /tmp/stat.sh now  > /dev/null 2>&1`;
         #  `sudo rm /tmp/stat.sh`;
           #sleep(1);
     }

}

#######################
sub about_stop_socketserver {
#######################

  &error('obsolete');
  ###################

}




########### about #
sub about {              # internal item
###########

    my ($ant,$c,$t,$file,$r);

    ##
    #cfg

    if ($in{'id'}=~/^admin/) {
        #setup
        if ($in{'l2'} =~/set/) {
                 &about_setup;
        }

        #setup
        if ($in{'l2'} =~/lingual/) {
                 &about_lingual;
        }

        #functions
        if ($in{'l2'} =~/functions/) {
                 &about_functions;
        }
        #update
        if ($in{'l2'} =~/update/) {
                 &about_update;
        }
    }


    #help
    if ($in{'l2'} =~/help/) {
                 &about_help;
    }

    #security
    if ($in{'l2'} =~/security/) {
                 &about_security;
    }


    if ($in{'l2'} =~/contribute/) {
                 print "<script language='javascript'>document.getElementById('hlinebox').innerHTML='napp-it contribute'</script>\n";
                 print "<pre>$txt{'txt_contribute'}</pre>";
                 exit;
    }


    ## about ##################### l2 ="" ##########
    if ($txt{'app_about_header'} eq "") {
       print "<script language='javascript'>\$('#hl').html('<b>$cfg{'app_name'} </b> - network &amp; <b>n</b>as <b>app</b>liance &copy; napp-it.org 2010 - 2024')</script>\n";
    } else {
       print "<script language='javascript'>\$('#hl').html(\"$txt{'app_about_header'}\")</script>\n";
    }

    #1. licence
    if ($txt{'app_about_show_license'} ne "no") {

    print <<EoF;

 <b style='background-color:#dddddd'>napp-it License</b> <br><pre>

 You are allowed to use napp-it cs without charge for noncommercial home use with 3 servers. Outside private homeuse you need a Pro subscription for every
 managed ZFS server. For a single Windows ZFS server you need one Pro subscription. If this server additionally manage another two ZFS server ex a
 BSD and Linux ZFS server, you need a triple subscription after an initial 30day evaluation period. You are allowed to modify the napp-it menus and features
 for inhouse use so long as this copyright is maintained and you do not give away or redistribute the scripts. You will not get any warranty beside bugfix
 and eMail support as soon as possible, use it as it is at your own risk. <a href='#' class='toggle'> Read more..</a></pre>

 <div class='toggle_content'>
 <pre>
 Developers extending the functionality of napp-it are allowed to use a different licence for their add-ons and they are also allowed
 to request a fee or donation to ensure further development. These non-free add-ons are distributed by their developers.

 <i>Sie d&uuml;rfen napp-it cs free f&uuml;r nichtkommerziellen Privatgebrauch mit bis zu 3 Servern kostenlos nutzen. Andere  Nutzer der Windows Version ben&ouml;tigen
 eine Pro Subscription f&uuml;r jeden ZFS Server nach einer 30t&auml;gigen Testphase. Wollen Sie napp-it (auch zusammen mit anderer Software oder Hardware
 geb&uuml;ndelt vertreiben, vorkonfigurieren oder eine Geb&uuml;hr daf&uuml;r verlangen, so ben&ouml;tigen Sie dazu jedesmal eine Bundling Lizenz.

 Entwickler die napp-it um spezielle Extensions oder eigene Men&uuml;s erweitern, d&uuml;rfen diese unter eine andere Lizenz stellen und eine Geb&uuml;hr oder Spende
 verlangen, um die weitere Entwicklung sicherzustellen. </i></pre></div>
EoF

 }

&load_lib("oslib.pl");        # no exe on localhost!
&oslib_status;                # from oslib.pl


} #/setup


##################  multilingual edit
sub about_lingual {
#################
return;
    my ($i,$k,$v,$lang,$item,$items,$sub, $it1,$it2,$l);
    my @items;       #
    my @sub;
    my @lang;
    $it1=",";  # itemlist to avoid double menus
    $it2=",";

    print "<script language='javascript'>\$('#hl').html('Multilingual editor:  Menu translations and messages')</script>\n";
    if (!($cfg{'ver'}=~/c|m/)) {
       print "This is a function that is included in the complete or monitor extension";
       &log_end;  sleep (3);  exit;
    }

    ################################### update #######################
    if (($in{'answered'}) && ($in{'_lang'} ne "")) {

         $lang=$in{'_lang'};
         $item=$in{'_item'};
         $sub =$in{'_sub'};


         # new = regular item
         $in{'_new'}=~s/ +//g;
         if ($in{'_new'} ne "") {

                   # en
                   $i=$in{'_new'}."_en";
                   $in{$i}=$in{'_new_en'};

                   #inFo (to allow info)
                   if ($in{'_new_info'} ne "") {
                      $i=$in{'_new'}."_inFo";
                      $in{$i}=$in{'_new_inFo'};
                   }

                   # lang
                   if ($in{'_new_lang'} ne "") {
                        $i=$in{'_new'}."_lang";
                        $in{$i}=$in{'_new_lang'} ;
                   }

         }


         while (($k,$v) = each %in) {

              # items
              if ($k=~/_en$/) {
                     if ($k=~/^_new_/) { next; }                       # without new
                      $t=$k; $t=~s/_en$//;
                      push(@items,$t);
              }

              # lang_items
              if ($k=~/_lang$/) {
                      if ($k eq "_new_lang") { next; }                 # without new
                      if ($k eq "_lang")     { next; }

                      $t=$k; $t=~s/_lang$//;
                      if ($v ne "") { push(@lang,$t); }                 # only when set
              }


         }

         if ($sub eq "")   { $sub =$item;  }
         if ($sub eq "")   { &mess('which file??'); }

         if ($lang eq "")  { &mess('which language??'); }
         @items=sort(@items);

#debug
#&print_hash(%in);
#&print_var($t);
#&print_array(@items);
#&print_array(@lang);

         # update en
         $t="$dpath/menues/_lib/lang/en/$sub.txt";
         if (@items > 0) {          # any value

                  open(F, ">$t");
                          flock(F, LOCK_EX);
                          foreach my $key (@items) {
                             $i=$key."_en";
                             $in{$i}=~s/\s+$//s;
                             print F "<<$key>> $in{$i}\n";

                             $i=$key."_inFo";
                             print F "<<$key\_inFo>> $in{$i}\n\n";
                          }
                  close(F);

                  # update language
                  if (@lang > 0) {
                      $t="$dpath/menues/_lib/lang/$lang/$sub.txt";
                      if ($lang =~/[A-Z]/) {
                          $t="/var/web-gui/_my/zfsos/_lib/lang/$lang/$sub.txt";
                      }

                      # if copied as root
                      #`sudo touch $t`;
                      #`sudo chmod 666 $t`;

                      open(F, ">$t");
                          flock(F, LOCK_EX);
                          foreach my $key (@lang) {
                             $i=$key."_lang";
                             print F "<<$key>> $in{$i}\n";
                          }
                      close(F);
                  }
          }
          ### / update

    }

    #################################### edit ########################

    # step 1, get all editable items, each item is a menu

    if ($in{'autoselect_lang'} eq "") {  $in{'autoselect_lang'}="$cfg{'select_lang'}"; }   # default
    if ($in{'autoselect_lang'} eq "") {  $in{'autoselect_lang'}="de"; }                    # default

    $in{'autoselect_sub'}=~s/^\-//;
    if ($in{'autoselect_item'} eq "") {
         $in{'autoselect_item'}="about";
         $in{'autoselect_sub'}="about_menus";                   # default
    }

    # internal menus
    if ($in{'autoselect_item'} eq "about") {
        @sub=("00_about_menus","01_about_settings","02_about_multilangual","03_about_functions","04_about_security","05_about_update","06_about_contribute","90_about_basic");
    }

    #get all folders below
    $t=`sudo find /var/web-gui/data/napp-it/zfsos/ -type d`;                  # find folders

    @t=();
    @t=split(/\n/,$t);



    foreach $t (@t) {
        $t=~s/.*zfsos\///;
        if (($t=~/^\_/) || ($t eq "")) { next; }

        $t=lc($t);
        $t=~s/=\-*\w+//g;                              # remove option =lin
        $t=~s/^\d+\_|//g;                              # remove option 01_
        $t=~s/\/\d+\_/\//g;

        $t=~s/ \w+//g;                                 # first word only

        if ($t=~/\//) {   #sub
              if ($t=~/^$in{'autoselect_item'}/i) {
                    if ($it1=~/\b$t\b/) { next; }     # menu a, menu b -> same file
                    push (@sub,$t);
                    $it1.="$t,";
              }
        } else {
              $t=~s/ .*//;                            # keep first word as key
              if ($it2=~/\b$t\b/) { next; }           # menu a, menu b -> same file
              push (@items,$t);
              $it2.="$t,";
        }

    }
 #&print_array(@sub);

    #remove nn_, keep original sorting
    foreach $t (@items) { $t=~s/^\d+\_//; }

    # sort main items
    @items=sort(@items);
    unshift(@items,"about");


    # add - for main menu itself

    # sort sub items
      @sub=sort(@sub);

    if ($in{'autoselect_item'} ne "about") {
         unshift(@sub,"-");
    }


 # get lang
                 @lang=();
                 @t=();
                 $t="";                                                              # get lang
                 $l="$dpath/menues/_lib/lang/";                        # defaults like en, de
                 &read_dir("$l",'t','/',__LINE__);
                 @t=sort(@t);
                 @lang=@t;

                 # add my languages
                 @t=();
                 $l="$dpath/_my/_lib/lang/";
                 &read_dir("$l",'t','/',__LINE__);                                         # my languages ex CN, IT
                 @t=sort(@t);

                 push(@lang,@t);
 @lang=sort(@lang);


 # build edit-table
 $items=join(",",@items);

 $sub=join(",",@sub);
 $lang=join(",",@lang);
 $lang=~s/\///g;


 print "<br>For a basic translation to a new language, you must create a folder like /var/web-gui/data/napp-it/zfsos/_lib/lang/sp for a Spanish version. \n";
 print "It is then a good beginning to translate <br> the about_menus and about_basic section. If you send your new or improved zipped language folder to community\@napp-it.org, ";
 print "it may be included to napp-it. If you want to create your own translations, you can create a private language folder like /var/web-gui/_my/zfsos/_lib/lang/MY (use uppercase)  <br><br>";


 # select item
 &ask('begin','m');
    &ask('autoselect_lang','Language (Uppercase = private translations)',$lang,$in{'autoselect_lang'});
    &ask('autoselect_item','Main item',$items,$in{'autoselect_item'});
    &ask('autoselect_sub','Sub item',$sub,$in{'autoselect_sub'});
 &ask('end');


 ####################
 # get en + lang text
 ####################
 if ($in{'autoselect_sub'} eq "") {
    $t="$in{'autoselect_item'}";
 } else {
    $t="$in{'autoselect_sub'}";
 }

 my $en;
 if ($in{'autoselect_lang'} eq "_my") {
     $p="$dpath/_my/_lib/lang/";
 } else {
     $p="$dpath/menues/_lib/lang/$in{'autoselect_lang'}/";
 }
 # get other lang: lang or _my
 $lang="";
 if (-f "$p$t.txt") {
   $lang=&my_read("$p$t.txt");
 }

 # get english
 my $en;
 if (-f "$dpath/menues/_lib/lang/en/$t.txt") {
  $en=&my_read("$dpath/menues/_lib/lang/en/$t.txt");
 }

#&print_var("/var/web-gui/data/napp-it/zfsos/_lib/lang/en/$t.txt<hr>$en");

 ########################
 # build a list from keys
 ########################

 @items=();  # en keys                                     # en version cares about order of entries
 my @items2; # engl content
 my %en;  # engl values
 my %lang;                                                 # hash of lang content


 @t=();
 @t=split(/<</,$en);


 #&print_array(@t);
 foreach $t (@t) {
     if (!($t=~/>>/)) { next; }  # not a valid key
     chomp($t);
     @w=();
     @w=split(/>>/,$t);
     if ($w[0] eq "#")     { next; }                           # no comments in en
     if (!($w[0] =~/_inFo$/)) {                               # no info as items in en
         push(@items,$w[0]);
     }
     $w[1]=~s/^ +//;
     $en{$w[0]}=$w[1];
 }

 # same with lang
 @t=();
 @t=split(/<</,$lang);

                                                           # lang version: no comments and order does not matter ex $lang{$key}
 foreach $t (@t) {
     if (!($t=~/>>/)) { next; }  # not a valid key
     chomp($t);
     @w=();
     @w=split(/>>/,$t);
     $w[1]=~s/^ +//;

     if ($w[0] eq "#") { next; }                           # no comments in lang
     $lang{$w[0]}=$w[1];
 }

 #&print_hash(%en);

 #################
 # build edit-table
 ##################

  &ask('begin','edit');
  &ask('hidden', '_lang', $in{'autoselect_lang'});
  &ask('hidden', '_item', $in{'autoselect_item'});
  &ask('hidden', '_sub',  $in{'autoselect_sub'});
  &ask('hidden', 'autoselect_sub',  $in{'autoselect_sub'});
  &ask('hidden', 'autoselect_item',  $in{'autoselect_item'});
  &ask('hidden', 'autoselect_lang',  $in{'autoselect_lang'});

  print "<br><br>$in{'autoselect_item'} >> $in{'autoselect_sub'}<table border='0' style='width:99%'>";
  $i=0;

  my $key="<input name='K' class='td1_bg' style='border: B; width: 320px; height:15px; font-weight:bold; font-size:12px; padding-bottom:4px' type='text' size='80' maxlength='60' value='V' readonly>";

  my $edit1="<textarea name='K_en' style='width: 100%; height:45px' rows='3'>C</textarea>";
  my $edit2="<textarea name=\"K_lang\" style='width: 100%; height:45px' rows='3'>C</textarea>";
  my $info;
  my $info="<span style='font-size:9px'>info: <input name='K_inFo' class='td2_bg' style='border:none; width: 320px; font-size:9px' value='C' type='text' size='80' maxlength='60'></span>";

  my $del="<span style='font-size:9px; color:#999999'><a style='margin-left: 40px'>[d]</a> elete in en and in all languages</span>";
  $del="";  # todo

  my $i2;

  @items=sort(@items);

  #add new
  push(@items,"_new");

#&print_array(@items);
#&print_hash(%en);

  $i==0;
  foreach my $item (@items) {

      #key + del
      $t=$key; $t=~s/I/$items[$i]/;
      if ($items[$i] eq "_new") {
           $t="new: $t"; $t=~s/ readonly//; $t=~s/B/solid 0 0 1px 0/; $t=~s/V//;   $t=~s/K/_new/;
      } else {
           $t=~s/V/$items[$i]/; $t=~s/B/none/;   $t.=$del;  $t=~s/K/$items[$i]/;
      }
      print "\n<tr class=\"td1_bg\"><td colspan='2' style='padding-top: 5px; border-top: 8px solid white'><b>$t</b></td></tr>\n";   # key name

      #en
      $t=$edit1; $t=~s/K/$items[$i]/;  $t=~s/C/$en{$items[$i]}/;                       # key and content
      print "<tr class=\"td2_bg\"><td style='width: 99%; padding-right:10px'>$t<br>\n";

      #lang
      $t=$edit2; $t=~s/K/$items[$i]/;  $t=~s/C/$lang{$items[$i]}/;
      print "<font style='font-size:9px'>$in{'autoselect_lang'}<br></font>$t<br>";

      # info
      $i2=$info; $i2=~s/K/$items[$i]/;

      $t=$items[$i]."_inFo";
      $i2=~s/C/$en{$t}/;

      print "\n$i2";

      #end
      print "</td></tr>\n";

      $i++;
  }

  print "</table><br><br>\n";
  &ask('confirm','update en + language version','Update language files?');
  print "<br><br><br>\n";

  &log_end;
  exit;


}



#################
sub about_security {
#################


print "<script language='javascript'>\$('#hl').html('Security')</script>\n";
      print <<EoF;
<pre>$txt{'txt_security'}

</pre>
EoF
     &log_end;
     exit;
}  # /about_howto

#################
sub about_help {
#################
print "<script language='javascript'>\$('#hl').html('Help')</script>\n";
      print <<EoF;
<IFRAME SRC="http://www.napp-it.org" style="width:100%; height: 800px"></IFRAME>
EoF
     exit;
}  # /about_howto


#################
sub about_functions {
#################
my (@lib,$f,$l,$m,$t);
print "<script language='javascript'>\$('#hl').html('Functions')</script>\n";

###########
print <<EoF;
<pre>
<b>List of all available functions of napp-it and loaded libraries:</b>

<b>1. global napp-it variables </b><hr>
<b>1.1 cgi and config (please use read only)</b>
EoF


$t=<<EoF;
\%in                          post get data
\@cfg                         config data
\$sys{'path'}                        path to current menulevel
EoF
print &list2table($t,'100%,300px');

##########
print <<EoF;

<b>1.2 unused global variables for user-actions</b><hr>
\$p, \@p, \%p, \$t, \@t, \%t


<b>1.3 your functions and variables for user-actions</b><hr>
 please start names of your own functions with my.. example sub my_function1
 to avoid conflicts with napp-it functions and use variables locally
 ex: my (\$var1,\@list);

 preferred way: add your lib-name to your functions ex:
 if you create a lib abc-lib.pl, name your function sub myabc_..
 ex. sub myabc_create
 save your function libraries (name it ...-lib.pl) into a main menu folder
EoF
#print &list2table($t);


################
print <<EoF;


<b>2. basics functions</b> $cfg{'version'}<hr>
EoF


################
$t=<<EoF;
&stop(\$name)                 stop script, print html header and show content of variable \$name
&print_var(\$name)            print content of variable \$name, add +&lt;br&gt;\\n
&print_array(\@name)          print content of array \@name
&print_hash(\%hash)           print content of hash \%name

&ask("opt")                  ask user, print form elements (begin,submit,end,text,checkbox,radio,select,hidden)
&mess("text")        stop script, print oops-message -opt ok-message: &mess("text","ok text");
&list2table("text")        print tab or doublespace-list as nice table opt: &list2table("text","tablewidth,td1width,td2width")
&console                     get console
&exe("command")              call shell command
&show_file("file")           show file
&edit_file("file")           edit file
&read_file("file")           read file, return string ex \$s=&read_file('/etc/hosts');

&read_dir("dir","name")      read files in dir to public array \@name
&read_ahfile(file,arrayname,opt)   read file to public array/hash \@name, opt=h,b (hash,both)
EoF
print &list2table($t,'100%,300px');


############
print <<EoF;

<b>3. user libraries (*-lib.pl)</b><hr>
EoF


##########
print<<EoF;
libraries in /napp-it and /napp-it/os will be <b>always</b> included automatically (global functions)
libraries in /napp-it/os/menu-level1 will be included <b>only in this menu and below</b> (functions for this menu)

normal use of functions should be:
EoF

#######
$t=<<EoF;
\$t=\&my_function("a","b");    call functions vith values
\$t=\&list_zfs;                function will return a value; ex. \$t contains zfs list
print \&list_zfs;             print zfs list
EoF
print &list2table($t,'100%,300px');

#  functions in napp-it and napp-itos
@lib=split(/,/,$sys{'libs'});



#&mess($p);
#&print_array(@lib);


#1. global libs in /napp-it  and napp-it/os  and menue1 libs
foreach $f (@lib) {
  $f=~s/^\s+//;
  if ($f=~/\/get/) { next; }                #gethash
  print "<br><b>library: $f</b><hr>\n";

 # $f="$sys{'cgipath'}"."$f";
  @t="";
  $t="";

  if (!(-f $f)) { next; }
  &read_ahfile($f,'p','a');

  foreach $p (@p) {
    if (!($p=~/^\s*sub/))                 { next; }
    if ($p=~/hide:/)                      { next; }                             #hide it
    $p=~s/^\s*sub /\&/;                   #sub -> &
    $p=~s/ /() /;
    $p=~s/\{|\#//g;

    $t.= "$p";
  }
  if ($t eq "") {  $t="-lib has no public functions-";}
  print &list2table($t,'100%,300px');
  print "\n";
}
   &log_end;
   exit;
}  # /about_howto


###################
 sub about_setup {
 #################
 my ($file,$c1,$c2,$no1,$no2,$l,@l,$k,$v,$r);
 #return;

 if (!($in{'id'}=~/^admin,/)) { &error("setup: admin only"); }

                 #stage 2 save it
                 if ($in{'answered'}) {

                      # only form values
                      %cfg=();

                      $in{'select_os'}=~s/^\.+//;
                      $in{'select_os'}=~s/\||\\|\///g;
                      $file="$sys{'cgipath'}$in{'text_os'}";
                      if (!(-d $file)) { &mess("set os: folder $in{'text_os'} not found!<br>$file"); }

                      #cluster
                      $cfg{'select_servermode'}=$in{'select_servermode'};

                      if ($in{'value_adminpw'} eq "")  { $no1="1"  }
                      $in{'value_adminpw'}=~s/^\*\*\*$//;
                      $in{'value_admin2pw'}=~s/^\*\*\*$//;

                      $in{'value_adminpw'}=~s/\*+//g;
                      $in{'value_adminpw'}=~s/\|//g;        #restricted  ?

                      if  ($in{'value_adminpw'} ne $in{'value_admin2pw'}) { &mess("admin password is not identical"); }


                      if ($in{'value_operatorpw'} eq "")  { $no2="1"  }
                      $in{'value_operatorpw'}=~s/^\*\*\*$//;
                      $in{'value_operator2pw'}=~s/^\*\*\*$//;

                      $in{'value_operatorpw'}=~s/\*+//g;
                      $in{'value_operatorpw'}=~s/\|//g;        #restricted  ?
                      if  ($in{'value_operatorpw'} ne $in{'value_operator2pw'}) { &mess("operator password is not identical"); }

                      $in{'select_os'}=~s/[^a-zA-Z0-9\_\-\.]//gs;
   ##
                      $cfg{'select_defuser'}=$in{'select_defuser'};
                      $cfg{'select_lang'}=$in{'select_lang'};

                      if ($in{'value_adminpw'} ne "") {                                # get sha hash
                                # save hash, crypt always 16 char
                                 $cfg{'value_adminpw'}=&gethash("admin",$in{'value_adminpw'});
                        }
                      if ($no1)  { $cfg{'value_adminpw'}="";  }

                      if ($in{'value_operatorpw'} ne "") {                            # get hash
                                 # save hash, crypt always 16 char
                                 $cfg{'value_operatorpw'}=&gethash("operator",$in{'value_operatorpw'});
                        }
                      if ($no2)  { $cfg{'value_operatorpw'}="";  }

                      $cfg{'select_editable'}=$in{'select_editable'};

                      #security settings
                      $in{'value_manage_ip'}=~s/ +//g;
                      $in{'value_group_ip'}=~s/ +//g;
                      $in{'value_keyserver_path'}=~s/ +//g;

                      $cfg{'value_manage_ip'}=$in{'value_manage_ip'};
                      $cfg{'value_group_ip'}=$in{'value_group_ip'};
                      $cfg{'value_remote_addr'}=$in{'value_remote_addr'};

                      # key
                      $in{'value_keydata_fs'}=~s/^\/+//;                        # must be pool/filesystem
                      $in{'value_keydata_fs'}=~s/\/+$//;
                      $cfg{'value_keydata_fs'}=$in{'value_keydata_fs'};         # local keys

                      $in{'value_keydata_fs2'}=~s/^\/+//;                       # must be pool/filesystem
                      $in{'value_keydata_fs2'}=~s/\/+$//;
                      $cfg{'value_keydata_fs2'}=$in{'value_keydata_fs2'};

                      #S3
                      $in{'value_key_s3_fs'}=~s/^\/+//;                       # must be pool/filesystem
                      $in{'value_key_s3_fs'}=~s/\/+$//;
                      $cfg{'value_key_s3_fs'}=$in{'value_key_s3_fs'};


                      # tmp fs
                      $in{'value_keydata_tmpfs'}=~s/\/+$//;
                      $cfg{'value_keydata_tmpfs'}=$in{'value_keydata_tmpfs'};   #

                      $in{'value_key_server1'}=~s/^\/+//;                       # https://a.b.c
                      $in{'value_key_server1'}=~s/\/+$//;
                      $in{'value_key_server1'}=~s/\s//g;
                      $cfg{'value_key_server1'}=$in{'value_key_server1'};       # remote keys

                      $in{'value_key_server1b'}=~s/^\/+//;                       # https://a.b.c
                      $in{'value_key_server1b'}=~s/\/+$//;
                      $in{'value_key_server1b'}=~s/\s//g;
                      $cfg{'value_key_server1b'}=$in{'value_key_server1b'};

                      $in{'value_key_server2'}=~s/^\/+//;                       # https://a.b.c
                      $in{'value_key_server2'}=~s/\/+$//;
                      $in{'value_key_server2'}=~s/\s//g;
                      $cfg{'value_key_server2'}=$in{'value_key_server2'};

                      $in{'value_key_server2b'}=~s/^\/+//;                       # https://a.b.c
                      $in{'value_key_server2b'}=~s/\/+$//;
                      $in{'value_key_server2b'}=~s/\s//g;
                      $cfg{'value_key_server2b'}=$in{'value_key_server2b'};

                      # hostid (access to webserver)
                      $in{'value_key_hostid'}=~s/\s+//g;
                      $cfg{'value_key_hostid'}=$in{'value_key_hostid'};

                      # keyserver
                      $in{'value_keyserver_fs'}=~s/^\/+//;                        # must be pool/filesystem
                      $in{'value_keyserver_fs'}=~s/\/+$//;
                      $cfg{'value_keyserver_fs'}=$in{'value_keyserver_fs'};       # keyserver fs

                      $cfg{'select_keyserver'}=$in{'select_keyserver'};
                      $cfg{'value_key_ip'}=~s/ +//g;
                      $cfg{'value_key_ip'}=$in{'value_key_ip'};

                      $cfg{'select_key_split'}=$in{'select_key_split'};          # keysplit all, local, web, non (prompt only)
                      $cfg{'select_key_server'}=$in{'select_key_server'};        # enable keyserver

                      #smtp settings
                      $cfg{'value_smtp'}=$in{'value_smtp'};
                      $cfg{'value_smtp-to'}=$in{'value_smtp-to'};
                      $cfg{'value_smtp-user'}=$in{'value_smtp-user'};
                      $cfg{'value_smtp-pw'}=$in{'value_smtp-pw'};
                      $cfg{'value_smtp-from'}=$in{'value_smtp-from'};

                      #push service
                      $cfg{'select_push'}=$in{'select_push'};
                      $cfg{'value_pushover-token'}=$in{'value_pushover-token'};
                      $cfg{'value_pushover-user'}=$in{'value_pushover-user'};

                      #other
                      $in{'value_nc_wait'}=~s/\D//g;                  # netcat wait in group remote connect
                      $cfg{'value_nc_wait'}=$in{'value_nc_wait'};
                      $cfg{'value_hide_disk'}=$in{'value_hide_disk'}; # hide disks, (windows bootdisk is automatically hided)

                      $file="$wpath/_log/web-gui.cfg";


                     if  (($in{'value_upsrv'} ne "") && (!($in{'value_upsrv'}=~/\w/)))  { &mess("Use 'ip' for local Apache or a dns name like www.myuniversity.org for validated https");  }
                     $cfg{'value_upsrv'}=$in{'value_upsrv'};        # uploadserver name

                      #save no :: or salt info
                      %t=();
                      while (($k,$v) = each %cfg) {
                           if ($k=~/^app\_/) { next; }  # ex app_name
                           if ($k=~/::/)     { next; }  # ex key
                           if ($k=~/^ver/)   { next; }
                           if ($k=~/^salt/)  { next; }
                           $t{$k}=$cfg{$k};
                      }

                     &hash2file("t","$file","",__LINE__);

                      #reload
                           print <<EoR;
                           <script type="text/javascript">
                                   window.location.href = "/cgi-bin/admin.pl?id=$in{'id'}&amp;action=&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=&amp;l3=";
                           </script>
EoR
                      exit;
                 }


                 # stage 1 form
                 ##### create form ###############

                 $in{'l2'}="02_settings";          # set correct l2 or menu descriptions are missing after first setup
                 if ($cfg{'select_editable'} eq "") { $cfg{'select_editable'}="yes"; }

                 if ($cfg{'select_lang'} eq "") { $cfg{'select_lang'}="en"; }        # force a local /MY!
                 &get_language;

                 @t=();
                 $t="";                                                              # get lang
                 $l="$dpath/menues/_lib/lang/";                                      # defaults like en, de
                 &read_dir("$l",'t','/',__LINE__);
                 @t=sort(@t);
                 my @lang=@t;

                 # add my languages
                 @t=();
                 $l="$wpath/_my/zfsos/_lib/lang/";
                 &read_dir("$l",'t','/',__LINE__);                                  # my languages ex CN, IT
                 @t=sort(@t);

                 push(@lang,@t);
                 $l="";

                 foreach $t (@lang) {
                    if (!($t=~/^[a-z]+\!*\//i)) { next; }
                    $t=~s/\///;
                    $l.="$t,";
                 }
                 $l=~s/,$//;                                                                 # ex auto,en,de

                 # force MY!
                 if ($l=~/MY!/) { $l="MY!"; }

                 @p=();
                 &read_dir("$sys{'cgipath'}",'p','/',__LINE__);                              #  get os

                 foreach $t (@p) { $t=~s/\/$//; $t=~s/^_.*|^-.*//;  $t=~s/^CGI$//;   }       # hide _xx od -xx  or CGI
                 $p=join(",",@p); $p=~s/\\|\///;
                 $p="auto,$p"; $p=~s/,$//;  $p=~s/,+/,/g;


                 print "<script language='javascript'>\$('#hl').html('$txt{'set_top'}')</script><br>\n";
                 #print "<script language='javascript'>\$('#hl').html('xx')</script><br>\n";

                 print "<br><b style='font-size:16px'>Base settings</b><br><br>";
                 &ask('begin');

                 &ask('value_adminpw',$txt{'set_adminpw'},'***','m16');
                 &ask('value_admin2pw',$txt{'set_adminpw2'},'***','m16');

                 &ask('value_operatorpw',$txt{'set_opw'},'***','m16');
                 &ask('value_operator2pw',$txt{'set_opw2'},'***','m16');


                 &ask('select_editable',$txt{'set_edit_menu'},'yes,always,no',"$cfg{'select_editable'}");

                 # default user
                 &ask('select_defuser',$txt{'set_default_user'},'admin,operator',"$cfg{'select_defuser'}");

                 # standalone or cluster
                 if ($cfg{'select_servermode'} eq "") { $cfg{'select_servermode'}="standalone"; }
                # &ask('select_servermode','Servermode<br></b>Standalone, Cluster failover with HA z-raid or cluster-control<b>',"standalone,cluster-failover,cluster-control","$cfg{'select_servermode'}");

                 if (-d "$wpath/_my/menues/_lib/lang/MY!") {
                         &ask('hidden','select_lang','MY!');
                 } else {
                         print "force private /_my/zfsos/_lib/lang/MY! or use the following:";
                         if ($cfg{'select_lang'} eq "") { $cfg{'select_lang'}="win" }
                         &ask('select_lang',$txt{'set_lang'},"$l","$cfg{'select_lang'}");
                 }

                 ####################################################################
                 print "<br><b style='font-size:16px'>Security settings</b><br><br><br>";
                 ####################################################################

                 &ask('value_manage_ip',"Management allowed from ip(s) (regex)</b><br>ex 192.168.1.10 or 172.16.1. or 192.168.1[01].10<br>or commalist 192.168.1.10,192.168.2.10<b>",$cfg{'value_manage_ip'});
                 &ask('value_group_ip',"Grouping allowed from ip(s)",$cfg{'value_group_ip'});
                 &ask('value_remote_addr',"Swap remote_addr (ip=newip)",$cfg{'value_remote_addr'});

                 #minio/S3
                 #&ask('value_key_s3_fs',"S3 miniO config/accessdata ex pool-1/keydata (S3)</b><br>Prefer an encryted filesystem or pool on an USB/iSCSI LUN<b>",$cfg{'value_key_s3_fs'});

                 ####################################################################
                 print "<br><b style='font-size:16px'>Base encryption settings</b><br><br><br>";
                 ####################################################################

                 &ask('value_keydata_fs',"First local keydata folder or filesystem-1 ex pool-1/keydata (L1)</b><br>Prefer an encryted filesystem or pool on an USB/iSCSI LUN<b>",$cfg{'value_keydata_fs'});
                 &ask('value_key_server1',"First Webserver-1 for keydata</b><br>ex https://keyserver1.myuniversity.org:82 (W1)<b>",$cfg{'value_key_server1'});
                 &ask('value_key_hostid','Access id for all web keyrequests from this server<br></b>use value from keyserver host settings<b>',$cfg{'value_key_hostid'},"30");
                 &ask('select_key_split','Allow web/filebased keys</b><br>save or split the keys either L=locally or on W=webserver','all,local,web,none',$cfg{'select_key_split'});
                 #if ($sys{'auto_os'} eq "Linux") {
                 #     &ask('value_key_tmpfs','Rambased tmp filesystem to store keys temporary<br></b>default: /tmp<b>',$cfg{'value_key_tmpfs'},'30');
                 #} else {
                 #     &ask('hidden','value_key_tmpfs',$cfg{'value_key_tmpfs'});
                 #}

                 # pro feature
                 ####################################################################
                 print "<br><b style='font-size:16px'>Extended encryption settings (Pro Complete)</b><br><br><br>";
                 ####################################################################
                 if ($cfg{'ver'}=~/c/) { $t=""; $k="yes,no"; } else { $t=" readonly"; $k="no"; }

                 &ask('value_keydata_fs2','Secondary local keydata or filesystem-2 ex pool-2/keydata (L2)<br></b>for keysplit and keypart-2 on a second filesystem<b>.',"$cfg{'value_keydata_fs2'}","30$t");
                 &ask('value_key_server1b','HA Keyserver 1b ex https://www.mykeyserver2.com:82/ (W1\')<br></b>a HA redundant webserver for W1<b>',$cfg{'value_key_server1b'},"30$t");

                 &ask('value_key_server2','Secondary Webserver-2 for keydata ex https://www.mykeyserver3.com:82/ (W2)<br></b>for keysplit and keypart-2 on a second webserver<b>',$cfg{'value_key_server2'},"30$t");
                 &ask('value_key_server2b','HA Keyserver 2b ex https://www.mykeyserver4.com:82/ (W2\')<br></b>a HA redundant webserver for W2<b>',$cfg{'value_key_server2b'},"30$t");

                 print "Keyserver settings";
                 &ask('value_keyserver_fs',"Keyserver data/keys ex pool-1/keydata</b><br>can be same or different to local keydata folder or  filssystem<b>",$cfg{'value_keyserver_fs'});
                 &ask('value_key_ip',"Keyserver access allowed from ip starting with</b><br>ex 172.16.1.<b>",$cfg{'value_key_ip'},"30$t");
                 &ask('select_key_server','enable Keyserver access from remote clients</b><br>Allow webbased http/https keyrequests for encrypted filesystems<br>Keysplit and (HA) Keyserver require a Pro complete license<b>',$k,"$cfg{'select_key_server'}");


                 ################################################################################
                 print "<br><br><b style='font-size:16px'>Notification settings</b><br><br><br>";
                 ################################################################################

                 print "<b style='margin-left: 3px'>$txt{'set_email'}</b>";
                 &ask('value_smtp',"$txt{'set_smtp'} ex. smtp.gmail.com",$cfg{'value_smtp'});
                 &ask('value_smtp-user',$txt{'set_smtp_user'},$cfg{'value_smtp-user'});
                 &ask('value_smtp-pw',$txt{'set_smtp_pw'},$cfg{'value_smtp-pw'});
                 &ask('value_smtp-to',$txt{'set_mail_to'},$cfg{'value_smtp-to'});
                 &ask('value_smtp-from',$txt{'set_mail_from'},$cfg{'value_smtp-from'});

                 # push service
                 #print "<br><b>Push alerts via webapi</b><br>ex Pushover, SendinBlue, Telegram or your webapi<br><br>";
                 #&ask('select_push','Push service provider via webapi</b><br>see /var/web-gui/_my/scripts/webapi/webapi.pl or<br>/var/web-gui/data/napp-it/zfsos/_lib/scripts/webapi.pl','webapi',"$cfg{'select_push'}");
                 #&ask('value_pushover-token','Push token (webapi/Telegram/Threema work)',$cfg{'value_pushover-token'});
                # &ask('value_pushover-user','Pushover user, Sendinblue to email, Telegram chatbot id or Threema bc api',$cfg{'value_pushover-user'});

                 ####################################################################
                 print "<br><b style='font-size:16px'>Other cs settings</b><br><br><br>";
                 ####################################################################
                 #&ask('value_nc_wait','netcat wait timeout in s <br>appliance group setting, default: 90',$cfg{'value_nc_wait'});        # netcat wait in group remote connect
                 &ask('value_hide_disk','hide disks from ZFS ex physicaldrive2,physicaldrive3<br>Windows bootdisk is automatically hidden',$cfg{'value_hide_disk'});        # netcat wait in group remote connect

                 #https communication via hostname
                 &ask('value_upsrv',"Use encrypted https callback for cmd and result</b><br>empty to disable, 'ip'to use local Apache or a hostname ex.<br>www2.university.edu. Callback can be enforced in server.pl<b>",$cfg{'value_upsrv'});        # netcat wait in group remote connect


                 &ask('end');

                 print "\n<br><br><font style='font-size: 10px'>$txt{'set_footer'}</font>";
                 &log_end;
                 print "\n<br><br>\n</div>\n<!--admin 1509-->\n</body>\n</html>";          # div from menu

                 exit;

 }

#################### reload taskserver on updates
sub reload_onupdates {
#####################
return;                 #todo
    #
    if ($sys{'auto_os'} ne "Linux") {

            # disable stat-functions
            &about_stat_disable;

            # update
            `sudo cp /var/web-gui/data/tools/httpd/init.d/napp-it /etc/init.d/napp-it`;
            # will manage napp-it-poef in agent-bootinit.pl
    }

    #
    # del sessions
        `sudo rm /var/web-gui/_log/tmp/session.* 2>/dev/null`;
        $in{'id'}="";

    if ($sys{'auto_os'} eq "Linux") {
         print "restart Linux or napp-it manually!br>";
         exit;
    } else {

         $in{'id'}="";
        # reload :81
         print <<ER;
         <script type="text/javascript">
           var url='http://' + window.location.hostname + ':81';
           setTimeout(function() {  window.location.href = url;  },3000);
         </script>
ER
        # restart napp-it
         print "<br>Please wait some seconds...<br><br>On problems, try:<hr>- page reload <br>- manual restart of napp-it via menu System-Shutdown-Restart napp-it (or /etc/init.d/napp-it stop/start)";
         print "<br>- a reboot,<br>- a copy of /var/web-gui/data_last/ to /var/web-gui/data or a <br>- reinstall via wget.!";

         print "<br><br>Restart napp-it services now.<br>";
         # restart napp-it via at now
         # disable agents
        `touch /var/web-gui/_log/accelerate_off`;
        `touch /var/web-gui/_log/monitor_off`;

          # opt remove old/blocking at
         `sudo rm /var/spool/cron/atjobs/* 2>/dev/null`;

         # restart via at now
         print `sudo /usr/bin/at -s -f /var/web-gui/data/napp-it/zfsos/_lib/scripts/restart_napp-it.sh now 2>&1`;
         sleep(3);

    }
         exit;
}

#################
sub about_update {
#################
return;

my ($opt,$default,$newest,$versions,$nv,$dv,$f,$v,$r,$p,$newest_f,$newest_p);

#### update 0.8 -> 0.9 -> 1.0 only via wget, update handling in wget script
#### other updates: online via menu update from newest
#### update options in update-0.9.txt (for 0.9 line) like:
#### free: 0.9a, 0.9b
#### pro:  0.9c, 0.9d, 0.9e, 0.9g
#### wget: 0.9a, 1.0a,

#get default
print "<script language='javascript'>\$('#hl').html('Update or Downgrade')</script>\n";

my ($free,$pro,$wget,$pro_sel,$mid);
if (!($in{'answered'})) {
    $t=substr($sys{'version'},0,3);

    # from yy.mm
    if ($t>15) { $t=~s/\D//g;}         # 16. -> 16

    my $url="www.napp-it.org";
    if ($txt{'app_updateserver'} ne "") {
        $url=$txt{'app_updateserver'}; $url=~s/ +//g;
    }

    print "<br>request all update options for current version $t from $url:<hr>";
    $t="update-$t.txt";
    $opt=`wget -O - $url/$t 2>&1`;                  # ex update-0.9.txt
    $opt=~s/$t//is;

    $opt=~s/.+\'STDOUT\'//s;
    $opt=~s/\n\n.*//s;
    print "$opt";  # result of wget

    @t=split(/\n/,$opt);
    foreach my $t (@t) {
      $t=~s/ +//;
      if ($t=~/free:/)        { $free=$t; $free=~s/.*free://; }
      if ($t=~/pro:/)         { $pro=$t;  $pro=~s/.*pro://; }
      if ($t=~/wget:/)        { $wget=$t; $wget=~s/.*wget://; }
      if ($t=~/newest_f:/)    { $newest_f=$t; $newest_f=~s/.*://; }       # newest free and pro (date)
      if ($t=~/newest_p:/)    { $newest_p=$t; $newest_p=~s/.*://; }

    }
}

# pro update requ pro lic
if ($cfg{'ver'} eq "") { $pro_sel=""; } else { $pro_sel=$pro; }
#if (($cfg{'ver'} eq "") || ($cfg{'ver'}=~/e/)) { $pro_sel=""; } else { $pro_sel=$pro; }

#pro > 18.01 req valid machine id license in /var/web-gui/_log/appliance.log
$mid="0";
if ($pro_sel ne "") {
    $t=`sudo cat /var/web-gui/_log/appliance.log 2>&1`;
    #&mess($t);
    if ($t=~/::/s) {
          print "<br><br>request Pro update options for versions newer v.18.01 (valid machine id license required)<hr>";

          @t=();
          @t=split(/\n/,$t);
          $opt="";
          foreach my $l (@t) {
              if ($l=~/^\#/)    { next; }
              $l=~s/\| *$//; $l=~s/.*\|//; # key only
              $l=~s/[^a-zA-Z0-9\-\_:\. ]//g;

              if (!($l=~/::/))  { next; }
              if (!($l=~/eval/i)) {
                 if (!($l=~/ \d\d\d\d\d\d+\_h:m.+[eml]90/))  { next; }
              }

              # ok seems a lic  app_replicate|replicate 12345_h:ma4256f436857e90_xx - 01.01.2021::mVqmVqsmVPTTmsmsVTTV|
              $l=~s/::.*//;
              $opt.="$l,";
          }
          $opt=~s/,$//;

          $opt=~s/ /~/gs;
          #&mess($opt);

          $r="no valid pro machine id license found";
          if ($opt ne "") {
            $r=`wget -O - http://www.napp-it.org/cgi-bin/eval/check.pl?lic=$opt 2>&1`;

            $r=~s/.+\'STDOUT\'\s*//s;
            $r=~s/\n.*//s;

            if ($r=~/ok/s) {
               print "$r<br>";
            } else {
               print "<b style='color:red'>$r</b><br>";
            }
          } else {
            print "$r<br>";
          }

          if ($r=~/ok/s) {
               $mid="1";
          }
    }
}

#debug
    #debug set pro options
            #$mid="0";
            #$pro_sel.=",18.02pro";

if ($mid eq "0") {
    #
    @t=();

    $pro_sel=~s/ //g;
    @t=split(/,/,$pro_sel);

    $pro_sel="";
    foreach my $w (@t) {
                    $t=$w;
                    $t=~s/[^\d\.]//g;
                    if ($t <= "18.01") {
                       $pro_sel.="$w,";
                    }
    }
    $pro_sel=~s/,$//;
               #&mess($pro_sel);
}

### answered
if (($in{'answered'})  && (!($in{'select_options'}=~/select/))) {

    # create BE
    if ($sys{'auto_os'} ne "Linux") {
      $t=time();
      $t="$in{'select_options'}_".$t;
      $t=~s/napp\-it/release/;
      $t=~s/ /_/g;
      print "create BE pre_$t <br>";
      print `sudo /usr/sbin/beadm create pre_$t`;
      print "<br>";
    }

    if ($in{'select_options'}=~/activate/) {
#&print_hash(%in);

         $in{'select_options'}=~s/activate /data_/;
         print "<br><br>activating $in{'select_options'} ...\n ";

         if (!($in{'select_options'}=~/data_/)) { &mess("error: wrong option $in{'select_options'}"); }

         #step 1. rename old data -> data_last
         if ($in{'select_options'} ne "data_last") {
            if (-d "/var/web-gui/data_last") {                                     # already a last version?
                     &exe("rm -r /var/web-gui/data_last/");
            }
            &exe("cp -R /var/web-gui/data/. /var/web-gui/data_last/");             #/. opt create target
         }

         $f="$in{'select_options'}";                                             #data_nn.nn

         # del all folders to be updated (simple rename of whole folder gives problems with httpd)
         &exe("rm -r /var/web-gui/data/napp-it");
         &exe("rm -r /var/web-gui/data/tools");
         &exe("rm -r /var/web-gui/data/wwwroot/_doc");
         &exe("rm /var/web-gui/data/wwwroot/*.html");                 # root folder

         #copy new files
         &exe("cp -R /var/web-gui/$f/. /var/web-gui/data/");

         #change owner of /napp-it to web-account on every start of napp-it
         `sudo $sys{'binpath'}chown -R napp-it /var/web-gui/data`;

        #set permission to -R 755
        `sudo $sys{'binpath'}chmod -R 755 /var/web-gui/data`;

         print "<br>$f activated.<br>\n ";
    }

    ##########
    if ($in{'select_options'}=~/download/) {

         print "<br><br>$in{'select_options'} ...\n ";                  # download x.xx

         $f=$in{'select_options'};
         $f=~s/download /napp-it-/;
         $f.=".zip";                                                    # filename

         if (-f "./$f") { &exe("rm ./$f"); }
         if (-d "./web-gui") { &exe("rm -r ./web-gui"); }

         $v="www.napp-it.org/doc/downloads/$f";

         &exe("wget $v");
         print "<br>unzipping $f ...\n ";          # ex napp-it-0.9a1.zip
         &exe("unzip -a ./$f");                    # /cgi-bin/web-gui/data_09a1

         # delete zip
         if (-f "./$f") { &exe("rm ./$f"); }

         $f=~s/\.zip//;  $f=~s/.*-/data_/;         # data_0.9a1

         # opt rm already downloaded folder
         if ((-d "/var/web-gui/$f") && ($f ne "")) {
            $t=`sudo rm -r /var/web-gui/$f`;
         }

         &exe("cp -R ./web-gui/. /var/web-gui");   # new option to activate

         #delete downloaded files
          if (-d "./web-gui") { &exe("rm -r ./web-gui"); }


         #change owner of /napp-it to web-account on every start of napp-it
         `sudo $sys{'binpath'}chown -R napp-it /var/web-gui/$f`;

        #set permission to -R 755
        `sudo $sys{'binpath'}chmod -R 755 /var/web-gui/$f`;


         #step 1. rename old data -> data_last
         if (-d "/var/web-gui/data_last") {                                     # already a last version?
                     &exe("rm -r /var/web-gui/data_last/");
         }
         &exe("cp -R /var/web-gui/data/. /var/web-gui/data_last/");             #/. opt create target


         # del all folders to be updated (simple rename of whole folder gives problems with httpd)
         &exe("rm -r /var/web-gui/data/napp-it");
         &exe("rm -r /var/web-gui/data/tools");
         &exe("rm -r /var/web-gui/data/wwwroot/_doc");
         &exe("rm /var/web-gui/data/wwwroot/*.html");                 # root folder

         #copy new files
         &exe("cp -R /var/web-gui/$f/. /var/web-gui/data/");


         #change owner of /napp-it to web-account on every start of napp-it
         `sudo $sys{'binpath'}chown -R napp-it /var/web-gui/data`;

        #set permission to -R 755
        `sudo $sys{'binpath'}chmod -R 755 /var/web-gui/data`;

         print "<br>$f downloaded and activated.<br>\n ";
    }

    # kill all dns-sd Bonjour settings
    &exe("pkill dns-sd");


    #reload
         sleep(1);
         $in{'l1'}=""; $in{'l2'}=""; $in{'l3'}="";
         &reload_onupdates;
         exit;

}

###################### select download/ activate
$opt="-select-,";

#option1, activate a saved versions
@t=();
if (-d "/var/web-gui/") {
  &read_dir("/var/web-gui/","t","/",__LINE__);
}

@t=sort(@t);
@t=reverse(@t);  # newest first
#&print_array(@t);

my $i=1;
my $activate=",";
foreach my $t (@t) {

   if (!($t=~/^data\_/)) { next; }
   $t=~s/\///;

   #unlink folder > 5
   ##################
   if ($i > 5) {
      $f="/var/web-gui/$t";
      # print "rm -r $f";
      &exe("rm -r $f");
      next;
   }
   $i++;

   $t=~s/data_//;
   $opt.="activate $t,";
   $activate.="$t,";
}
#&mess("$activate");

# add download options
$t="$free,$pro_sel"; $t=~s/ +//g;
@t=split(/,/,$t);
for my $t (@t) {
     # if ($activate=~/$t\b/)  { next; }      # allow reload
     $opt.=",download $t";
}

$opt=~s/,$//;
# Text Update or Downgrade
###########################
$txt{'txt_update'}=~s/=v=/$sys{'version'}/gs;
$txt{'txt_update'}=~s/=f=/$free $newest_f/gs;

if ($pro eq "") {
     $txt{'txt_update'}=~s/=p=//gs;
} else {
     $txt{'txt_update'}=~s/=p=/$pro $newest_p/gs;
}
$txt{'txt_update'}=~s/=w=/$wget/gs;

print <<EoF;
<pre>$txt{'txt_update'}
</pre>
EoF

&ask('begin');
&ask('select_options',$txt{'select'},$opt,"-");
&ask('confirm','submit',$txt{'proceed'});
&log_end;
print "<br><br><br><br>";
exit;

}

##########################

#remove private menue item
sub menue_remove {
##################
&mess("obsolete");


}
###


###########         menu options after = or ==      return: menutext, NAHI, i (Noedit, Admin, Hide,Icon)
sub l_opt {
###########
my ($n,$opt,$noedit,$icon,$admin,$m,$hide,$nr);

#  parameter foldername ex 01_help
# check options char on

# within option  menutext=AH  -> option is AH
# N    noedit
# H    hide
# A    admin only
# I    Icon or I(20)
# abc  must be in auto_os_type or auto_os
# -abc must not be in  auto_os_type or auto_os


$n=$_[0];        # original foldername
$m=$_[1];        # menuindex ex 01.04.05

$opt=$n;
if ($n=~/=/) {
    $opt=~s/^.*=//;
    $n=~s/=.*//;
} else {
    $opt="";
}
$n=~s/ +$//;                                    # trim
$n=~s/^\d+_//;

############### options
# option example 01_format=sol_nNA    (nexenta, noedit, admin only)
# parameter [-]abc to hide is only valid on source file

if ($opt=~/\-/) {                               # exclude in auto_os or auto_os_type
                $t=$opt;
                $t=~s/[^a-z]//g;
                if ($t ne "") {
                    if ("$sys{'auto_os_type'}$sys{'auto_os'}"=~/$t/)    {
                        return ("$n","H");      # hide
                    }
                }
}  else {
       if ($opt=~/[a-z]/) {
                $t=$opt;
                $t=~s/[^a-z]//g;

                 # include
                 if ($t ne "") {
                     if (!("$sys{'auto_os_type'}$sys{'auto_os'}"=~/$opt/)) {
                         return ("$n","H");
                     }
                 }
      }
}

##
# parameter Admin and No-edit only can be on source and language file
if ((!($in{'id'} =~/^admin/)) && ($opt=~/A/))  { $admin="A"; }
if ($opt=~/N/) { $noedit="N"; }


# replace n with name from language file
$m="m$m";
if ($txt{$m} ne "") {
       $n=$txt{$m};
       $opt=$n;
       if ($n=~/=/) {
           $opt=~s/^.*=//;
           $n=~s/=.*//;
       } else {
           $opt="";
       }
} else {
  if (!($m=~/\./)) {
    $n=~s/ .*//;     # first word only in level 1
  }
  $n=~s/_/ /g;
}
$n=~s/ +$//;                                    # trim

# check HNI (either on source or on language file)
if ((!($in{'id'} =~/^admin/)) && ($opt=~/A/))  { $admin="A"; }
if ($opt=~/N/) { $noedit="N"; }
if ($opt=~/H/) { $hide="H"; }
if ($opt=~/I/) {
   if ($opt=~/I\(\d+\)/) {       # I(20) -> Icon 20.png
      $nr=$opt;
      $nr=~s/.*I\(//;
      $nr=~s/\).*//;             # ex 20
      $icon="I$nr";
   } else {
      $icon="I";
   }
}

 #return
 return ("$n","$noedit$admin$hide$icon");       # NAHI
}



############## parse input
sub parse_in {
##############
my ($k,$v);

              if (!(defined $in{'name'})) { $in{'name'}=""; }
              if (!(defined $in{'pass'})) { $in{'pass'}=""; }
              if (!(defined $in{'pre'}))  { $in{'pre'}=""; }
              if (!(defined $in{'name'})){ $in{'name'}=""; }
              if (!(defined $in{'l1'})){ $in{'l1'}=""; }
              if (!(defined $in{'l2'})){ $in{'l2'}=""; }
              if (!(defined $in{'l3'})){ $in{'l3'}=""; }
              if (!(defined $in{'action'})){ $in{'action'}=""; }
              if (!(defined $in{'edited'})){ $in{'edited'}=""; }
              if (!(defined $in{'item'})){ $in{'item'}=""; }
              if (!(defined $in{'id'})){ $in{'id'}=""; }

              $in{'name'}=~s/[^A-Za-z0-9]//g;
              $in{'pass'}=~s/\|//g;
              $in{'pre'}=~s/[^v\d]//gs;

              $in{'l1'}=~s/\||\/\\//gs;  $in{'l1'}=~s/^\.+//;

              $in{'l2'}=~s/\||\/\\//gs;  $in{'l1'}=~s/^\.+//;
              $in{'l3'}=~s/\||\/\\//gs;  $in{'l1'}=~s/^\.+//;
              $in{'action'}=~s/[^a-zA-Z0-9\.\_\-\ \+]//gs;
              $in{'edited'}=~s/[^a-zA-Z0-9\.\_\-\ \+]//gs;

              $in{'item'}=~s/\||\/\\//gs;  $in{'item'}=~s/^\s+//; $in{'item'}=~s/\s+$//g;   $in{'item'}=~s/^\.+//;

              #private text inputs  form to text
               while (($k,$v) = each %in) {
                  if ($k=~/^text/) {
                    $in{$k}=&f2t($in{$k});
                  }
               }

               # problem: $in{'member'}=$in{'member'}$in{'member'}??
               $in{'member'}=~s/[^a-z0-9\_\-\.~]/~/g;
               @t=split(/~/,$in{'member'}); if (@t >2) {  $in{'member'}="$t[(@t-2)]~$t[(@t-1)]"; }

               $current{'member_ip'}=$t[(@t-1)];
               $current{'member_hostname'}=$t[(@t-2)];
}


############### verify ############################

###########
sub login {
###########
my $s;
my ($h,@p,$status);


if ($cfg{'value_adminpw'} eq "")    {
        $h =" -adminpw  $txt{'disabled'} !!";
}

if ($cfg{'value_operatorpw'} eq "") {
        $h.="<br> -operatorpw $txt{'disabled'} !!";
}

my $message="";
if (-f "$wpath//_my/message.txt") {
  $message=&socket("type $wpath/_my/message.txt");             # powershell allows /
}
if ($message ne "") { $message.="<br><br>"; }

# select user
$s=&select('name','admin,operator',$cfg{'select_defuser'},'','','','width: 107px');

$t=~s/^\d+//; # or time at first login or ex wrong pw
$t.="<br><br>";

$status=&ample_state('','1');

print<<Eol;

<style type="text/css">
   #status {  position: absolute; width:99%; text-align: right; top:78px; z-index:9; } }
</style>

<!--nows-->
<table style="width:99%; height:60%">

<tr><td>
$status

</td></tr>
<tr>
  <td style="vertical-align:middle; text-align: center; padding-top: 30px">
      <form name="login" method="post" action="/cgi-bin/admin.pl">
            <table border="0" style="margin:auto; text-align:left; width: 450px; height:180px; border: 1px solid #cccccc; background-color: #cccccc">

            <tr style='background: url(/_doc/oibg.png) repeat-x'>
            <td colspan="2" style="text-align:left; padding-left: 190px; vertical-align: middle; height: 25px;font-size:16px"><b>Login</b></td>
            </tr>

            <tr style='background: url(/_doc/oibg.png) repeat-x'>
            <td style="width: 160px; text-align: right; vertical-align: middle; height: 25px;font-size:13px"><b>user:</b>&nbsp;</td>
            <td style="vertical-align: middle; height: 25px; font-size: 14px">$s</td>
            </tr>

            <tr style='background: url(/_doc/oibg.png) repeat-x'>
            <td style="width: 160px; text-align: right; vertical-align: middle; height: 25px;font-size:13px"><b>pass:</b>&nbsp;</td>
            <td style="vertical-align: middle; height: 20px"><input type="password" name="pass" style='font-size: 12px; width: 100px'>
            <input type='submit' name='submit' value='login' style='font-size: 11px; margin-left:30px'>
            <input type='hidden' name='member' value=\"$in{'member'}\">
            </td>
            </tr>

            <tr>
            <td colspan="2" style="text-align:left; background-color:#eeeeee; padding:8px"">
            $t

            <font style="font-size:11px">$txt{'first_login'}<br><br>
            <span style="color:#ff0000">$h</span></font>
            <br><br>
            $message

            </td>
            </tr></table>
      </form>
  </td>
  </tr></table>

</div>\n<!--admin 2379--></body></html>

Eol

&log_end;

exit;     # </div></body> from menu
}


############
sub login_ok {
#############
  #read web-gui.cfg
  my ($id,$p,$file,@p,$pw,$access,$t,$alert,$r);

     &getid_client;    # read clientinf

#&print_hash(%in);
     ##########
     if ($in{'name'} eq "admin") {      #ok

             $current{'USER'}="admin";

             $pw=$in{'pass'};
             $in{'pass'}=&get_sha_hash($in{'name'},$in{'pass'});

             #pw gespeichert=
             if ($cfg{'value_adminpw'} ne "") {
                if ($cfg{'value_adminpw'} ne $in{'pass'}) {
                    $t="<font style='font-size: 10px'>wrong admin password</font>";
                    &login;    #ok ask login
                }
             }

             $file='$wpath/_log/web-gui.cfg';
             if (!(-f $file)) { $in{'l2'} ="setup"; }

            print "<p style='margin-left: 5px; font-size: 9px'>$txt{'first_login_wait'}</p>";




            # set session
             &getid_set;

             # del old tmp in npp-it start!
             #&exe("del $sys{'tmp'}\\*.*");

             # reminder
             $t="";
             if (-f "$wpath/_log/appliance.log") {
                  $t=&socket("type $wpath\\_log\\appliance.log","127.0.0.1");
                  @t=();
                  @t=split(/\n/,$t);
                  $alert="Reminder: one or more extensions are due to expire: \\n\\n";
                  foreach my $v (@t) {
                          if ($v=~/eval/)             { next; }
                          if (!($v=~/\d+\.\d+\.\d+/)) { next; }
                          $p=$v;
                          $p=~s/::.*//;

                          $v=~s/:.*//;
                          $v=~s/.*\- //;                  # keep data
                          $r=&date2diff($sys{'date'},$v); # 2val - 1val

                          #&mess($r);

                          if (($r<21) && ($r>0)) {
                                $alert.="$p ($r days left)\\n";
                          }
                  }
                  #&mess($alert);

                  if ($alert=~/\d/s) {
                       $alert.="\\n\\nrenew at: \\nhttps://napp-it.org/extensions/quotation_en.html";
                       print <<EoF;
                       <script type="text/javascript">
                       alert ("$alert");
                       </script>
EoF
                  }
             }

#&print_hash(%in);
             #reload
             print <<EoR;
     <script type="text/javascript">
             window.location.href = "/cgi-bin/admin.pl?id=$in{'id'}&amp;action=&amp;member=$in{'member'}&amp;l1=&amp;l2=&amp;l3=";
     </script>
EoR
exit;
       }


       if ($in{'name'} eq "operator") {      #ok

             $current{'USER'}="operator";
             $in{'pass'}=&get_sha_hash($in{'name'},$in{'pass'});

             #pw gespeichert=
             if ($cfg{'value_operatorpw'} ne "") {
                if ($cfg{'value_operatorpw'} ne $in{'pass'}) {
                    $t="<font style='font-size: 10px'>wrong operator password</font>";
                    &login;    #ok ask login
                }
             }

             # set session
             &getid_set;


             #reload
             print <<EoR;
     <script type="text/javascript">
             window.location.href = "/cgi-bin/admin.pl?id=$in{'id'}&amp;action=&amp;member=$in{'member'}&amp;l1=&amp;l2=&amp;l3=";
     </script>
EoR
exit;
       }


  $t="<font style='font-size: 10px'>unknown user or invalid pw</font>";
  print "</div>\n<!--admin 2474-->";
  &login;    #ok ask login
}


###########  get hashvalue from cleartext pw, pw, today only
sub get_sha_hash {
###########
        my $name=$_[0];
        my $pass=$_[1];
        if ($pass eq "") { $pass="hjkXkjh"; }              #

        my $h  = sha256_hex($pass);      # sha
        return ($h);                     # return hash
}


##########     clientinfos
sub getid_client {
#########

      # call in line 280
      @t=();
      %t=();

      ## current session data
      $current{'HTTP_USER_AGENT'}=$ENV{'HTTP_USER_AGENT'};
      $current{'REMOTE_ADDR'}=$ENV{'REMOTE_ADDR'};

      @t=split(/,/,$in{'id'});
      $current{'USER'}=$t[0];     if ($current{'USER'} eq "")    { $current{'USER'}="--";    }
      $current{'REF'}=$t[1];      if ($current{'REF'} eq "")     { $current{'REF'}="--";     }
      $current{'SESSION'}=$t[2];  if ($current{'SESSION'} eq "") { $current{'SESSION'}="--"; }

      if ($current{'HTTP_USER_AGENT'} eq "") { $current{'HTTP_USER_AGENT'}="unknown"; }
      if ($current{'REMOTE_ADDR'} eq "")     { $current{'REMOTE_ADDR'}="unknown"; }

      # get values from /var/web-gui/_log/tmp/session_ip.txt

      # opt delete all sessions on a new day
      my $dop=&date2dop($sys{'date'});
      my $file="$tpath/session.$dop";

      my @files = glob("tpath/session.*");
      foreach my $file (@files) {
        if (-f $file) {
           # unlink("$file");               # delete all sessions     2> /dev/null
            &my_write("$file","marker for current day = $dop");
         }
      }

      $file="$tpath/session.$current{'REF'}";         # session: R1(time)|id1,id2|     multi id=multitab
      if (-f $file) {
           @t=(); %t=();
           &read_ahfile($file,'t','h','getid_client');  # values  S_ID|session1,session2,..|            Referenz
                                                        #         S_AGENT|user agent|


          # debug                                              #         S_TIME|time()|                        #last access
          # &print_hash(%t);

          #add sessions to Current
          if ($t{'S_IP'} ne "")    { $current{'S_IP'}=$t{'S_IP'};       } else { $current{'S_IP'}="-";    } # session ip
          if ($t{'S_ID'} ne "")    { $current{'S_ID'}=$t{'S_ID'};       } else { $current{'S_ID'}="-";    } # session id
          if ($t{'S_USER'} ne "")  { $current{'S_USER'}=$t{'S_USER'};   } else { $current{'S_USER'}="-";  } # session user
          if ($t{'S_AGENT'} ne "") { $current{'S_AGENT'}=$t{'S_AGENT'}; } else { $current{'S_AGENT'}="-"; } # session agent
          if ($t{'S_TIME'} ne "")  { $current{'S_TIME'}=$t{'S_TIME'};   } else { $current{'S_TIME'}="-";  } # last time

      }

      # &mess($file);
      # &print_hash(%t);

}



########### set session after login
sub getid_set {
##########
#&mess(__LINE__);
          # write next session data
          $current{'REF'}=time();

          # newrandom id
          my  @set=('a'..'z','A'..'Z','0'..'9');
          my  $str = join '' => map $set[rand @set], 1 .. 16;

          $in{'id'}="$current{'USER'},$current{'REF'},$str";

          @t=();
          my $file="$tpath/session.$current{'REF'}";

          $t[0]="S_AGENT|$current{'HTTP_USER_AGENT'}|\n";
          $t[1]="S_ID|$str|\n";                       # new session id
          $t[2]="S_LID||\n";                          # last id
          $t[3]="S_IP|$current{'REMOTE_ADDR'}|\n";     # ip

          $t=time();
          $t[4]="S_TIME|$t|\n";

          $t[5]="S_USER|$current{'USER'}|\n";         # user
          $t[6]="S_VER|$cfg{'ver'}|\n";               # ver

          $t=join("",@t);

          open (PF, ">$file");                                                       # write request, processed in agent_acc.pl
             flock(PF, LOCK_EX);
             print PF "$t";
          close (PF);


          #$t{'S_IP'}=$current{'REMOTE_ADDR'};
          #$t{'S_ID'}=$str;
          #$t{'S_USER'}=$current{'USER'};
          #$t{'S_AGENT'}=$current{'HTTP_USER_AGENT'};
          #$t{'S_TIME'}=time();


          #`touch $file`;
          # &hash2file('t',$file);


          #debug
          #print "<br><br> <font style='font-size:9px'>session=$in{'id'}</font>";
          #sleep(2);
}

########### user id: name, + hash of date,name, saved hash pw
sub getid {
###########    parameter
          my (@set,$str,$id,@id,$new,$name);

          my $ref=time();
          $name=$current{'S_USER'};

          $current{'TIME'}=time();

          # get id values
          @id=();
          @id=split(/,/,$in{'id'});                  # name, ref=time, id
          if ($id[1] eq "") { $t="id missing, please login again!"; &header;  &login;     }        # load header prior login

          $current{'LSESSION'}=$id[2];

          my $file="$tpath/session.$id[1]";                        # name ok
          if (!(-f $file)) {
              $t="session missing, please login again!";  &header;  &login;   # load header prior login
          }

          # check valid session

              if ($current{'S_ID'} ne $id[2])                          {
                    $t="<font style='font-size:10px'>session id not valid or too old, please login again!</font>"; &header; &login;
              }

              #check ip and user agent
              if ($current{'S_IP'} ne $current{'REMOTE_ADDR'})         {
                    $t="<font style='font-size:10px'>wrong ip, please login again!</font>"; &header; &login;
              }
              if ($current{'S_AGENT'} ne $current{'HTTP_USER_AGENT'})  {
                    $t="<font style='font-size:10px'>wrong user agent, please login again!</font>";  &header; &login;
              }

              if ($current{'S_USER'} ne $current{'USER'})  {
                    $t="<font style='font-size:10px'>wrong user, please login again!</font>";  &header;  &login;
              }

          # allow re-use of current id within 50min from initial call (enable reload)
            if ($current{'TIME'}-$current{'S_TIME'} < 3000) { return; }


          # newrandom id
             @set=('a'..'z','A'..'Z','0'..'9');
             $str = join '' => map $set[rand @set], 1 .. 16;

          # background
          #if ($current{'S_IP'} eq "") { return; }

          #&print_hash(%in);
          #&print_array(@t);

          #set next id
          $in{'id'}="$current{'USER'},$current{'REF'},$str";

          # write next session data
          @t=();
          my $file="$tpath/session.$current{'REF'}";

          $t[0]="S_AGENT|$current{'S_AGENT'}|\n";
          $t[1]="S_ID|$str|\n";                       # new session id
          $t[2]="S_LID|$current{'LSESSION'}|\n";      # last id
          $t[3]="S_IP|$current{'S_IP'}|\n";           # ip

          $t=time();
          $t[4]="S_TIME|$t|\n";

          $t[5]="S_USER|$current{'S_USER'}|\n";       # user
          $t[6]="S_VER|$cfg{'ver'}|\n";                # ver

          #$t{'S_IP'}=$current{'S_IP'};
          #$t{'S_ID'}=$str;
          #$t{'S_LID'}=$id[2];                                 # last id
          #$t{'S_USER'}=$current{'S_USER'};
          #$t{'S_AGENT'}=$current{'S_AGENT'};
          #$t{'S_TIME'}=time();


          $t=join("",@t);
          open (PF, ">$file");                                                       # write request, processed in agent_acc.pl
             flock(PF, LOCK_EX);
             print PF "$t";
          close (PF);

}


######################  /verify #######################

##############
sub edit_sys {
#############
# edit systemfiles in ../_log/edit with last three versions
# copy back to origin as root
  #my ($ant,$tmp,$file,$ok, $list, $action, $str, $i, $v1, $v2, $v3, $pre, $b1, $b2, $f, $l);
  my ($file,$src,$edit,$v0,$v1,$v2,$v3,$r,$pre,$str,$b1,$b2);
  @t=();
  if (!($in{'id'}=~/^admin,/)) { &error("only for admin"); }

  # no log window
  &log_end;

  # edit file
  $file=$_[0];
  $file=&name2file($file);
  if (!(-f "$file")) { &error("file $file not found"); }

  #_versions
      $t=$file;  $t=~s/\//:/g;
      $v0="$wpath/_log/edit/$t"."_v0.log";
      $v1="$wpath/_log/edit/$t"."_v1.log";
      $v2="$wpath/_log/edit/$t"."_v2.log";
      $v3="$wpath/_log/edit/$t"."_v3.log";
  #

  #preversions
      $pre="<font style='font-size: 10px'>versions:</font> ";
      if (-f $file) {
           if ($in{'pre'} eq "") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2=""; }
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 saved $b2</a>" ;
      }
      if (-f $v1) {
           if ($in{'pre'} eq "v1") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2="";}
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=v1&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 -1 $b2</a>" ;
      }
      if (-f $v2) {
           if ($in{'pre'} eq "v2") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2="";}
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=v2&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 -2 $b2</a>" ;
      }
      if (-f $v3) {
           if ($in{'pre'} eq "v3") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2="";}
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=v3&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 -3 $b2</a>" ;
      }

  if ($in{'pre'} eq "")   {   $src=$file; }
  if ($in{'pre'} eq "v1") {   $src=$v1;   }         # preversion
  if ($in{'pre'} eq "v2") {   $src=$v2;   }
  if ($in{'pre'} eq "v3") {   $src=$v3;   }

  if (!(-f "$src")) { &error("file/version $src not found"); }
  $str=&exe("cat $src");
  $str=&t2f($str);

  ##edited -> save file?
  if ($in{'edited'}) {

      #&print_var($v1);  exit;     #debug

      $in{'text'}=&f2t($in{'text'});
      $in{'text'}=~s/<n>/\n/gs;

      #save/ rename/del versions
         if (-f $v3)   { unlink($v3); }           # del version3
         if (-f $v2)   { rename($v2,$v3);    }
         if (-f $v1)   { rename($v1,$v2);    }
         if (-f $v0)   { rename($v0,$v1);    }

         open (PF, ">$v0") || &error("edit_sys write-error: $v0");   # always write v0/current
             print PF "$in{'text'}";
         close (PF);

      # update src
         #&error("$v0<br>$file");
         print "cp $v0 $file<br>";
         &exe("cp $v0 $file");
         return;
  } else {
      ##### create form ###############

      $t=$file;
      print "<script language='javascript'>\$('#hl').html('edit $file')</script>\n";
      print <<EoF;
         <form name="add" method="post" action="/cgi-bin/admin.pl">
         <input type="hidden" name="id" value="$in{'id'}">
         <input type="hidden" name="l1" value="$in{'l1'}">
         <input type="hidden" name="l2" value="$in{'l2'}">
         <input type="hidden" name="l3" value="$in{'l3'}">
         <input type="hidden" name="edit" value="$in{'edit'}">
         <input type="hidden" name="action" value="$in{'action'}">
         <input type="hidden" name="edited" value="1">
         <input type="hidden" name="answered" value="1">
         <input type="hidden" name="file" value="$file">
         <input type="hidden" name="src" value="$in{'src'}">
         <table border="0" style="width:99%; height:90%; border:none; padding:0; margin:0;">
         <tr>
            <td valign="top" style="height:12px"><b>Edit file: $file</b></td>
            <td valign="top" align="right" style="height: 12px; padding-right: 10px">$pre</td>
         </tr>
         <tr>
         <td colspan="2" valign="top" style="height:450px">
<textarea name=\"text\" style=\"width:99%; height:450px; padding: 5px\" class=\"tt\" wrap=\"off\">$str</textarea>
<br>\n<input type='submit' name='submit' value='save file' style='font-size: 10px; margin-top:15px'><br><br><br>\n
         </td></tr></table>

EoF
  }

#show form only
exit;

}


######### parameter file; ex &edit('/etc/hosts');
sub edit {
#########
    my ($r, $txt, $file, $src, $p, $s);

  #############
  #file to edit
  #############
    $src="$_[0]";

    # reload page after edit -> save
    if ($in{'src'} ne "") {
       $src=$in{'src'};
    }


  #################
  #set file to edit
  #################
   $file=$src;
   $file=~s/^.*\///;       # ex /etc/hosts  -> hosts

   $p=$src;
   $p=~s/$file$//;         # source path

   $file="$sys{'path'}"."$file";   # tmp-file to edit
   $file=~s/\'+\//\//g;            # edit in my

  #&mess("2765 $file<br>$src");
  #############
  # save edited
#&print_hash(%in);

  #############
  if ($in{'cons'} ne "1") {  #not when klicked on cmd
   if ($in{'edited'}) {

     &edit_file("$file","$_[1]",$src);  #save

#&print_hash(%in);
     $file=&name2path($file);
     $p=&name2path($p);

     $r=&exe("cp $file $p");

     if ($file=~/appliance\.log/) {
           $t=$file;
           $t=~s/\.log.*//;
           &exe("rm $t*");
     }

     print "<br>ok file saved and copied back<br>cp $file $p";
     if ($r ne "") { &mess("$r"); }

     sleep(2);
     #&print_hash(%in);

     $in{'edited'}="";

     if ($in{'no_reload'} eq "1") { return; }          # in case of a edit needs additional commands like other refreshes
     if (($in{'l3'} eq "") && ($in{'l2'} ne ""))  { $in{'l2'}=""; }
     if ($in{'l3'} ne "") { $in{'l3'}=""; }

     &reload();
     return;
   }
  }

  ##################
  # form: edit file
  ##################

     $p=$sys{'path'};
     $p=&name2path($p);

     $s=$src;
     $s=&name2path($s);


     #file exist?
     if (!(-f $src)) { &error("edit 2806 : source file not found<br>$src"); }

     $r=&exe("cp $s $p");                            # edit only in path allowed
     if ($r ne "") { &mess($r); }
     if (!(-f $file)) { &error("edit: copy failure <br>$file"); }

     $s=$file;
     $s=&name2path($s);

     $r=&exe("chmod 666 $s");
     if ($r ne "") { &mess($r); }

     &edit_file("$file",$_[1],$src);

} #/sub
########



###############
sub edit_file {  # parameter file, show line numbers
############### edit textfiles  alternativ datei als parameter
  my ($ant,$my,$tmp,$file,$ok, $list, $action, $str, $i, $v1, $v2, $v3, $pre, $b1, $b2, $f, $l);
  @t=();
  if (!($in{'id'}=~/^admin,/)) { &error("only for admin"); }

  #eval?
  if ($ev) { return; }

  $t=$in{'l1'};
  $t=~s/\_.*//;
  if ($t>=100) {
     $my="1";
  } else {
     $my="0";
  }

  ######
  if ($in{'item'} eq "") { $in{'item'}="action.pl"; }                            #defaults
  if ($_[0] ne "") { $in{'item'}="$_[0]"; $in{'item'}=~s/.*\///; }               # action.pl or file

  #&print_hash(%in);

  if ($in{'item'} eq "action.pl") {
       if ($in{'l1'} ne "") {$in{'action'}="edit_l1"; }                         # edit actions
       if ($in{'l2'} ne "") {$in{'action'}="edit_l2"; }
       if ($in{'l3'} ne "") {$in{'action'}="edit_l3"; }
  }


  if ($in{'l1'} eq "01_setup") { &error("edit 01_setup not allowed");  }

  if ($in{'action'} eq "edit_l1") {
     if (!($in{'l1'}=~/\w+/))     { &error("item l1 ($in{'l1'}) not valid");  }
     $file="$sys{'ospath'}/$in{'l1'}/$in{'item'}";

     #opt my
     if ($my) {
         $file="$sys{'myospath'}/$in{'l1'}/$in{'item'}";
         $file=~s/[^a-zA-Z0-9\_\-\ \+\/\.=:]//g;

     }
  }

  if ($in{'action'} eq "edit_l2") {
     if (!($in{'l2'}=~/\w+/))     { &error("item l1 ($in{'l2'}) not valid");  }
     $file="$sys{'ospath'}$in{'l1'}/$in{'l2'}/$in{'item'}";
     #opt my
     if ($my) {
         $file="$sys{'myospath'}/$in{'l1'}/$in{'l2'}/$in{'item'}";
         $file=~s/[^a-zA-Z0-9\_\-\ \+\/\.=:]//g
     }
  }

  if ($in{'action'} eq "edit_l3") {
     if (!($in{'l3'}=~/\w+/))     { &error("item l1 ($in{'l3'}) not valid");  }
     $file="$sys{'ospath'}$in{'l1'}/$in{'l2'}/$in{'l3'}/$in{'item'}";
     #opt my
     if ($my) {
         $file="$sys{'myospath'}/$in{'l1'}/$in{'l2'}/$in{'l3'}/$in{'item'}";
         $file=~s/[^a-zA-Z0-9\_\-\ \+\/\.=:]//g
     }
  }

  if ($_[0] ne "") {
       $file=$_[0];
       $file=~s/^.*\///;
       $file="$sys{'path'}$file";                   # edit only in path allowed
       $file=~s/\'+//g;
       $file=~s/\'+\//\//g;
       if (!(-f $file))     { &mess("1489 sub edit_file: file not found<br>$file<br>");  }
  }  else {
       print "    <br><br>\n";
  }


  #_versions
      $v1="$file"."_v1.log";
      $v2="$file"."_v2.log";
      $v3="$file"."_v3.log";




  ##edited -> save file?
  if ($in{'edited'}) {

      #&print_var($file);  exit;     #debug

      $in{'text'}=&f2t($in{'text'});
      $in{'text'}=~s/<n>/\n/gs;


      #system command in action not allowed
      if ($file=~/action\.pl$/) {

        $in{'text'}=~s/\= *\`/=\&exe\(\"/gs;
        $in{'text'}=~s/\`;/\"\)\;/gs;

        if ($in{'text'}=~/\`/s) { &error("System call via backtick operator ex \$a=`zpool list`; is not allowed. <br>-> use: \&exe('zpool list');"); }
        if ($in{'text'}=~/system\s*\(/is) { &error("System call via system operator ex \$a=system(... is not allowed. <br>-> use: \&exe('...');"); }
        if ($in{'text'}=~/exec\s*\(/is)   { &error("System call via exec operator   ex \$a=exec(...   is not allowed. <br>-> use: \&exe('...');"); }
      }

     # edit appliance.log
     if ($in{'file'}=~/appliance\.log/) {
        @t=();
        @t=split(/\n/,$in{'text'});
        foreach my $t (@t) {
             $t=~s/^\s+//; $t=~s/\s+$//;
             if ($t=~/^complete /) { $t="app_complete|$t|"; }
             if ($t=~/^pro /)      { $t="app_pro|$t|"; }
             if ($t=~/^acl /)      { $t="app_acl|$t|"; }
             if ($t=~/^replicate /){ $t="app_replicate|$t|"; }
             if ($t=~/^monitor /) { $t="app_monitor|$t|"; }
             if ($t=~/^complete /) { $t="app_complete|$t|"; }
        }
        $in{'text'}=join("\n",@t);
     }

     if ($in{'file'}=~/action\.pl/) {

               $tmp="$file\.tmp";
               if ($in{'activate'} eq "1") { #activate manually
                    #rename/del versions
                    if (-f $v3)   { unlink($v3); }           # del version3
                    if (-f $v2)   { rename($v2,$v3);  }
                    if (-f $v1)   { rename($v1,$v2);  }
                    if (-f $file) { rename($file,$v1);  }
                    rename($tmp,$file);
                   return;
               }

               unlink ($tmp);
               #eval first

               if (($in{'text'}=~/sub +my_action +\{/s) && ($in{'text'}=~/1\;/s)) {

                   open (PF, ">$tmp") || &error("(1621) write-error: $tmp");
                                 print PF "$in{'text'}";
                   close (PF);
                   $t=&name2path($tmp);
                   $p=&exe("chmod 755 $t","n");

                   #activate manually            #rename action.pl.tmp action.pl
                   if ($in{'activate'} ne "1") {

                         #activate action manuall
                         $t="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;action=$in{'action'}&amp;edited=$in{'edited'}&amp;activate=1&amp;edit=$in{'edit'}\">manually</a>";

                         print "<b class='font_orange'><hr>evaluate script:</b> .... please wait and";
                         print " <a href=\"javascript\:history.back()\"><b>go back</b><\/a> only if you get \"Software error\"<br><br>\n";
                         print "if your script needs libraries, (load them or ignore undefined subroutine) or<br>\n";
                         print "if your script contains something like 'exit', you must activate your action $t<hr>\n";


                         require "$tmp";

                         #load all default libs to avoid errors about missing libs
                         # read all files in $ospath."_lib"
                           @t=();
                         &read_dir("$sys{'ospath'}\_lib","t","",__LINE__);
                         foreach $l (@t) {
                                 if (!($l=~/lib\.pl$/)) { next; }
                                 require "$sys{'ospath'}\_lib/$l";
                         }
                         $ev="1";
                         eval (&my_action);

                         if ($@) {
                            warn
                            exit;
                         }
                         $ev="";
                 }
              }
              unlink ("$tmp");

     }

     if (!($ev)) {
        #rename/del versions
         if (-f $v3)   { unlink($v3); }           # del version3
         if (-f $v2)   { rename($v2,$v3);  }
         if (-f $v1)   { rename($v1,$v2);  }
         if (-f $file) { rename($file,$v1);  }

         $in{'text'}=~s/→/\t/gs;                # utf8 tab

         open (PF, ">$file") || &error("(626) write-error: $file");
             print PF "$in{'text'}";
         close (PF);

       $t=&name2path($file);
       $p=&exe("chmod 755 $t","n");
     }


     if ($_[0] eq "") {
       #reload
       print <<EoR;
     <script type="text/javascript">
             window.location.href = "/cgi-bin/admin.pl?id=$in{'id'}&amp;action=&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}";
     </script>

EoR
       }  #/$_[0]


    } else {
        ## form


    #### edit $file ###########
    if ($in{'pre'} ne "") {
      $file.="_$in{'pre'}.log";

      #del opt. tmp
      $tmp="$file\.tmp";
      unlink ("$tmp");
    }

    if ($file=~/action\.pl$/) {
        #lese eval -file
        $tmp="$file\.tmp";
        if (-f $tmp) {
           $file=$tmp;
        }
    }
#&mess($file);
    if (!(-f $file))     { &error("1118 file $file not found");  }
    &read_ahfile("$file","t","a");

    $str="";

    #write linenumbers
    if ($in{'ln'}) {
        $str=join("",@t);
        $i="1";
        foreach $tmp (@t) {
              $tmp="($i):\t$tmp";
              $i++;
        }
    }

    $str="";
    foreach $tmp (@t) {
      $str.="$tmp";
    }
    $str=&t2f($str);

    #preversions
      $pre="<font style='font-size: 10px'>versions:</font> ";
      if (-f $file) {
           if ($in{'pre'} eq "") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2=""; }
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 saved $b2</a>" ;
      }
      if (-f $v1) {
           if ($in{'pre'} eq "v1") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2="";}
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=v1&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 -1 $b2</a>" ;
      }
      if (-f $v2) {
           if ($in{'pre'} eq "v2") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2="";}
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=v2&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 -2 $b2</a>" ;
      }
      if (-f $v3) {
           if ($in{'pre'} eq "v3") { $b1="<b>"; $b2="</b>"; } else { $b1=""; $b2="";}
           $pre.="\n        <a href=\"/cgi-bin/admin.pl?pre=v3&amp;id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;edit=$in{'edit'}\" style=\"font-size:9px; margin-left: 5px\">$b1 -3 $b2</a>" ;
      }


      #form
      if (($_[1] eq "") || ($_[1] > 1)) {
         $f="<textarea name=\"text\" style=\"width: 99%; height: 470px; padding: 5px\" class=\"tt\" wrap=\"off\">$str</textarea>";
      } else {
         $f="<input type=\"text\" name=\"text\" value=\"$str\" style=\"width: 450px; height: 22px; padding:0 0 0 3px; margin:0\" class=\"tt\">";
      }

    ##### create form ###############   src=par2
      $t=$file;
      $file=~s/.*\///;
      print "<script language='javascript'>\$('#hl').html('edit $file')</script>\n";
      print <<EoF;
         <form name="add" method="post" action="/cgi-bin/admin.pl">
         <input type="hidden" name="id" value="$in{'id'}">
         <input type="hidden" name="l1" value="$in{'l1'}">
         <input type="hidden" name="l2" value="$in{'l2'}">
         <input type="hidden" name="l3" value="$in{'l3'}">
         <input type="hidden" name="edit" value="$in{'edit'}">
         <input type="hidden" name="action" value="$in{'action'}">
         <input type="hidden" name="edited" value="1">
         <input type="hidden" name="answered" value="1">
         <input type="hidden" name="src" value="$_[2]">
         <input type="hidden" name="file" value="$file">
         <input type="hidden" name="file2" value="$t">
         <table border="0" style="width: 100%; height: 75%; border:none; padding:0; margin:0;">
         <tr>
            <td valign="top" style="height: 12px">file: $file</td>
            <td valign="top" align="right" style="height: 12px; padding-right: 10px">$pre</td>
         </tr>
         <tr>
         <td colspan="2" valign="top">
$f

EoF


#&print_var($t);  exit;     # debug

# edit with submit only on _my files and nonmenus
if ($in{'item'} ne "action.pl") {        # do not edit action.pl via menu
          if ($in{'file2'}=~/_my\//) {
               if (!($in{'ln'})) {                 # without line numbers
                  if ($file=~/_my/) {              # submit only on my menus
                      print "<br><br>\n<input type='submit' name='submit' value='save file' style='font-size: 10px; margin-top:15px'>";
                  }
               }

          } else {
               ######### not a menu, show submit
               if (!($in{'ln'})) {                 # without line numbers
                    print "<br>\n<input type='submit' name='submit' value='save file' style='font-size: 10px; margin-top:15px'>\n";
               }
          } # end menu
}


############################
# switch line numbers on/off
if ($_[1] ne "1") {                       # single line

      if (!($in{'ln'})) {                 # without line numbers
         print "<br><br><a href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;ln=1&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}\" style=\"font-size:9px; margin-left: 5px\">load file with line numbers</a>\n";

      } else {

         print "<br><br><a href=\"/cgi-bin/admin.pl?id=$in{'id'}&amp;ln=&amp;action=$in{'action'}&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}\" style=\"font-size:9px; margin-left: 5px\">load file without line numbers</a>\n";

      }
}



#######
     &log_end;

     print "<br><br><font style=\"font-size:9px;margin-left:5px\"> tabs are used and shown as \&rarr;</font>";
     print "<br><font style=\"font-size:9px;margin-left:5px\">default menus are not editable within the GUI</font><br><br><br>";
     #&show_hash('in');
          print "</td></tr></table>\n</form> \n<!--edit_file--><br></div>\n<!--admin 2944--></body></html>";        # div from menu
          exit;
    }

    if ($_[0] eq "") {
              print "</td></tr></table>\n</form>\n<!--edit_file--><br></div>\n<!--admin 2949--><br><br></body></html>";    # div from menu
              exit;
     }
} #/sub



##########
sub reload {
###########
     #reload     par: reload
     print <<EoR;
     <script type="text/javascript">
             window.location.href = "/cgi-bin/admin.pl?id=$in{'id'}&amp;reload=$_[0]&amp;member=$in{'member'}&amp;l1=$in{'l1'}&amp;l2=$in{'l2'}&amp;l3=$in{'l3'}&amp;action=$in{'action'}&amp;list=$in{'list'}&amp;prop=$in{'prop'}&amp;prop2=$in{'prop2'}&amp;zfs=$in{'zfs'}&amp;folder=$in{'folder'}";
     </script>
EoR
exit;
}



####### eof main ####
1;