#!"\xampp\perl\bin\perl.exe"
#
# (c) guenther alka@napp-it.org 2019-2020
# 29.1.2020
# keyserver
# cfg at $p{'value_keydata_fs'}/keyserver/defaults.cfg
# keys (parts) at $p{'value_keydata_fs'}/keyserver/keys/fsid.kp1 | .kp2
# hosts at $p{'value_keydata_fs'}/keyserver/hosts/hostid/
#

#################################################################
# Set up Variables                                              #
#################################################################

# use CGI::Carp qw (fatalsToBrowser);  # Solaris only
use vars qw(%t %p %in %cfg %sys %current %opt $f $r $t $d);                # menues and global var + global temp

use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

#return header
print "Content-type: text/html\n\n";

# bergabe lesen
&ReadParse;

#print "hostid=$in{'hostid'}\n"; exit;

#parse in
$in{'action'}  =~s/[^a-z]//gs;                # action
$in{'hostid'}  =~s/[^a-zA-Z0-9]//gs;          # hostid
$in{'fsid'}    =~s/[^a-zA-Z0-9\~\_\-]//gs;    # fsid ex pool/data
$in{'keypart'} =substr($in{'keypart'},0,1);   # single digit
$in{'keypart'} =~s/[^1-2]//gs;                # keypart: 1 or 2
$in{'hostname'}=~s/[^a-zA-Z0-9\-\_\.]//gs;    # hostname
$in{'data'}    =~s/[^a-zA-Z0-9]//gs;          # keydata


#lib
require "/var/web-gui/data/napp-it/zfsos/_lib/illumos/keyserverlib.pl";


#load date
&getdate;

if ($in{'hostid'} eq "")                              { print "keyserver:error, missing hostid\n"; exit;  }  # \n at end is neccessary
if ($in{'action'} eq "")                              { print "keyserver:error, missing action\n"; exit;  }  # \n at end is neccessary

# action: write,get,check
if (!($in{'action'} =~/\bwrite\b|\bget\b|\bcheck\b/)) { print "keyserver:error, unknown action\n"; exit;  }  # \n at end is neccessary


# ok need enc config folder from system settings   - > %p
&get_key_par('/var/web-gui/_log/napp-it.cfg','p');

#debug
#&print_hash(%p);

#keyserver ip allowed (About settings)
if ($ENV{'REMOTE_ADDR'} ne "") {
   if ($p{'key_ip'} ne "") {
      $t=quotemeta($p{'key_ip'});
      if (!($ENV{'REMOTE_ADDR'}=~/$t/))                {  print "keyserver:error, client ip range not allowed\n";  exit; }
   }
}

#keyserver disabled (About settings)
if ($p{'select_key_server'} ne "yes")                  {  print "keyserver:error, keyserver disabled\n"; exit;  }  # \n at end is neccessary

# keyserver fs
if (!($p{'value_keydata_fs'}=~/\/\w/))                 {  print "keyserver:error, keydata_fs setting missing\n"; exit;  }  # \n at end is neccessary


# client folder
$r=`sudo test -d "/$p{'value_keyserver_fs'}/keyserver/clients/$in{'hostid'}" && echo 1 || echo 2`;  chomp($r);
if ($r eq "2")                                         {  print "keyserver:error, client folder for $in{'hostid'} not found\n"; exit;  }  # \n at end is neccessary

# read keyserver defaults
$r=`sudo test -f "/$p{'value_keyserver_fs'}/keyserver/defaults.cfg" && echo 1 || echo 2`;  chomp($r);
if ($r eq "2")                                        {  print "keyserver:error, keyserver_fs defaults missing\n"; exit;  }  # \n at end is neccessary

&get_key_par("/$p{'value_keydata_fs'}/keyserver/defaults.cfg",'p');
#&print_hash(%p);

# add host defaults
$r=`sudo test -f "/$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}/defaults.cfg" && echo 1 || echo 2`;  chomp($r);
if ($r eq "1") {
   &get_key_par("/$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}/defaults.cfg",'p');
}
#&print_hash(%p);

# validate REMOTE_ADDR vs "$p{'allow_hostip'}
#&print_hash(%ENV);
$p{'allow_key_thishost'}=~s/\s+//g;
if ($p{'allow_key_thishost'} ne "") {
     if (!($ENV{'REMOTE_ADDR'}=~/^$p{'allow_key_thishost'}/)) {
         {  print "keyserver:error, this host not allowed\n"; exit;  }
     }
}

# global from about settings
if ($p{'value_key_ip'} ne "") {
     if (!($ENV{'REMOTE_ADDR'}=~/^$p{'value_key_ip'}/)) {
         {  print "keyserver:error, ip not in allowed range\n"; exit;  }
     }
}

#hostid required
if ($in{'hostid'} eq "")                          {  print "keyserver:error, hostid required\n"; exit;  }  # \n at

# read keyserver defaults2
$r=`sudo test -f "/var/web-gui/_log/appliance.log" && echo 1 || echo 2`;  chomp($r);
if ($r eq "1") { $t=`cat /var/web-gui/_log/appliance.log`; } else { $t="";}
if ( ($r eq "2") || (!($t=~/\_com/s)) )                  {  print "keyserver:error, pro complete required\n"; exit;  }  # \n at end is neccessary


#check if service is available even for a write
if ($in{'action'} eq "check")   {
    $r=`sudo test -d "/$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}" && echo 1 || echo 2`;  chomp($r);
    if ($r eq "2")  {  print "keyserver:error, no clientfolder\n"; exit; }      # \n at end is neccessary
    print "keyserver:ok, accessable\n"; exit;                                      # \n at end is neccessary
}

#debug
#&print_hash(%p);
#&print_hash(%in);

################################################################
# Main Script                                                  #
################################################################

#require keypart
if (!($in{'keypart'}=~/1|2/))   {  print "keyserver:error, keypart must be 1 or 2\n"; exit;  }  # \n at end is neccessary

#write key
if ($in{'action'} eq "write")   {
     # require data
     if (!($in{'data'}=~/\w+/)) {  print "keyserver:error, data required\n"; exit;  }  # \n at end is neccessary

     #require fsid
     if (!($in{'fsid'}=~/\w+\~\w+/)) {  print "keyserver:error, fsid must be pool~fs\n"; exit;  }  # \n at end is neccessary

     #datafile
     $d="/$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}/keys-part$in{'keypart'}/$in{'fsid'}.kp$in{'keypart'}";

     $r=`sudo test -f "$d" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "1")  {  print "keyserver:error, keyfile exists\n"; exit; }      # \n at end is neccessary


     #check keyfolder
     $r=`sudo test -d "/$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}/keys-part$in{'keypart'}" && echo 1 || echo 2`;  chomp($r);
     if ($r eq "2") {
       `sudo mkdir /$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}/keys-part$in{'keypart'}`;
     }

     #write data
     $f=&get_random_ascii(8);
     $f="/tmp/$f.tmp";

     $r=`sudo echo $in{'data'} > $f`;
     $r=`sudo cp $f $d`;
     `sudo /bin/chmod 700 $d`;            # root only

     $r=`rm $f`;

     #verify data
     $r=`sudo cat $d 2>/dev/null`;  chomp($r);

     if ($r eq $in{'data'}) {
            print "keyserver:ok, data written\n"; exit;           # \n at end is neccessary
     } else {
            print "keyserver:error, data not written\n"; exit;    # \n at end is neccessary
     }

}

#get key
if ($in{'action'} eq "get")   {

    #datafile
    $d="/$p{'value_keydata_fs'}/keyserver/clients/$in{'hostid'}/keys-part$in{'keypart'}/$in{'fsid'}.kp$in{'keypart'}";

    $r=`sudo test -f "$d" && echo 1 || echo 2`;  chomp($r);
    if ($r eq "1")  {

       $r=`sudo cat $d 2>/dev/null`;  chomp($r);
       if (!($r=~/\w+/))  {  print "keyserver:error, no data\n"; exit; }      # \n at end is neccessary
       print "keyserver:ok, $r\n"; exit;                                      # \n at end is neccessary
    } else {
       print "keyserver:error, no keyfile\n"; exit;
    }
}

#debug
#print "$d\n"; exit;

print "keyserver:error, unexpected end\n"; exit;
exit;

# debug


######
#Subs
######



###############
sub print_hash { #parameter %
 my %h = @_;
 my ($k,$v,@tmp,$w);
 print "<p class='tt' style='padding-top:80px'>\<b>&print_hash()</b><hr>\n<table width='1200px'>\n";
 while (($k,$v) = each %h) {
     $v=~s/\n/\\n/gs;
     $v=~s/<br>/\&lt;br&gt;/gs;
     $v=~s/\t/\\t/gs;
     # print "$k \t-> \'$v\'\n";
     push (@tmp,"<tr><td valign='top' width='300px' style='border-bottom: 1px dashed'>$k</td><td nowrap valign='top' style='border-bottom: 1px dashed; padding-bottom: 5px'> -&gt; </td><td valign='top' style='border-bottom: 1px dashed'>\'$v\'</td></tr>");
 }
 @tmp=sort(@tmp);
 $w=join("\n",@tmp);

 print "$w\n</table>";
 exit;
}

sub print_var { #parameter $
###############
   my $t=$_[0];
   $t=~s/\n/\\n/gs;
   $t=~s/<br>/\&lt;br&gt;/gs;
   $t=~s/\t/\\t/gs;
   print "<p style='padding-top:80px'><tt>\&print_var(\$var) - > \'$t\' \n</tt></pre>";
   exit;
}

sub print_array { #parameter @
###############
   my @t=@_;
   my $t;
   print "<pre class='tt' style='padding-top:80px'>\<b>&print_array()</b><hr>\n\n";
  for (my $i=0;$i<@t; $i++) {
       $t=~s/\n/\\n/gs;
       $t=~s/<br>/\&lt;br&gt;/gs;
       $t=~s/\t/\\t/gs;
       print "[$i] -> '$t[$i]\'\n";
   }
   print "\n</pre>";
   exit;
}




sub getdate {                # setzt datumsvariablen
###########
 my ($min,$hour,$mday,$sec,$mon,$year,$wday,$ydat,$isdat);
 ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;

 $sys{'sec'}=$sec;
 $sys{'min'}=$min;
 $sys{'hour'}=$hour;
 $sys{'mday'}=$mday;
 $sys{'mon'}=$mon;
 $sys{'year'}=$year;
 $sys{'date_and_time'} = "$mday\.$mon\.$year, $hour:$min $sec s";
 $sys{'date'} = "$mday\.$mon\.$year";
 $sys{'date_us'}= "$mon\.$mday\.$year";
 $sys{'date_all'}="$year\.$mon\.$mday\.$hour\.$min\.$sec";
}



############# dow of today
sub getdow {
#day of week (tt.mm.jjjj)
 my $day="$mday.$mon.$year";

 my @day = ("sun","mon","tue","wed","thu","fri","sat");
 my @d = (0,3,2,5,0,3,5,1,4,6,2,4);
 my @tmp;
 @tmp=split(/\./,$day);
 my $t=$tmp[0];
 my $m=$tmp[1];
 my $j=$tmp[2];
 if ($j < 100) { $j =2000+$j; }
 if ($m < 3) { $j-- ; }
 $tmp[3] = $day[($j+int($j/4)-int($j/100)+int($j/400)+$d[$m-1]+$t) % 7];
 return ($tmp[3]);
}





sub date2valid {
##############
 # parameter: datum ("tt.mm.jjjj")
 # return datum oder -1
 my @tmp1=split(/\./,$_[0]);
 my $t=$tmp1[0];
 my $m=$tmp1[1];
 my $j=$tmp1[2];

 if (($j >= 100) && ($j < 1900)) { return (0); }
 if ($j eq "") { $j=$sys{'year'}; }
 if ($j < 100) { $j =2000+$j; }


 if (($m > 12) || ($m < 1)) { return (0); }
 if (($t > 31) || ($t < 1) ) { return (0); }

  # if ($j eq "2099") {   &mess("$t.$m.$j"); }

 my $tmp3=&schaltjahr($j);
 $tmp3=$tmp3+28;
 if (($m == 2) && ($t > $tmp3) ) { return (0); }
 if ($m < 10) { $m=~s/^0+//;  $m="0$m"; }
 if ($t < 10) { $t=~s/^0+//; $t="0$t"; }



 return("$t\.$m\.$j");
}


#############
sub date2dow {
#day of week (tt.mm.jjjj)
 if (!(&date2valid($_[0]))) { return("--"); }
 my @day = ("So","Mo","Di","Mi","Do","Fr","Sa");
 my @d = (0,3,2,5,0,3,5,1,4,6,2,4);
 my @tmp;
 @tmp=split(/\./,$_[0]);
 my $t=$tmp[0];
 my $m=$tmp[1];
 my $j=$tmp[2];
 if ($j < 100) { $j =2000+$j; }
 if ($m < 3) { $j-- ; }
 $tmp[3] = $day[($j+int($j/4)-int($j/100)+int($j/400)+$d[$m-1]+$t) % 7];
 return ($tmp[3]);
}


sub schaltjahr {
##############
# (jahr)  ja = 1, nein = 0
 if ($_[0] < 100) { $_[0] =2000+$_[0]; }
 if (!($_[0] % 4)) {                        # schaltjahr 4 teilbar > ja aber
        if (!($_[0] % 100)) {                 # 100 teilbar >  nein aber
                if (!($_[0] % 400)) {         # 400 teilbar >  doch ja
                           return ("1");
                } else {
                           return ("0");
                }
        } else {
           return ("1");
        }
 } else {
        return ("0");
 }
}



sub date2doy {        #day of year -  konvertiert datum in eine zahl von tagen seit 1.1.des Jahres;
##############
 # parameter: datum ("tt.mm.jjjj")
 my $x=&date2valid($_[0]);
 if (!($x)) {  return("-1"); }
 my @tmp1=split(/\./,$x);
 my $t=$tmp1[0];
 my $m=$tmp1[1];
 my $j=$tmp1[2];
 my $tmp3=&schaltjahr($j);
 $tmp3=$tmp3+28;
 my @md = (31,$tmp3,31,30,31,30,31,31,30,31,30,31);
 my $days=0;
 my $n;
 for ($n=0;$n<$m-1;$n++) {
        $days=$days+$md[$n];         # monate
 }
 $days=$days+$t;
 return($days)
}


##############  konvertiert datum in eine zahl von tagen seit 1.1.1900;
sub date2dop {
############## day of period
 # parameter: datum ("tt.mm.jjjj")
 my $x=&date2valid($_[0]);
 if (!($x)) {  return("-1"); }
 my @tmp1=split(/\./,$x);
 my $t=$tmp1[0];
 my $m=$tmp1[1];
 my $j=$tmp1[2];
 if ($j < 1900) {  return("-1"); }
 my $days=0;
 my $n;
 for ($n=1900;$n<$j;$n++) {
        $x=&schaltjahr($n);
        $days=$days+365+$x;         # jahre
 }
 $x=&date2doy($_[0]);
 $days=$days+$x;
 return($days)
}

sub date2diff {        #day of period -  Datumsdifferenz in Tagen;
##############
 # parameter: datum ("tt.mm.jjjj","tt.mm.jjjj")
 my $x=&date2valid($_[0]);
 if (!($x)) {  return("d1error"); }
 my $y=&date2valid($_[1]);
 if (!($y)) {  return("d2error"); }
 my $d=&date2dop($y)-&date2dop($x);
 return($d);
}

sub date2add {        #  Datum in n Tagen;
##############
 # parameter: datum ("tt.mm.jjjj","n")
 my $x=&date2valid($_[0]);
 if (!($x)) {  return("-1"); }
 if (!(($_[1] >= 0) && ($_[1] < 300000))) {  return("-1"); }
 my @tmp1=split(/\./,$x);
 my $t=$tmp1[0];
 my $m=$tmp1[1];
 my $j=$tmp1[2];
 my @md = (31,(&schaltjahr($j)+28),31,30,31,30,31,31,30,31,30,31);
 my $n;
 for ($n=0;$n<$_[1];$n++) {
        $t++;
        if ($t > $md[($m-1)]) {
                $t =1;
                $m++;
        }
        if ($m eq "13") {
                $t =1;
                $m =1;
                $j++;
                 @md = (31,(&schaltjahr($j)+28),31,30,31,30,31,31,30,31,30,31);
        }
 }
 return(&date2valid("$t.$m.$j"));
}

sub date2sub {        #  Datum vor n Tagen;
##############
 # parameter: datum ("tt.mm.jjjj","n")
 my $x=&date2valid($_[0]);

 if (!($x)) {  return("-1"); }
 if (!(($_[1] >= 0) && ($_[1] < 300000))) {  return("-1"); }
 my @tmp1=split(/\./,$x);
 my $t=$tmp1[0];
 my $m=$tmp1[1];
 my $j=$tmp1[2];
 my @md = (31,(&schaltjahr($j)+28),31,30,31,30,31,31,30,31,30,31);
 my $n;
 for ($n=0;$n<$_[1];$n++) {
        $t--;
        if ($t==0) {
                $m--;
                if ($m==0) {
                        $m =12;
                        $j--;
                }
                $t=$md[($m-1)];
        }

 }
# return("$t.$m.$j");
 return(&date2valid("$t.$m.$j"));
}

sub date2ger {        #parameter jjjj.mm.tt xxx>> tt.mm.jjjj xxx (z.b. 01.12.2000 18:30 Uhr)
############
my $j;
my $m;
my $t;
my $opt=$_[0]; $opt=~s/^\d\d\d\d\.\d*\.\d*//;
my $date=$_[0]; $date=~s/ .*//;
my @werte=split(/\./,$date);
$j=$werte[0]; $m=$werte[1]; $t=$werte[2];
if (($t>0) && ($m>0) && ($j>1900)) { return ("$t.$m.$j$opt"); } else { return($_[0]); }
}

sub date2us {        #parameter  tt.mm.jjjj xxx >> jjjj.mm.tt xxx
#############
my $j;
my $m;
my $t;

my $opt=$_[0]; $opt=~s/\d*.\d*.\d\d\d\d//;
my $date=$_[0]; $date=~s/ .*//;
my @werte=split(/\./,$date);
$j=$werte[2]; $m=$werte[1]; $t=$werte[0];
if (($t>0) && ($m>0) && ($j>1900)) { return ("$j.$m.$t$opt"); } else { return($_[0]); }
}









#sonstige funktionen
####################

sub SendSendmail {
 #&SendSendmail("$mailapp","from","to","subject","message");
 return; #disabled

 if (!(defined $_[0])){ $_[0]=""; }
 if (!(defined $_[1])){ $_[1]=""; }
 if (!(defined $_[2])){ $_[2]=""; }
 if (!(defined $_[3])){ $_[3]=""; }
 if (!(defined $_[4])){ $_[4]=""; }

 if (($_[0] eq "") || ($_[1] eq "") || ($_[2] eq "") || ($_[3] eq "") || ($_[4] eq "")) { return ("-1"); }
 if (-f $_[0]) {
  open (MAIL,"|$_[0] -t") || (return ("-2"));
  print MAIL "To: $_[2]\n";                        #webmaster
  print MAIL "From: $_[1]\n";
  print MAIL "Subject: $_[3]\n\n";
  #print MAIL "Message:\n\n";
  print MAIL "$_[4]\n\n";
  close (MAIL);
   return ("1");
 } else {
   return ("-3");
 }
}

sub mess {
       # print "Content-type: text/html\n\n";
        print"$_[0]";
        exit;
}

sub error {
       # print "Content-type: text/html\n\n";
        print"$_[0]";
        exit;
}


############
sub read_dir { # &read_dir("dir","arrayname","Muster","Zeilennr")
############ directory lesen ergebnis in array "arrayname" (files+directories!!) oder Muster=/
 my @par = @_;
 my $tmp;
 if ($par[2] eq "") { $par[2]="\.\*"; } #beliebig

 my $file;
 my @liste;
 #$par[0]=&name2file($par[0]);
 local (*F);
 if ($par[0] eq "") { &CgiDie("(lib-561 read_dir: $par[2]) Programmfehler: Es wurde kein Verzeichnis angegeben (ref $_[3])"); }
 if ($par[1] eq "") { &CgiDie("(lib-562 read_dir: $par[2]) Programmfehler: Es wurde kein Array angegeben (ref $_[3])"); }
 if (!(-d $par[0])) { return; &CgiDie("(lib-1356 read_dir: $par[0]) Programmfehler: Kein Directory (ref $_[3])"); }

 opendir(F, $par[0]) || &CgiDie("(lib-564 read_dir: $par[2]) Programmfehler: Verzeichnis $par[0] gesperrt");
 while(defined($file=readdir F)) {
        next if (($file =~/^\.$/) || ($file =~/^\.\.$/));
        $tmp="$par[0]\/$file"; if (-d $tmp) { $file="$file\/"; }        # $file/ falls directory
        if ($par[2]=~/\./) {        #.xxx
                if ($file=~/$par[2]$/) {  push (@{$par[1]},$file); }
        } else {
                if ($file=~/$par[2]/) {  push (@{$par[1]},$file); }
        }
 }
 closedir(F);
 return;
}


# Perl Routines to Manipulate CGI input                                         erw. g.alka 15.1.2000
# cgi-lib@pobox.com
# $Id: cgi-lib.pl,v 2.17 1998/05/14 22:39:23 brenner Exp $
#
# Copyright (c) 1993-1998 Steven E. Brenner
# Unpublished work.
# Permission granted to use and modify this library so long as the
# copyright above is maintained, modifications are documented, and
# credit is given for any use of the library.
#
# Thanks are due to many people for reporting bugs and suggestions

# For more information, see:
#     http://cgi-lib.stanford.edu/cgi-lib/

sub pre {
$cgi_lib::version = sprintf("%d.%02d", q$Revision: 2.17 $ =~ /(\d+)\.(\d+)/);


# Parameters affecting cgi-lib behavior
# User-configurable parameters affecting file upload.
$cgi_lib::maxdata    = 131072;    # maximum bytes to accept via POST - 2^17
$cgi_lib::writefiles = "/0";        # directory to which to write files, or
                                                                 # 0 if files should not be written
$cgi_lib::filepre    = "up"."$ENV{'REMOTE_HOST'}"; # Prefix of file names, in directory above

# Do not change the following parameters unless you have special reasons
$cgi_lib::bufsize  =  8192;    # default buffer size when reading multipart
$cgi_lib::maxbound =   100;    # maximum boundary length to be encounterd
$cgi_lib::headerout =    0;    # indicates whether the header has been printed
}

# ReadParse
# Reads in GET or POST data, converts it to unescaped text, and puts
# key/value pairs in %in, using "\0" to separate multiple selections

# Returns >0 if there was input, 0 if there was no input
# undef indicates some failure.

# Now that cgi scripts can be put in the normal file space, it is useful
# to combine both the form and the script in one place.  If no parameters
# are given (i.e., ReadParse returns FALSE), then a form could be output.

# If a reference to a hash is given, then the data will be stored in that
# hash, but the data from $in and @in will become inaccessable.
# If a variable-glob (e.g., *cgi_input) is the first parameter to ReadParse,
# information is stored there, rather than in $in, @in, and %in.
# Second, third, and fourth parameters fill associative arrays analagous to
# %in with data relevant to file uploads.

# If no method is given, the script will process both command-line arguments
# of the form: name=value and any text that is in $ENV{'QUERY_STRING'}
# This is intended to aid debugging and may be changed in future releases

sub ReadParse {
  &pre;
  local (*in) = shift if @_;    # CGI input
  local (*incfn,                # Client's filename (may not be provided)
         *inct,                 # Client's content-type (may not be provided)
         *insfn) = @_;          # Server's filename (for spooled files)
  local ($len, $type, $meth, $errflag, $cmdflag, $perlwarn, $got, $name);

  # Disable warnings as this code deliberately uses local and environment
  # variables which are preset to undef (i.e., not explicitly initialized)
  $perlwarn = $^W;
  $^W = 0;

  binmode(STDIN);   # we need these for DOS-based systems
  binmode(STDOUT);  # and they shouldn't hurt anything else
  binmode(STDERR);

  # Get several useful env variables
  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};

  if ($len > $cgi_lib::maxdata) { #'
      &CgiDie("cgi-lib.pl: Request to receive too much data: $len bytes\n");
  }

  if (!defined $meth || $meth eq '' || $meth eq 'GET' ||
      $meth eq 'HEAD' ||
      $type eq 'application/x-www-form-urlencoded') {
    local ($key, $val, $i);

    # Read in text
    if (!defined $meth || $meth eq '') {
      $in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    } elsif($meth eq 'GET' || $meth eq 'HEAD') {
      $in = $ENV{'QUERY_STRING'};
    } elsif ($meth eq 'POST') {
        if (($got = read(STDIN, $in, $len) != $len))
          {$errflag="Short Read: wanted $len, got $got\n";};
    } else {
      &CgiDie("cgi-lib.pl: Unknown request method: $meth\n");
    }

    @in = split(/[&;]/,$in);
    push(@in, @ARGV) if $cmdflag; # add command-line parameters

    foreach $i (0 .. $#in) {
      # Convert plus to space
      $in[$i] =~ s/\+/ /g;

      # Split into key and value.
      ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }

  } elsif ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    # for efficiency, compile multipart code only if needed
$errflag = !(eval <<'END_MULTIPART');

    local ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    local ($bpos, $lpos, $left, $amt, $fn, $ser);
    local ($bufsize, $maxbound, $writefiles) =
      ($cgi_lib::bufsize, $cgi_lib::maxbound, $cgi_lib::writefiles);


    # The following lines exist solely to eliminate spurious warning messages
    $buf = '';

    ($boundary) = $type =~ /boundary="([^"]+)"/; #";   # find boundary
    ($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
    &CgiDie ("Boundary not provided: probably a bug in your server")
      unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      &CgiDie("Invalid request method for  multipart/form-data: $meth\n");
    }

    if ($writefiles) {
      local($me);
      stat ($writefiles);
      $writefiles = "/tmp" unless  -d _ && -w _;
      # ($me) = $0 =~ m#([^/]*)$#;
      $writefiles .= "/$cgi_lib::filepre";
    }

    # read in the data and split into parts:
    # put headers in @in and data in %in
    # General algorithm:
    #   There are two dividers: the border and the '\r\n\r\n' between
    # header and body.  Iterate between searching for these
    #   Retain a buffer of size(bufsize+maxbound); the latter part is
    # to ensure that dividers don't get lost by wrapping between two bufs
    #   Look for a divider in the current batch.  If not found, then
    # save all of bufsize, move the maxbound extra buffer to the front of
    # the buffer, and read in a new bufsize bytes.  If a divider is found,
    # save everything up to the divider.  Then empty the buffer of everything
    # up to the end of the divider.  Refill buffer to bufsize+maxbound
    #   Note slightly odd organization.  Code before BODY: really goes with
    # code following HEAD:, but is put first to 'pre-fill' buffers.  BODY:
    # is placed before HEAD: because we first need to discard any 'preface,'
    # which would be analagous to a body without a preceeding head.

    $left = $len;
   PART: # find each part of the multi-part while reading data
    while (1) {
      die $@ if $errflag;

      $amt = ($left > $bufsize+$maxbound-length($buf)
              ?  $bufsize+$maxbound-length($buf): $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

      $in{$name} .= "\0" if defined $in{$name};
      $in{$name} .= $fn if $fn;

      $name=~/([-\w]+)/;  # This allows $insfn{$name} to be untainted
      if (defined $1) {
        $insfn{$1} .= "\0" if defined $insfn{$1};
        $insfn{$1} .= $fn if $fn;
      }

     BODY:
      while (($bpos = index($buf, $boundary)) == -1) {
        if ($left == 0 && $buf eq '') {
          foreach $value (values %insfn) {
            unlink(split("\0",$value));
          }
          &CgiDie("cgi-lib.pl: reached end of input while seeking boundary " .
                  "of multipart. Format of CGI input is wrong.\n");
        }
        die $@ if $errflag;
        if ($name) {  # if no $name, then it's the prologue -- discard
          if ($fn) { print FILE substr($buf, 0, $bufsize); }
          else     { $in{$name} .= substr($buf, 0, $bufsize); }
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      if (defined $name) {  # if no $name, then it's the prologue -- discard
        if ($fn) { print FILE substr($buf, 0, $bpos-2); }
        else     { $in {$name} .= substr($buf, 0, $bpos-2); } # kill last \r\n
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 2) eq "--";
      substr($buf, 0, $bpos+$blen+2) = '';
      $amt = ($left > $bufsize+$maxbound-length($buf)
              ? $bufsize+$maxbound-length($buf) : $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;


      undef $head;  undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) {
        if ($left == 0  && $buf eq '') {
          foreach $value (values %insfn) {
            unlink(split("\0",$value));
          }
          &CgiDie("cgi-lib: reached end of input while seeking end of " .
                  "headers. Format of CGI input is wrong.\n$buf");
        }
        die $@ if $errflag;
        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos+2);
      push (@in, $head);
      @heads = split("\r\n", $head);
      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #";
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $incfn{$name} .= (defined $in{$name} ? "\0" : "") .
        (defined $fname ? $fname : "");

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
        $fn = $writefiles . ".$$.$ser";
        open (FILE, ">$fn") || &CgiDie("Couldn't open $fn\n");
        binmode (FILE);  # write files accurately
      }
      substr($buf, 0, $lpos+4) = '';
      undef $fname;
      undef $ctype;
    }

1;
END_MULTIPART
    if ($errflag) {
      local ($errmsg, $value);
      $errmsg = $@ || $errflag;
      foreach $value (values %insfn) {
        unlink(split("\0",$value));
      }
      &CgiDie($errmsg);
    } else {
      # everything's ok.
    }
  } else {
    &CgiDie("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
  }

  # no-ops to avoid warnings
  $insfn = $insfn;
  $incfn = $incfn;
  $inct  = $inct;

  $^W = $perlwarn;

  return ($errflag ? undef :  scalar(@in));
}


# PrintHeader
# Returns the magic line which tells WWW that we're an HTML document

sub PrintHeader {
  return "Content-type: text/html\n\n";
}


# HtmlTop
# Returns the <head> of a document and the beginning of the body
# with the title and a body <h1> header as specified by the parameter

sub HtmlTop
{
  local ($title) = @_;

  return <<END_OF_TEXT;
<html>
<head>
<title>$title</title>
</head>
<body>
<h1>$title</h1>
END_OF_TEXT
}


# HtmlBot
# Returns the </body>, </html> codes for the bottom of every HTML page

sub HtmlBot
{
  return "</body>\n</html>\n";
}


# SplitParam
# Splits a multi-valued parameter into a list of the constituent parameters

sub SplitParam
{
  local ($param) = @_;
  local (@params) = split ("\0", $param);
  return (wantarray ? @params : $params[0]);
}


# MethGet
# Return true if this cgi call was using the GET request, false otherwise

sub MethGet {
  return (defined $ENV{'REQUEST_METHOD'} && $ENV{'REQUEST_METHOD'} eq "GET");
}


# MethPost
# Return true if this cgi call was using the POST request, false otherwise

sub MethPost {
  return (defined $ENV{'REQUEST_METHOD'} && $ENV{'REQUEST_METHOD'} eq "POST");
}


# MyBaseUrl
# Returns the base URL to the script (i.e., no extra path or query string)
sub MyBaseUrl {
  local ($ret, $perlwarn);
  $perlwarn = $^W; $^W = 0;
  $ret = 'http://' . $ENV{'SERVER_NAME'} .
         ($ENV{'SERVER_PORT'} != 80 ? ":$ENV{'SERVER_PORT'}" : '') .
         $ENV{'SCRIPT_NAME'};
  $^W = $perlwarn;
  return $ret;
}


# MyFullUrl
# Returns the full URL to the script (i.e., with extra path or query string)
sub MyFullUrl {
  local ($ret, $perlwarn);
  $perlwarn = $^W; $^W = 0;
  $ret = 'http://' . $ENV{'SERVER_NAME'} .
         ($ENV{'SERVER_PORT'} != 80 ? ":$ENV{'SERVER_PORT'}" : '') .
         $ENV{'SCRIPT_NAME'} . $ENV{'PATH_INFO'} .
         (length ($ENV{'QUERY_STRING'}) ? "?$ENV{'QUERY_STRING'}" : '');
  $^W = $perlwarn;
  return $ret;
}


# MyURL
# Returns the base URL to the script (i.e., no extra path or query string)
# This is obsolete and will be removed in later versions
sub MyURL  {
  return &MyBaseUrl;
}


# CgiError
# Prints out an error message which which containes appropriate headers,
# markup, etcetera.
# Parameters:
#  If no parameters, gives a generic error message
#  Otherwise, the first parameter will be the title and the rest will
#  be given as different paragraphs of the body

sub CgiError {
  local (@msg) = @_;
  local ($i,$name);

  if (!@msg) {
    $name = &MyFullUrl;
    @msg = ("Error: script $name encountered fatal error\n");
  };

  if (!$cgi_lib::headerout) { #')
    print &PrintHeader;
    print "<html>\n<head>\n<title>$msg[0]</title>\n</head>\n<body>\n";
  }
  print "<h1>$msg[0]</h1>\n";
  foreach $i (1 .. $#msg) {
    print "<p>$msg[$i]</p>\n";
  }

  $cgi_lib::headerout++;
}


# CgiDie
# Identical to CgiError, but also quits with the passed error message.

sub CgiDie {
  local (@msg) = @_;
  &CgiError (@msg);
  die @msg;
}


# PrintVariables
# Nicely formats variables.  Three calling options:
# A non-null associative array - prints the items in that array
# A type-glob - prints the items in the associated assoc array
# nothing - defaults to use %in
# Typical use: &PrintVariables()

sub PrintVariables {
  local (*in) = @_ if @_ == 1;
  local (%in) = @_ if @_ > 1;
  local ($out, $key, $output);

  $output =  "\n<dl compact>\n";
  foreach $key (sort keys(%in)) {
    foreach (split("\0", $in{$key})) {
      ($out = $_) =~ s/\n/<br>\n/g;
      $output .=  "<dt><b>$key</b>\n <dd>:<i>$out</i>:<br>\n";
    }
  }
  $output .=  "</dl>\n";

  return $output;
}

# PrintEnv
# Nicely formats all environment variables and returns HTML string
sub PrintEnv {
  &PrintVariables(*ENV);
}


# The following lines exist only to avoid warning messages
$cgi_lib::writefiles =  $cgi_lib::writefiles;
$cgi_lib::bufsize    =  $cgi_lib::bufsize ;
$cgi_lib::maxbound   =  $cgi_lib::maxbound;
$cgi_lib::version    =  $cgi_lib::version;
$cgi_lib::filepre    =  $cgi_lib::filepre;

1; #return true


